/* Copyright (c) 2011, FoxTab. (team@foxtab.com)
 * All rights reserved.
 * See License.txt for further details.
 */

var foxTab = {

	WINDOW_CHROME_URL	   : "chrome://foxtab/content/window.xul",
	BIG_THUMBNAIL_SCALE		: 0.5,
	CACHED_SITE_DIR		   : "",
	FOXTAB_DIR			   : "",
	FOXTAB_DIR_NAME        : "foxtab",
	CACHE_SITE_DIR_NAME    : "thumbs",
	TIME_CACHE_DELTA	   : 2000,

	isWindowOpen		   : false,
	isFlashOpen			   : false,

	foxTabWindow		   : null,

	workAroundHeightDelta  : 0,		
	isFirstSizeCalculation : true,
	biggestWindowWidth	   : 0,
	biggestWindowHeight    : 0,
	windowBoxObject        : {},

	loadOnFirefoxStart     : true,
	interval			   : null,
	canvas				   : null,
	gBrowser			   : null,
	container		       : null,
    pref				   : {},

    windowId			   : 0,

	url_list		       : null,
	url_allow_list		   : null,
	url_to_file_name	   : null,
	fileNameCounter 	   : 0,
	quickLaunchKey         : 9,
	staticLaunchKey        : 9,
	isFlashPlayerInstalled : true,
	disableTabSelected     : false,
	disableRecentlyUsedPush : false, 
	mode				   : 4,

	win                    : window,
	tabsList               : null,
	OS                     : "",
	isFoxTabEnabled		   : true,
	isFlashLoaded		   : true,

	VERSION                : "1.4.2",
	FOXTAB_GUID            : "{ef4e370e-d9f0-4e00-b93e-a4f274cfdd5a}",
	WINDOWS				   : "winnt",
	LINUX				   : "linux",
	MAC					   : "darwin",
	firefoxVer             : null,

	CANVAS_INNER           : "canvasInner",
	CANVAS_FLOAT           : "canvasFloat",
	CANVAS_WIN             : "canvasWin",
	canvasType             : "canvasFloat",
 
	LAUNCH_MODE_INTERACTIVE: "interactive",	
	LAUNCH_MODE_QUICK      : "quick",	
	launchMode             : "quick",

	ENABLE_MEM_HANDLING    : true, 
	MEM_CLEAR_TIME         : 20 * 1000, 
	MEM_WRITE_TIME         : 8 * 1000,

	MODE_NEW_TAB           : "newTab",
	MODE_TOP_SITES         : "topSites",
	MODE_TABS              : "tabs",
	MODE_RECENTLY_CLOSED   : "recentlyClosed",
    PAGES_MODE             : "tabs",
	TOP_SITES			   : 'topSites.json',
	MAX_RECENTLY_CLOSED    : 10,
	rcCleanUp              : false,
    DEBUG_MODE             : true,
	FOXTAB_HOME_PAGE_URL   : "chrome://foxtab/content/homepage.html",
	
	init : function() { 

		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var e = wm.getEnumerator(null);
		var bwr = e.getNext();

		if (bwr.foxTabGlobal==null) bwr.foxTabGlobal = {}
		if (bwr.foxTabGlobal.windowId==null)		  bwr.foxTabGlobal.windowId = 0
		if (bwr.foxTabGlobal.mostRecentlyUsedList==null) bwr.foxTabGlobal.mostRecentlyUsedList = new Array();

		bwr.foxTabGlobal.windowId++

		while (e.hasMoreElements()) {
			var w = e.getNext();
			if (w.foxTabGlobal==null) w.foxTabGlobal = {}
			w.foxTabGlobal.windowId       = bwr.foxTabGlobal.windowId
			w.foxTabGlobal.mostRecentlyUsedList = bwr.foxTabGlobal.mostRecentlyUsedList
		}

		foxTab.windowId				= bwr.foxTabGlobal.windowId
		foxTab.mostRecentlyUsedList  = bwr.foxTabGlobal.mostRecentlyUsedList		

		foxTab.url_list		    = new Array();
		foxTab.url_allow_list   = new Array();
		foxTab.url_to_file_name = new Array();

		// Operating system detection
		var cacheInTempdir;
		try{
			// Returns "WINNT" on Windows Vista, XP, 2000, and NT systems;  
			// "Linux" on GNU/Linux; and "Darwin" on Mac OS X.  
			var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
			switch (osString.toLowerCase()) {
					case foxTab.WINDOWS:
						foxTab.OS = foxTab.WINDOWS  // Windows Vista, XP, 2000, and NT systems;  
						cacheInTempdir = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("foxTab.system.windows.cacheInTempdir");
						break;
					case foxTab.LINUX:
						foxTab.OS = foxTab.LINUX  // GNU/Linux
						cacheInTempdir = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("foxTab.system.linux.cacheInTempdir");
						break;
					case foxTab.MAC:
						foxTab.OS = foxTab.MAC 	// MAC OSX/Darwin
						cacheInTempdir = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("foxTab.system.osx.cacheInTempdir");
						break;
					default : foxTab.OS = foxTab.WINDOWS
							  cacheInTempdir = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("foxTab.system.windows.cacheInTempdir");
			}
		}catch(e){
		    foxTab.OS = foxTab.WINDOWS
			cacheInTempdir = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("foxTab.system.windows.cacheInTempdir");
		} 
		foxTab.cacheInTempdir = cacheInTempdir;
		var appDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		appDir.append(foxTab.FOXTAB_DIR_NAME); 
		cacheDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get(cacheInTempdir ? "TmpD" : "ProfD" ,Components.interfaces.nsIFile);
		cacheDir.append(foxTab.FOXTAB_DIR_NAME); 	 
		cacheDir.append(foxTab.CACHE_SITE_DIR_NAME); 
		foxTab.cacheDir = cacheDir;

		switch (foxTab.OS) {
			case foxTab.WINDOWS:
				foxTab.FOXTAB_DIR = appDir.path+"\\";
				foxTab.CACHED_SITE_DIR = cacheDir.path+"\\";
				break;
			case foxTab.LINUX:			
			case foxTab.MAC:
				foxTab.FOXTAB_DIR = appDir.path+"/";
				foxTab.CACHED_SITE_DIR = cacheDir.path+"/";
				break;
		}

		// Run once
		if (bwr.foxTabGlobal.foxTabDirectoryCreated==null) { // first browser window session
			/***************************************************************************************/
			// Flash truested file
			switch (foxTab.OS) {
					case foxTab.WINDOWS:
						var fl = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("AppData", Components.interfaces.nsIFile);
						var fp = fl.path + "\\Macromedia\\Flash Player\\#Security\\FlashPlayerTrust\\foxTabTrusted.txt"
					break;
					case foxTab.LINUX:
						var fl = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("Home", Components.interfaces.nsIFile);
						var fp =  fl.path + "/.macromedia/Flash_Player/#Security/FlashPlayerTrust/foxTabTrusted.txt"
					break;
					case foxTab.MAC:
						var fl=Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ULibDir", Components.interfaces.nsIFile);
						var fp = fl.path + "/Preferences/Macromedia/Flash Player/#Security/FlashPlayerTrust/foxTabTrusted.txt"
					break;
			}
			// save a text file to allow the flash to read local images files
			foxTab.saveTextFile(fp, foxTab.WINDOW_CHROME_URL)

		    try {
				if( !appDir.exists() || !appDir.isDirectory() ) {   // if it doesn't exist, create
				   appDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
				}		  
			} catch (e) {}	

		    try {
				if( !cacheDir.exists() || !cacheDir.isDirectory() ) {   // if it doesn't exist, create
				   cacheDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
				} else {
				   // removes the last session thumbnails
				   cacheDir.remove(true);
				   cacheDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
				}			  
			} catch (e) {}

			/***************************************************************************************/
			bwr.foxTabGlobal.foxTabDirectoryCreated = true;
		}
		
		var e = wm.getEnumerator(null);
		while (e.hasMoreElements()) {
			var w = e.getNext();
			if (w.foxTabGlobal==null) w.foxTabGlobal = {}
			w.foxTabGlobal.foxTabDirectoryCreated       = bwr.foxTabGlobal.foxTabDirectoryCreated
		}

		window.addEventListener("resize" , foxTab.onResize, false);

		window.addEventListener("keyup"  , foxTab.onKeyUp, false);
		window.addEventListener("keydown", foxTab.onKeyDown, false);

		window.addEventListener("unload" , foxTab.onUnLoad, false);
		window.addEventListener("load"   , foxTab.onLoad, false);
		window.addEventListener("flashblockCheckLoad", foxTab.flashBlockEvent, true, true)

		
	/*	var uninstallObserver = {
		  observe: function(subject,topic,data){
			  if ((topic == "em-action-requested") && (data == "item-uninstalled")) {
				  var updateItem = subject.QueryInterface(Components.interfaces.nsIUpdateItem);
				  if (updateItem.id==foxTab.FOXTAB_GUID) {
					foxTab.gBrowser.selectedTab = gBrowser.addTab("http://www.foxtab.com/" + foxTab.VERSION + "/uninstall/");
					observerService.removeObserver(uninstallObserver,"em-action-requested");
				  }
			  }

		  }
		};

		var observerService =
		  Components.classes["@mozilla.org/observer-service;1"]
			.getService(Components.interfaces.nsIObserverService);
		observerService.addObserver(uninstallObserver,"em-action-requested",false);*/

	},
	
	mouseGestures : {

		init : function() {

			this.MOUSE_GESTURE_MIDDLE_DOUBLE_CLICK = true;
			this.MOUSE_GESTURE_LEFT_MIDDLE_PRESSED = foxTab.pref.gestureLeftMiddle;
			this.MOUSE_GESTURE_LEFT_RIGHT_PRESSED  = foxTab.pref.gestureLeftRight;
			this.MOUSE_GESTURE_RIGHT_WHEEL		   = foxTab.pref.gestureRightClickScroll;
			this.MOUSE_GESTURE_CTRL_WHEEL		   = foxTab.pref.gestureCtrlScroll;

			this.isOpenByGesture = false;
			this.isGestureQuickMode = false;

			this.mouseButtonDown = -1;

			if ((this.MOUSE_GESTURE_LEFT_RIGHT_PRESSED) || (this.MOUSE_GESTURE_LEFT_MIDDLE_PRESSED) || (this.MOUSE_GESTURE_RIGHT_WHEEL)) {
				if (this.listenerInitialized==null) {
					window.addEventListener("mousedown", this.onMouseDown, false);
					window.addEventListener("mouseup", this.onMouseUp, false);
					window.addEventListener("click", this.onMouseClick, false);
					this.listenerInitialized = true;
				}
				if ((foxTab.OS==foxTab.MAC) || (foxTab.OS==foxTab.LINUX)) {
					if ((this.MOUSE_GESTURE_LEFT_RIGHT_PRESSED) || (this.MOUSE_GESTURE_RIGHT_WHEEL)) {
						window.addEventListener("contextmenu", this.onLinuxMacContextMenu, true, true);
						this.onLinuxMacContextRegister = true;
					} else {
						if (this.onLinuxMacContextRegister) {
							window.removeEventListener("contextmenu", this.onLinuxMacContextMenu, true, true);
							this.onLinuxMacContextRegister = false
						}
					}
				}
			} else {
				if (this.listenerInitialized!=null) {
					window.removeEventListener("mousedown", this.onMouseDown, false);
					window.removeEventListener("mouseup", this.onMouseUp, false);
					window.removeEventListener("click", this.onMouseClick, false);
					if ((foxTab.OS==foxTab.MAC) || (foxTab.OS==foxTab.LINUX)) {
						if (this.onLinuxMacContextRegister) {
							window.removeEventListener("contextmenu", this.onLinuxMacContextMenu, true, true);
							this.onLinuxMacContextRegister = false
						}
					}
					this.listenerInitialized = null;
				}
			}

			if ((this.MOUSE_GESTURE_RIGHT_WHEEL) || (this.MOUSE_GESTURE_CTRL_WHEEL)) {
				if (this.scrollListenerInitialized==null) {
					window.addEventListener("DOMMouseScroll", this.DOMMouseScroll, false);
					this.scrollListenerInitialized = true;
				}
			} else {
				if (this.scrollListenerInitialized!=null) {
					window.removeEventListener("DOMMouseScroll", this.DOMMouseScroll, false);
					this.scrollListenerInitialized = null;
				}			
			}
		},
		/***************************/
		openByGesture : function(launchMode) {
			foxTab.openFoxTab(launchMode);
			this.isOpenByGesture = true;
			if (launchMode == foxTab.LAUNCH_MODE_QUICK) this.isGestureQuickMode = true;
			 else this.isGestureQuickMode = false;
			this.disableMouseClick = true;
		},
		/***************************/
		closeByGesture : function() {
			if (this.isOpenByGesture) {
				foxTab.foxTabWin.foxTabFlash.execute("","closeAndSelect")
				this.isOpenByGesture = false;
				this.isGestureQuickMode = false;
				this.disableMouseClick = false;
			}
		},
		/***************************/
		DOMMouseScroll : function(e) {
			var t = foxTab.mouseGestures;

			allowWheel = false;
			if (((t.MOUSE_GESTURE_CTRL_WHEEL) && (e.ctrlKey)) ||
				((t.MOUSE_GESTURE_RIGHT_WHEEL) && (t.mouseButtonDown==2))){
				allowWheel = true;
			}
			if (allowWheel) {
				 if (foxTab.isFlashOpen) {

					 if (e.target.id!="foxTabFlash") {
					    var mode = foxTab.pref.mode
					    if (foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK) {
						   if (foxTab.pref.quick_mode!="") mode = foxTab.pref.quick_mode
						}
						if (mode-0 == 6) { 
							foxTab.foxTabWin.onMouseWheel("k", -1 * e.detail, false)
						} else {
							foxTab.foxTabWin.onMouseWheel("k", -1 * e.detail, true)
						}
					 }
				 } else {		
				     var selectedIndex = foxTab.gBrowser.tabContainer.selectedIndex
					 var numTabs		= foxTab.gBrowser.tabContainer.childNodes.length;
					 if (e.detail<0) selectedIndex    = selectedIndex - 1
					   else selectedIndex    = selectedIndex + 1
					 if (selectedIndex>numTabs-1) selectedIndex = (selectedIndex - numTabs)
					   else if (selectedIndex<0) selectedIndex = numTabs + selectedIndex
					 foxTab.selectedIndex = selectedIndex;


					 t.openByGesture(foxTab.LAUNCH_MODE_QUICK);
					 if ((t.MOUSE_GESTURE_CTRL_WHEEL) && (e.ctrlKey)) window.addEventListener("keyup"  , t.onKeyUp, false);
				 }
				 e.stopPropagation();
				 e.preventDefault();
			}
		},
		/***************************/
		onMouseClick : function(e) {
			var t = foxTab.mouseGestures;
			if ((foxTab.isFlashOpen) && (t.isOpenByGesture)) {
				 if (e.target.id!="content") {
					 e.stopPropagation();
					 e.preventDefault();
				 }
				 t.disableMouseClick = false;
			}
		},
		/***************************/
		onMouseDown : function(e) {
			var t = foxTab.mouseGestures;
				
			if (e.target.ownerDocument=="[object XULDocument]") {
				return false;
			}

			if ((e.target.nodeName.toLowerCase()=="embed") || 
				(e.target.nodeName.toLowerCase()=="object")){
				return false;
			}

			var launch = -1;
			if ((t.screenX==null) || (t.screenY==null)) {
				t.screenX = e.screenX;
				t.screenY = e.screenY;
			} else {
				var delta = 15;
				if ((e.screenX>t.screenX-delta) && (e.screenX<t.screenX+delta) && (e.screenY>t.screenY-delta) && (e.screenY<t.screenY+delta)) {
					if ((t.MOUSE_GESTURE_LEFT_MIDDLE_PRESSED) && (((t.mouseButtonDown==0) && (e.button==1)) || ((t.mouseButtonDown==1) && (e.button==0)))) {
						launch = 0;
					} else if ((t.MOUSE_GESTURE_LEFT_RIGHT_PRESSED) && (((t.mouseButtonDown==0) && (e.button==2)) || ((t.mouseButtonDown==2) && (e.button==0)))) {				
						launch = 1;
					}
				}
				t.screenX = e.screenX;
				t.screenY = e.screenY;
			}
			if (launch!=-1) {
				 if (!foxTab.isFlashOpen) {
					 t.screenX = null;
					 t.screenY = null;
					 t.mouseButtonDown = -1;
					 t.openByGesture(foxTab.LAUNCH_MODE_INTERACTIVE);
					 return;
				 }
			}
			t.mouseButtonDown = e.button
		},
		/***************************/
		onMouseUp : function(e) {

			var t = foxTab.mouseGestures;
			if (t.mouseButtonDown!=-1) {
				if ((t.MOUSE_GESTURE_RIGHT_WHEEL) && (t.isGestureQuickMode) && (t.mouseButtonDown==2)) {
					if (foxTab.isFlashOpen) {
						if (e.button==2) t.closeByGesture();
						window.addEventListener("contextmenu", t.onContextMenu, true, true)
					}
				}
				t.mouseButtonDown = -1
			}
			if (!foxTab.isFlashOpen) {
			   if (e.button==2) {
					if ((foxTab.OS==foxTab.MAC) || (foxTab.OS==foxTab.LINUX)) t.displayContextMenu(e);
			   }
			}
		},
		/***************************/
		onContextMenu : function(e) {
			var t = foxTab.mouseGestures;
			if (e.button==2) {
				e.stopPropagation();
				e.preventDefault();
				window.removeEventListener("contextmenu", t.onContextMenu, true, true)
			}
		},
		displayContextMenu : function(e) {

				if (nsContextMenu.prototype.__setTarget==null) nsContextMenu.prototype.__setTarget = nsContextMenu.prototype.setTarget;
				nsContextMenu.prototype._setTargetInternal = nsContextMenu.prototype.__setTarget;
				nsContextMenu.prototype.setTarget = function(aNode, aRangeParent, aRangeOffset) {
					this._setTargetInternal(aNode, aRangeParent,e.rangeOffset);
				};

				var evt = e.originalTarget.ownerDocument.createEvent("MouseEvents");
				evt.initMouseEvent(
					"contextmenu", true, true, e.originalTarget.defaultView, 0,
					e.screenX, e.screenY, e.clientX, e.clientY,
					false, false, false, false, 2, null
				);

				foxTab.mouseGestures.disable = true;
				e.originalTarget.dispatchEvent(evt);
		},
		/***************************/
		onLinuxMacContextMenu : function(e) {
			if (foxTab.mouseGestures.disable!=true) {
				var t = foxTab.mouseGestures;
				if (e.button==2) {

					e.stopPropagation();
					e.preventDefault();
				}
			}
			foxTab.mouseGestures.disable = false;				
		},
		/***************************/
		onKeyUp : function(e) {
			var t = foxTab.mouseGestures;

			if ((t.MOUSE_GESTURE_CTRL_WHEEL) && (t.isGestureQuickMode)){
				if (e.keyCode == e.DOM_VK_CONTROL) {
					if (foxTab.isFlashOpen) {
						t.closeByGesture();
						window.removeEventListener("keyup"  , t.onKeyUp, false);
					}
				}
			}
		}
		/***************************/
	},
	/*
	 *
	 */
	onWindowFocus : function() {
		 if (foxTab.isFlashOpen) {
			 if (foxTab.windowFocusInterval!=null) clearTimeout(foxTab.windowFocusInterval)
			 foxTab.windowFocusInterval = setTimeout(foxTab.closeFoxTab,200)
		 }
	},
	/*
	 *
	 */
	checkVersion : function() {
		try{
			var info = Components.classes["@mozilla.org/xre/app-info;1"] .getService(Components.interfaces.nsIXULAppInfo);  
			if (info.version>="4") {

				Components.utils.import("resource://gre/modules/AddonManager.jsm");
				AddonManager.getAddonByID(foxTab.FOXTAB_GUID, function(addon) {
					var currentVersion = addon.version;
					var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

					var foxTabVersion = ffPreferences.getCharPref("foxTab.version");
					var isFirstRun	  = ffPreferences.getBoolPref("foxTab.isFirstRun");
					if (isFirstRun){
						  ffPreferences.setBoolPref("foxTab.isFirstRun",false);
						  ffPreferences.setCharPref("foxTab.version",currentVersion);
					
						  window.setTimeout(function(){
							   foxTab.gBrowser.selectedTab = gBrowser.addTab("http://www.foxtab.com/" + foxTab.VERSION +"/d/");
						  }, 1500);
						 }	else {
						  if (foxTabVersion!=currentVersion){
								ffPreferences.setCharPref("foxTab.version",currentVersion);
								window.setTimeout(function(){
								   foxTab.gBrowser.selectedTab = gBrowser.addTab("http://www.foxtab.com/" + foxTab.VERSION  +"/u/");
								}, 1500);
						  }				
					}
					return isFirstRun;
				});
				
				// uninstall listener
				var listener = {
				  onUninstalling: function(addon)
				  {
					 if (addon.id == foxTab.FOXTAB_GUID)
					 {
						foxTab.gBrowser.selectedTab = gBrowser.addTab("http://www.foxtab.com/" + foxTab.VERSION + "/uninstall/");
					 }
				  },
				}
				AddonManager.addAddonListener(listener);
			} else {	
						try{
								  var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
														.getService(Components.interfaces.nsIExtensionManager);
								  var currentVersion = gExtensionManager.getItemForID("{ef4e370e-d9f0-4e00-b93e-a4f274cfdd5a}").version;
								
								  var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

								  var foxTabVersion  = ffPreferences.getCharPref("foxTab.version");
								  var isFirstRun	 = ffPreferences.getBoolPref("foxTab.isFirstRun");
							}catch(e){
								//nothing
							} finally {
								  if (isFirstRun){
									  ffPreferences.setBoolPref("foxTab.isFirstRun",false);
									  ffPreferences.setCharPref("foxTab.version",currentVersion);
								
									  window.setTimeout(function(){
									  foxTab.gBrowser.selectedTab = gBrowser.addTab("http://www.foxtab.com/" + foxTab.VERSION +"/d/");
									  }, 1500);
								  }	else {
									  if (foxTabVersion!=currentVersion){
											ffPreferences.setCharPref("foxTab.version",currentVersion);
											window.setTimeout(function(){
											  foxTab.gBrowser.selectedTab = gBrowser.addTab("http://www.foxtab.com/" + foxTab.VERSION  +"/u/");
											}, 1500);
									  }				
								  }
								  return isFirstRun;
							}
			}

		}catch(e){
		    //nothing
		} finally {

		}
		return false;
	},
	/*
	 *
	 */
	openOptions : function() {
		window.openDialog("chrome://foxtab/content/options/options.xul","FoxTabOptions", "chrome, centerscreen, toolbar");
	},
	/*
	 *
	 */
	setPref : function() {
		  var pref = foxTab.pref
		  var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		  
		  pref.siteTitle            = ffPreferences.getBoolPref("foxTab.general.siteTitle");
		  pref.displayFavoriteIcon  = ffPreferences.getBoolPref("foxTab.general.displayFavoriteIcon");
		  pref.closeButton		    = true
		  pref.contextMenu          = ffPreferences.getBoolPref("foxTab.general.contextMenu");
		  pref.addPageContextMenu   = ffPreferences.getBoolPref("foxTab.general.addPageContextMenu");
		  pref.disaplyStatusBarIcon = ffPreferences.getBoolPref("foxTab.general.disaplyStatusBarIcon");
		  pref.tabEffect	        = ffPreferences.getBoolPref("foxTab.general.tabEffect");
		  pref.showNavigationArrows = ffPreferences.getBoolPref("foxTab.general.showNavigationArrows");
		  pref.lowMemAlloc			= ffPreferences.getBoolPref("foxTab.system.lowMemAlloc");
		  pref.flashVer			    = ffPreferences.getCharPref("foxTab.general.flashVer");
		  pref.useJPG			    = ffPreferences.getBoolPref("foxTab.general.useJPG");
		  pref.enableAllTabsButton  = ffPreferences.getBoolPref("foxTab.general.enableAllTabsButton");


		  pref.displayMainFoxTabToolbarButton      = ffPreferences.getBoolPref("foxTab.general.displayMainFoxTabToolbarButton");
		  pref.displayTopSiteToolbarButton	       = ffPreferences.getBoolPref("foxTab.general.displayTopSiteToolbarButton");
		  pref.displayTopSiteAddPageToolbarButton  = ffPreferences.getBoolPref("foxTab.general.displayTopSiteAddPageToolbarButton");
		  pref.displayRecentlyClosedToolbarButton  = ffPreferences.getBoolPref("foxTab.general.displayRecentlyClosedToolbarButton");

 		  pref.openInNewTab				 = ffPreferences.getBoolPref("foxTab.general.openInNewTab"); 
 		  pref.openInNewTabMessage		 = ffPreferences.getBoolPref("foxTab.general.openInNewTabMessage"); 
		//  pref.openInNewTabMessage = true;


 		  pref.enableRecentlyClosedMode	 = true


		  pref.mode			        = ffPreferences.getCharPref("foxTab.mode"); 
		  pref.quick_mode		    = ffPreferences.getCharPref("foxTab.quickMode"); 
		  pref.topSiteMode			= ffPreferences.getCharPref("foxTab.topSiteMode"); 
		  pref.enableSearch			= ffPreferences.getBoolPref("foxTab.enableGoogleSearch"); 
		  pref.showNTHomePageLink	= ffPreferences.getBoolPref("foxTab.general.showNTHomePageLink"); 
		  
		  pref.recentlyClosedMode	= ffPreferences.getCharPref("foxTab.recentlyClosedMode"); 
		  pref.lastPagesMode		= ffPreferences.getCharPref("foxTab.lastPagesMode"); 


		  pref.quick_size		    = ffPreferences.getCharPref("foxTab.view.quickSize");
		  pref.interactive_size	    = ffPreferences.getCharPref("foxTab.view.interactiveSize");

		  pref.carouselSize        = ffPreferences.getCharPref("foxTab.layout.carouselSize");
		  pref.carouselSize        = 13 - (pref.carouselSize-0)
		  pref.numOfColumns        = ffPreferences.getCharPref("foxTab.layout.numOfColumns");
		  pref.numOfThumbnail      = ffPreferences.getCharPref("foxTab.layout.numOfThumbnail");
		  pref.numOfSlides         = ffPreferences.getCharPref("foxTab.layout.numOfSlides");
		  pref.wallType		       = ffPreferences.getCharPref("foxTab.layout.wallType"); 

		  pref.carouselParams      = ffPreferences.getCharPref("foxTab.layout.carouselParams");
		  pref.rowParams		   = ffPreferences.getCharPref("foxTab.layout.rowParams");
		  pref.slidesParams        = ffPreferences.getCharPref("foxTab.layout.slidesParams");
		  pref.pageFlowParams      = ffPreferences.getCharPref("foxTab.layout.pageFlowParams");
		  pref.wallParams          = ffPreferences.getCharPref("foxTab.layout.wallParams");
		  pref.gridParams          = ffPreferences.getCharPref("foxTab.layout.gridParams");

		  pref.hideTabPanels	   = ffPreferences.getBoolPref("foxTab.general.hideTabPanels");
		  pref.showFirstLaunchHint = ffPreferences.getBoolPref("foxTab.general.showFirstLaunchHint"); 
		 

		  foxTab.quickFullScreenWorkaround = false;
		  foxTab.interactiveFullScreenWorkaround = false;

		  if ((pref.quick_size=="fullScreen") || (pref.interactive_size=="fullScreen")){
			var info = Components.classes["@mozilla.org/xre/app-info;1"] .getService(Components.interfaces.nsIXULAppInfo);  
			if (info.version>="3.6") {
				if (pref.quick_size=="fullScreen") {
					pref.quick_size = "fitToBrowser"
					foxTab.quickFullScreenWorkaround = true;
				}
				if (pref.interactive_size=="fullScreen") {
					pref.interactive_size = "fitToBrowser"
					foxTab.interactiveFullScreenWorkaround = true;
				}
			} else {
				foxTab.canvasType = foxTab.CANVAS_WIN
				foxTab.overrideCloseWindow();
			}
		  }

		  if (ffPreferences.getCharPref("foxTab.general.orientation")=="orientationPortrait") {
			  pref.portrait = true
		  } else {
			  pref.portrait = false
		  }

		  pref.multipleWindows         = ffPreferences.getBoolPref("foxTab.general.multipleWindows");
		  pref.closeFoxTabOnTabChange  = true;
		  pref.hideDuplicateTabs       = ffPreferences.getBoolPref("foxTab.general.hideDuplicateTabs");
		  pref.mostRecentlyUsed		   = ffPreferences.getBoolPref("foxTab.general.mostRecentlyUsed");
		  pref.previewBy 	           = ffPreferences.getCharPref("foxTab.general.thumbnailsPreviewBy")
		  pref.thumbnailPreviewByImage = ffPreferences.getBoolPref("foxTab.general.thumbnailByImage")
		  pref.speed		           = ffPreferences.getCharPref("foxTab.visual.animationSpeed");
		  pref.animateLayoutSelection		= ffPreferences.getBoolPref("foxTab.visual.animateLayoutSelection"); 
		  pref.displayPanel					= ffPreferences.getBoolPref("foxTab.visual.displayPanel"); 
		  pref.displayThumbnailsReflection	= ffPreferences.getBoolPref("foxTab.visual.displayThumbnailsReflection"); 
		  pref.hideTheTabBar				= ffPreferences.getBoolPref("foxTab.visual.hideTheTabBar"); 


		  pref.keyboardQuick_defaultEnabled = ffPreferences.getBoolPref("foxTab.keyboard.quick.enableDefault");
		  pref.keyboardQuick_customEnabled  = ffPreferences.getBoolPref("foxTab.keyboard.quick.enableCustom");
		  pref.keyboardQuick_customKey	    = ffPreferences.getCharPref("foxTab.keyboard.quick.customKey");
		  pref.keyboardQuick_defaultKey     = 9 // DOM_VK_TAB

		  pref.keyboardInteractive_defaultEnabled = ffPreferences.getBoolPref("foxTab.keyboard.interactive.enableDefault");
		  pref.keyboardInteractive_customEnabled  = ffPreferences.getBoolPref("foxTab.keyboard.interactive.enableCustom");
		  pref.keyboardInteractive_customKey	  = ffPreferences.getCharPref("foxTab.keyboard.interactive.customKey");
		  pref.keyboardInteractive_defaultKey     = 123 // DOM_VK_F12
		 
		  if (foxTab.OS==foxTab.MAC) {
		     pref.keyboardInteractive_defaultKey     = 119 // DOM_VK_F8
		  }

		  if ((pref.keyboardQuick_customKey!="") && (pref.keyboardQuick_customKey!=null)) {
			  pref.keyboardQuick_customKey = pref.keyboardQuick_customKey.toUpperCase().charCodeAt(0)
		  }
		  if ((pref.keyboardInteractive_customKey!="") && (pref.keyboardInteractive_customKey!=null)) {
			  pref.keyboardInteractive_customKey = pref.keyboardInteractive_customKey.toUpperCase().charCodeAt(0)
		  }
		  pref.firstFlipTabInQuickMode = false;

		  pref.suspensionTime        = ffPreferences.getCharPref("foxTab.keyboard.suspensionTime"); 
		  pref.EnableSuspension      = ffPreferences.getBoolPref("foxTab.keyboard.EnableSuspension"); 
		  if (!pref.EnableSuspension) pref.suspensionTime = 0;
		  
		  pref.quick_mode_threshold	= ffPreferences.getCharPref("foxTab.general.quickModeThreshold")-0;
		  pref.enableTabsThreshold      = ffPreferences.getBoolPref("foxTab.general.enableTabsThreshold"); 
		  if (!pref.enableTabsThreshold) pref.quick_mode_threshold = 2;


		  pref.sortGroupByName	  = ffPreferences.getBoolPref("foxTab.group.sortByName");
		  pref.searchByTitle      = ffPreferences.getBoolPref("foxTab.find.byTitle");
		  pref.searchByDomain     = ffPreferences.getBoolPref("foxTab.find.byDomain");
		  pref.searchByUrl        = ffPreferences.getBoolPref("foxTab.find.byURL");
		  pref.groupClearFilter	  = ffPreferences.getBoolPref("foxTab.group.clearFilter");
		  pref.findClearFilter	  = ffPreferences.getBoolPref("foxTab.find.clearFilter");
		  pref.groupOpen		  = ffPreferences.getCharPref("foxTab.group.status")-0;
		  pref.filterOpen		  = ffPreferences.getCharPref("foxTab.find.status")-0;
		  pref.theme		      = ffPreferences.getCharPref("foxTab.theme");	
	
		  pref.customColors		  = ffPreferences.getCharPref("foxTab.theme.customColors");
		  pref.useTheme			  = ffPreferences.getCharPref("foxTab.theme.useTheme");	
		  pref.titleColor	      = ffPreferences.getCharPref("foxTab.theme.titleColor");	
		  pref.displayBgImage	  = ffPreferences.getBoolPref("foxTab.theme.displayBgImage");	
		  
		  pref.themeRC		      = ffPreferences.getCharPref("foxTab.theme.rc");	
		  pref.themeTS		      = ffPreferences.getCharPref("foxTab.theme.ts");	


		  pref.gestureRightClickScroll = ffPreferences.getBoolPref("foxTab.mouseGesture.rightClickScroll");	
	  	  pref.gestureCtrlScroll	   = ffPreferences.getBoolPref("foxTab.mouseGesture.ctrlScroll");	
		  pref.gestureLeftMiddle	   = ffPreferences.getBoolPref("foxTab.mouseGesture.leftMiddle");	
		  pref.gestureLeftRight	       = ffPreferences.getBoolPref("foxTab.mouseGesture.leftRight");	

		  pref.isFirstLaunch	  = ffPreferences.getBoolPref("foxTab.isFirstLaunch");	

		  pref.staticWallRows	  = ffPreferences.getCharPref("foxTab.staticWall.rows");
		  pref.staticWallColumns  = ffPreferences.getCharPref("foxTab.staticWall.columns"); 
		  pref.staticWallSize	  = ffPreferences.getCharPref("foxTab.staticWall.size"); 

		  foxTab.DEBUG_MODE		  = ffPreferences.getBoolPref("foxTab.general.debugMode"); 

		  if (pref.openInNewTab) {
			  setTimeout(function() {
					window.BrowserOpenTab = foxTab.openNewTab;
			  }, 1000);
		  } else {
			if (pref.openInNewTabMessage) {
				window.BrowserOpenTab = foxTab.showNewTabMessage;
			} else {
				window.BrowserOpenTab = foxTab.defaultBrowserOpenTab;
			}
		  }

		  try {
			  var show    = document.getElementById("foxTab_contextMenu");
			  show.hidden = !pref.contextMenu
		  } catch (e) {}	
		  try {
			  var show    = document.getElementById("foxTab_contextMenu_addPage");
			  show.hidden = !pref.addPageContextMenu
		  } catch (e) {}	
			  
		  try {
			  var foxTab_statusbarpanel    = document.getElementById("foxTab_statusbarpanel");
			  foxTab_statusbarpanel.hidden = !pref.disaplyStatusBarIcon
		  } catch (e) {}		  


		  if (pref.keyboardQuick_defaultEnabled) {
			  foxTab.gBrowser.mTabBox.handleCtrlTab = false
		      foxTab.gBrowser.mTabBox.handleCtrlPageUpDown = false
			  try {
				ffPreferences.setBoolPref("browser.ctrlTab.mostRecentlyUsed", false);
			  } catch (e) {}
		  } else {
			  foxTab.gBrowser.mTabBox.handleCtrlTab = true
			 foxTab.gBrowser.mTabBox.handleCtrlPageUpDown = true
		  }

		  gBrowser.mTabContainer.collapsed = pref.hideTheTabBar;
 

		  foxTab.mouseGestures.init();
		  if (pref.enableAllTabsButton) {
			    try {
				/*  var __mAllTabsPopup = foxTab.gBrowser.mTabBox.tabs.mAllTabsPopup;
				  if (__mAllTabsPopup.foxTabRegister==null) {
					  __mAllTabsPopup.addEventListener("popupshowing",function(event) {
								if (pref.enableAllTabsButton) {
									foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE);
									event.stopPropagation();
									event.preventDefault();
								}
					  }, false);
					  __mAllTabsPopup.foxTabRegister = 1;
				  }*/
			    } catch (e) {}
		  }
		 if (document.getElementById("menu_tabview")) {
			document.getElementById("menu_tabview").addEventListener("click",function(event) {
					if (foxTab.isFlashOpen) foxTab.closeFoxTab();
			 }, false);
		 }

	},
	/*
	 *
	 */
	saveTextFile : function(filePath, text) {
		var file = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath( filePath );
		if ( file.exists() == false ) {
			file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
		}
		var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
			.createInstance( Components.interfaces.nsIFileOutputStream );
		outputStream.init( file, 0x04 | 0x08 | 0x20, 420, 0 );
		var output = text

		outputStream.write( output, output.length );
		outputStream.close();
	},
	/*
	 *
	 */
	urlToFileName : function(url_string) {
		url_string = url_string.replace(/\/{1,}/g ,"__")
		url_string = url_string.replace(/:/g ,"~")
		url_string = url_string.replace(/\?/g ,"^")
		url_string = url_string.replace(/&/g ,"_a_")
		url_string = url_string.replace(/\+/g ,"-")
		url_string = url_string.replace(/#/g ,"[]")
		url_string = url_string.replace(/\%/g ,"_[")
		
		if (url_string.length>135) { 
			url_string = url_string.substring(0,135);
		}

		if (foxTab.url_to_file_name[url_string]==null) {
			foxTab.url_to_file_name[url_string] = foxTab.windowId+"_"+foxTab.fileNameCounter
			url_string = foxTab.windowId+"_"+foxTab.fileNameCounter 
			foxTab.fileNameCounter++
		} else {
			url_string = foxTab.url_to_file_name[url_string]
		}
	
		return url_string;
	},
	/*
	 *
	 */
	deleteSite : function(url) {
	    var url_string = foxTab.urlToFileName(new String(url))
	    var file = Components.classes["@mozilla.org/file/local;1"]
							.createInstance(Components.interfaces.nsILocalFile);
		try {
			file.initWithPath(foxTab.CACHED_SITE_DIR + url_string);
			file.remove(false);

			file.initWithPath(foxTab.CACHED_SITE_DIR + url_string + "_S");
			file.remove(false);
		} catch (e) {
		}
	},
	/**
	 *
	 */
	saveCanvas : function(content,canvas, destFile) {
	    var file = Components.classes["@mozilla.org/file/local;1"]
						   .createInstance(Components.interfaces.nsILocalFile);
	    file.initWithPath(destFile);

	    var io = Components.classes["@mozilla.org/network/io-service;1"]
						 .getService(Components.interfaces.nsIIOService);

		try {
			var fileType="image/png";
			if (content.document instanceof ImageDocument)
				fileType="image/jpeg";
			else if (window.screen.width>1280) 
				fileType="image/jpeg";
			else if (foxTab.pref.useJPG) 
				fileType="image/jpeg";			



			var dataURL = io.newURI(canvas.toDataURL(fileType, ""), "UTF8", null);
			var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
								  .createInstance(Components.interfaces.nsIWebBrowserPersist);
			persist.persistFlags = Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
			persist.persistFlags |= Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;

			persist.saveURI(dataURL, null, null, null, null, file);
		} catch(e) {

		}
	},
	/**
	 *
	 */
   saveSite : function(content, url, isScreenShot, dir, fileName) {
        const MODE_BIG=1;
        const MODE_SMALL=0;
        var fileType = "";
        var canvasBig = foxTab.createCanvas(content,foxTab.BIG_THUMBNAIL_SCALE,MODE_BIG);
        if (dir==null) dir = foxTab.CACHED_SITE_DIR;
		if (fileName==null) fileName = foxTab.urlToFileName(new String(url))
			
		foxTab.saveCanvas(content,canvasBig, dir + fileName)
		var canvasSmall = foxTab.scaleCanvas(canvasBig,0.6);
		foxTab.saveCanvas(content,canvasSmall, dir + fileName + "_S")            
		if (foxTab.pref.lowMemAlloc){
			foxTab.resetCanvas(foxTab.canvas);
			foxTab.resetCanvas(foxTab.scaledCanvas);
			foxTab.resetCanvas(foxTab.bufferCanvas);
		}
    },
	resetCanvas : function(canvas){
		canvas.width		= 0;
		canvas.height		= 0;
	},	
    scaleCanvas : function(canvas,scale){
        var canvasW = canvas.width * scale;
        var canvasH = canvas.height * scale;
		
		var scaledCanvas;
		if (foxTab.pref.lowMemAlloc)
			scaledCanvas = foxTab.scaledCanvas;
		else
			scaledCanvas = document.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );
			
        scaledCanvas.style.width  = (canvasW) + "px";
        scaledCanvas.style.height = (canvasH) + "px";
        scaledCanvas.width        = (canvasW);
        scaledCanvas.height        = (canvasH);        
        var ctx = scaledCanvas.getContext("2d");
        ctx.drawImage(canvas,0, 0, canvasW, canvasH);
        return scaledCanvas;
    },
	getThumbnailDimensions: function(scale){
		const MAX_WIDTH=2800;
		var width=Math.floor(screen.width * scale);
		var height;
		if (foxTab.pref.portrait){
			var ratio=5/4;
			if (width>MAX_WIDTH) width = Math.floor(MAX_WIDTH/ratio);
			height = Math.floor(width*ratio);
		}else{
			// A4
			var ratio=Math.sqrt(2);
			if (width>MAX_WIDTH) width = MAX_WIDTH;
			height=Math.floor(width/ratio);
		}
		return {width:width,height:height};
	},
	/**
	 *
	 */
	createCanvas : function(content,scale,mode) {	
		const AREA_USE	    = "pageScrollPosition";
		const AREA_TOP	    = "pageTopArea";
		const AREA_TOP_LEFT = "pageTopLeftCorner";

		const TOPLEFT_PCT=0.66;
		var bgColor = content.document.bgColor
		if (bgColor=="#000000") {
			try {
				if (content.document.location=="about:blank") bgColor = "#ffffff"
			} catch (e) {}				
		}
		
		if ((bgColor=="") || (bgColor==null)) bgColor = "#ffffff"
		if (foxTab.pref.portrait && mode==0)
			scale*=3/4;



		var area = foxTab.pref.previewBy			
		var p=1;
		if (area == AREA_TOP_LEFT)
			p=TOPLEFT_PCT;
			
		var canvas;
		if (foxTab.pref.lowMemAlloc)
			canvas = foxTab.canvas;
		else
			canvas = document.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );
		
		var thumbDimension = foxTab.getThumbnailDimensions(scale);		
		var canvasW = thumbDimension.width;
		var canvasH = thumbDimension.height;
		
		canvas.style.width  = (canvasW) + "px";
		canvas.style.height = (canvasH) + "px";
		canvas.width		= (canvasW);
		canvas.height		= (canvasH);

		var ctx = canvas.getContext("2d");
		ctx.clearRect(0, 0,canvasW,canvasH);

		var isImageContent=(content.document instanceof ImageDocument);
		if (isImageContent){
            iWidth=content.document.images[0].width;
            iHeight=content.document.images[0].height;
            if (iHeight > iWidth){
                var iRatio = iHeight/iWidth;
                canvasW = canvasH / iRatio;
            }else{
                var iRatio = iWidth/iHeight;
                canvasH = canvasW / iRatio;           
            }
            canvas.style.width  = (canvasW) + "px";
            canvas.style.height = (canvasH) + "px";
            canvas.width        = (canvasW);
            canvas.height        = (canvasH);
                  
            decoderObserver = content.document.imageRequest.decoderObserver;
            ctx.drawImage(decoderObserver,0, 0, canvasW, canvasH);
           
		}else if (mode==0){
			var contentW=content.scrollMaxX + content.innerWidth;
			var contentH=content.scrollMaxY + content.innerHeight;
			
			var _dx = 0;
			var _dy = 0;
			if (area != AREA_TOP_LEFT){
				_dx=Math.floor((contentW - canvasW/scale)/2);
				if (_dx > 0)
					_dx = 0;
			}
			if (area == AREA_USE) 
				if (content.scrollY){
					_dy = Number(content.scrollY);
					var _maxDy = (contentH - canvasH/scale);
					if (_dy > _maxDy && _maxDy > 0)	
						_dy=_maxDy;
				}
			ctx.scale(scale/p,scale/p);
			ctx.drawWindow(content,_dx,_dy,canvasW/scale*p,canvasH/scale*p, bgColor);			
		}else{
			// width and height
			var w=screen.width;
			var h;
			if (foxTab.pref.portrait){
				h = Math.floor(w*5/4);		
			}else{
				// A4
				h = Math.floor(w/Math.sqrt(2));
			}
			// offset
			var contentW=content.scrollMaxX + content.innerWidth;
			var contentH=content.scrollMaxY + content.innerHeight;

			var _dx = 0;
			var _dy = 0;
			if (area != AREA_TOP_LEFT){
				_dx = (contentW - w)/2;
				if (_dx > 0)
					_dx = 0;
			}
			if (area == AREA_USE) 
				if (content.scrollY){
					_dy = Number(content.scrollY);
					var _maxDy = (contentH - h);
					if (_dy > _maxDy && _maxDy > 0)	
					_dy=_maxDy;
				}
			// buffer
			var bufferCanvas;
			if (foxTab.pref.lowMemAlloc)
				bufferCanvas = foxTab.bufferCanvas;
			else
				bufferCanvas = document.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );
			bufferCanvas.style.width  	= w + "px";
			bufferCanvas.style.height 	= h + "px";
			bufferCanvas.width			= w;
			bufferCanvas.height			= h;
			var bufferCtx = bufferCanvas.getContext("2d");


			bufferCtx.clearRect(0, 0,w,h);
			// Draw background
			bufferCtx.fillStyle = bgColor;
			bufferCtx.fillRect(0, 0, w, h);
			bufferCtx.drawWindow(content,_dx,_dy, w, h, bgColor);

			ctx.drawImage(bufferCanvas, 0, 0, w, h, 0, 0, canvasW/p, canvasH/p);
		}
		return canvas;
	},
	/*
	 *
	 */
	saveTabByBrowser : function(browser, updateImage) {
		try {
			var url = browser.currentURI.spec
			foxTab.saveSite(browser.contentWindow, url)

			if (updateImage!=false) {
				foxTab.updateFoxTabImage(browser, url);
			}
		} catch (e) {
			
		}
	},
	/*
	 *
	 */
	updateFoxTabImage : function(browser, url) {
		if (foxTab.pref.multipleWindows) {
			  var foxTabList = foxTab.getAllFoxTabObjects();
		}else{
			  var foxTabList = new Array(foxTab);
		}
		var f = null
		var index = null;
		for(var j=0; j<foxTabList.length; j++) {
			f = foxTabList[j]
			if ((f.isFlashOpen) && (f.isTabsPagesMode())) {
				for(var i=0; i<f.tabsList.length; i++) {
					if (f.tabsList[i].tabBrowser==browser) {
						index = f.tabsList[i].windowIndex;
						break;
					}
				}
				setTimeout(f.foxTabWin.updateImage, 1000, foxTab.windowId, index, foxTab.urlToFileName(new String(url)))
			}
		}
	},
	/*
	 *
	 */
	saveTabByDocument : function(doc) {
		var browser = foxTab.gBrowser.getBrowserForDocument(doc);
	
		if (browser!=null) {
			foxTab.saveTabByBrowser(browser);
		}
		return false;
	},
	/*
	 *
	 */
	onDocumentScroll : function(e) {
		var doc = e.originalTarget;
		var loc = doc.location;
		
		if (doc.interval==null) {
			
		} else {
			clearTimeout(doc.interval);
		}
		doc.interval = setTimeout(foxTab.saveTabByDocument, 4763, doc);
	},
	/*
	 *
	 */
	remotePageLoaded : function(url) {

		var numTabs = foxTab.gBrowser.tabContainer.childNodes.length;
		for(var index=0; index<numTabs; index++) {
			var currentBrowser = foxTab.gBrowser.getBrowserAtIndex(index);
			var url = currentBrowser.currentURI.spec

			if (foxTab.url_allow_list[url]!=null) {
	
				if (currentBrowser.lastURL==null) currentBrowser.lastURL = url

				if ((currentBrowser.isCached==null) || (currentBrowser.lastURL!=url)){
					foxTab.saveSite(currentBrowser.contentWindow, url)
					foxTab.updateFoxTabImage(currentBrowser, url);
					currentBrowser.isCached = true
					if (foxTab.url_list[url]==null) foxTab.url_list[url] = 0
					foxTab.url_list[url]++
					if (currentBrowser.topSiteAdded == false) {
						var z = setTimeout(function(b) {
							foxTab.addBrowserToTopSites(b);
							clearTimeout(z);
						}, 1000, currentBrowser);
					}
				}
				var lastURL = currentBrowser.lastURL
				if (lastURL!=url) {
					if (foxTab.url_list[lastURL]==null) {
						foxTab.url_list[lastURL] = 0
					} else {
						var url_counter =  foxTab.url_list[lastURL]	
						if (url_counter<2) foxTab.deleteSite(lastURL)	
						foxTab.url_list[lastURL]--
						if (url_counter==0) foxTab.url_list[lastURL] = null
					}
				}
				currentBrowser.lastURL=url
			}
			
		}
	},
	/*
	 *
	 */
	onMainButtonPressed : function(e) {
				
		var allow = true
		if (e!=null) {
			if (e.button != 0) {
				allow = false;
			}
		}
		if (allow) {
			if (!foxTab.isFlashOpen) {
				foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE);
			} else {
				if (foxTab.PAGES_MODE!=foxTab.MODE_NEW_TAB) {
					foxTab.closeFoxTab();
					if (foxTab.pref.openInNewTab) {
						if (gBrowser.selectedBrowser.currentURI.spec=="about:blank") {
								foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE, foxTab.MODE_NEW_TAB);
						}
					}
				} else {
					foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE);
				}
				
			}
		}
	},
	DOMMouseScroll : function(e) {
		if (foxTab.isFlashOpen) {
			 if (e.target.id!="foxTabFlash") {

				var mode = foxTab.pref.mode
				if (foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK) {
				   if (foxTab.pref.quick_mode!="") mode = foxTab.pref.quick_mode
				}
				if (mode-0 == 6) { 
					foxTab.foxTabWin.onMouseWheel("k", -1 * e.detail, false)
				} else {
					foxTab.foxTabWin.onMouseWheel("k", -1 * e.detail, true)
				}

				
				e.stopPropagation();
				e.preventDefault();
			 }
		}
	},
	launch : function() {
		foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE);
	},
	openFoxTab : function(launchMode, pagesMode) {
		if (foxTab.foxTabWindow!=null) {
			var lastMode = foxTab.PAGES_MODE;
			foxTab.launchMode = launchMode
			
			if (pagesMode==null) {
				if (foxTab.launchMode==foxTab.LAUNCH_MODE_INTERACTIVE) {
					if (foxTab.pref.lastPagesMode=="") {
						foxTab.PAGES_MODE = foxTab.MODE_TABS;
						var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
						ffPreferences.setCharPref("foxTab.lastPagesMode", foxTab.MODE_TABS);
						foxTab.pref.lastPagesMode = foxTab.MODE_TABS;
					} else {
						foxTab.PAGES_MODE = foxTab.pref.lastPagesMode;
					}
				} else {
					foxTab.PAGES_MODE = foxTab.MODE_TABS;
				}
			} else {
				foxTab.PAGES_MODE = pagesMode
			}


			var theme = null;
			if ((lastMode==foxTab.MODE_NEW_TAB) && (foxTab.PAGES_MODE!=foxTab.MODE_NEW_TAB)){

				if ((foxTab.OS!=foxTab.MAC) && (foxTab.OS!=foxTab.LINUX)) foxTab.setFoxTabFrame(1, true);

				foxTab.foxTabWin.clearStaticWall();
				switch (foxTab.PAGES_MODE) {
					case foxTab.MODE_TOP_SITES:
						var theme = foxTab.pref.themeTS;
					break;
					case foxTab.MODE_RECENTLY_CLOSED:
						var theme = foxTab.pref.themeRC
					break;
					default:
						var theme = foxTab.pref.theme
				}		
			} else {
				if (foxTab.PAGES_MODE==foxTab.MODE_NEW_TAB) {
					theme = foxTab.pref.themeTS;
				}			
			}

			if (theme!=null) {
				var themeList = theme.split(",");
				foxTab.foxTabWin.foxTabFlash.execute("","setTheme", themeList[0], themeList[1], themeList[2], themeList[3]);
			}


			foxTab.memHandler.end();

			if (foxTab.launchMode==foxTab.LAUNCH_MODE_INTERACTIVE) {
				if (foxTab.pref.interactive_size!="fitToBrowser") {
					if (foxTab.isDOMMouseScrollRegistered!=true) {
						window.addEventListener("DOMMouseScroll", foxTab.DOMMouseScroll, false);
						foxTab.isDOMMouseScrollRegistered = true;
					}
				}
			}




			var pos = foxTab.calcWindowPosition(); 		
			if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
				if (foxTab.frameOffScreenTimeout!=null) {
					foxTab.setFoxTabFrame(1);
				} else {
					if (foxTab.displayFrameTimeout!=null) {
						clearTimeout(foxTab.displayFrameTimeout);
						foxTab.displayFrameTimeout = null;
						foxTab.displayFrame();
					}
				}
				if (foxTab.pref.hideTabPanels){

						if (
							((foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK) && (foxTab.pref.quick_size=="fitToBrowser")) || 
							((foxTab.launchMode==foxTab.LAUNCH_MODE_INTERACTIVE) && (foxTab.pref.interactive_size=="fitToBrowser")) || 
							(foxTab.PAGES_MODE==foxTab.MODE_NEW_TAB) ||
							(((foxTab.OS==foxTab.LINUX) || (foxTab.OS==foxTab.MAC)) && (foxTab.pref.openInNewTab) && (foxTab.isNewTabSupported)) ||
							((foxTab.OS==foxTab.MAC) && (foxTab.isNewTabSupported))
							){
								foxTab.gBrowser.mTabBox.tabpanels.style.visibility = "hidden"	
						} else {
						}
				}
			}

			
			if (foxTab.DEBUG_MODE) foxTab.mainLogger.debug("open: pagesMode = " + foxTab.PAGES_MODE +", launchMode = " + foxTab.launchMode);

			foxTab.moveFrame(foxTab.windowBoxObject.left, foxTab.workAroundHeightDelta);
			foxTab.resizeFrame(foxTab.windowBoxObject.width, foxTab.windowBoxObject.height);

			if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
				foxTab.foxTabWindow.style.display = ''
			}

			if (foxTab.foxTabWin!=null) {
				foxTab.foxTabWin.onResize();
			}

			if (foxTab.loadOnFirefoxStart) {
				if (foxTab.canvasType!=foxTab.CANVAS_WIN) {
					foxTab.foxTabWindow.contentDocument.getElementById("winBox").style.visibility=""
				} else {
					foxTab.foxTabWindow.document.getElementById("winBox").style.visibility=""
				}

				if (foxTab.isFlashPlayerInstalled) {
					foxTab.foxTabWin.setFlashImages();
				}
				foxTab.isFlashOpen = true;
				foxTab.foxTabWin.foxTabFlash.object.style.width  = foxTab.windowBoxObject.width +"px"
				foxTab.foxTabWin.foxTabFlash.object.style.height = foxTab.windowBoxObject.height +"px"	
				
				if (foxTab.OS==foxTab.MAC) {
				} else {
						foxTab.foxTabWindow.focus();
				}
			} else {
			}
		}
	},
	/*
	 *
	 */
	closeFoxTab : function() {

		var f = foxTab
		f.selectedIndex = null;
	

		if (f.loadOnFirefoxStart) {

				if (foxTab.isDOMMouseScrollRegistered==true) {
					window.removeEventListener("DOMMouseScroll", foxTab.DOMMouseScroll, false);
					foxTab.isDOMMouseScrollRegistered = false;
				}			


				if (foxTab.canvasType==foxTab.CANVAS_WIN) {
					if (foxTab.OS==foxTab.LINUX) {
						f.foxTabWindow.resizeTo(1,1);
						if (f.isFlashPlayerInstalled) {
							f.foxTabWindow.foxTabWin.foxTabFlash.execute("","hide_all")
						}
					} else {
						if (f.isFlashPlayerInstalled) {
							f.foxTabWindow.foxTabWin.foxTabFlash.execute("","hide_all")
						}

						if ((f.pref.quick_size=="fitToBrowser") || (f.pref.interactive_size=="fitToBrowser")){
							f.foxTabWindow.resizeTo(1,1);
							f.foxTabWindow.moveTo(0,0);
						} else {
							f.foxTabWindow.resizeTo(1,0);
						}
					}
				} else {
						if (foxTab.gBrowser.mTabBox.tabpanels.style.visibility=="hidden") foxTab.gBrowser.mTabBox.tabpanels.style.visibility=""	

						foxTab.moveFrame(-1000,0);
						if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
							foxTab.resizeFrame(1,1);
						} else {
							foxTab.resizeFrame(1,0);
						}

						if (f.isFlashPlayerInstalled) {
							f.foxTabWin.foxTabFlash.execute("","hide_all")
						}
				}

			f.isQuickLaunch = false;
			f.isFlashOpen = false;
			f.foxTabWin.onFoxTabClosed();
		} else {
			f.foxTabWindow.close();
			f.foxTabWindow = null
			f.isWindowOpen = false;
			f.isFlashOpen = false;
		}
		f.isFlashOpen = false;

		f.memHandler.start();
	},


	memHandler : {

		end : function() {
			var mem = foxTab.memHandler;

			if (mem.refreshWriteTimeOut!=null) clearTimeout(mem.refreshWriteTimeOut);
			if (mem.refreshCleanTimeOut!=null) clearTimeout(mem.refreshCleanTimeOut);
			mem.refreshWriteTimeOut = null;
			mem.refreshCleanTimeOut = null;

			if (mem.isFlashReleased) {
				foxTab.foxTabWin.writeFlash();
				mem.isFlashReleased = false;	
			}
		},
		/*
		 *
		 */
		writeFlash : function() {
			var mem = foxTab.memHandler;
			clearTimeout(mem.refreshWriteTimeOut);
			mem.refreshWriteTimeOut = null;
			if (!foxTab.isFlashOpen) {
				foxTab.foxTabWin.writeFlash();
				mem.isFlashReleased = false;
			}		
		},
		/*
		 *
		 */	
		clearFlash : function () {
			var mem = foxTab.memHandler;
			
			clearTimeout(mem.refreshCleanTimeOut);
			mem.refreshCleanTimeOut = null;
			if (!foxTab.isFlashOpen) {
				if (mem.refreshWriteTimeOut!=null) clearTimeout(mem.refreshWriteTimeOut);
				foxTab.foxTabWin.releaseFlash();
				mem.isFlashReleased = true;
				mem.refreshWriteTimeOut = setTimeout(mem.writeFlash, foxTab.MEM_WRITE_TIME);		
			}
		},
		/*
		 *
		 */	
		start : function () {
			if (foxTab.ENABLE_MEM_HANDLING) {
				if (this.refreshCleanTimeOut!=null) clearTimeout(this.refreshCleanTimeOut);
				this.refreshCleanTimeOut = setTimeout(this.clearFlash, foxTab.MEM_CLEAR_TIME);
			}	
		}

	},
	/*
	 *
	 */
	getInitialWinPosition : function() {
		var pos = foxTab.calcWindowPosition();

		pos.left = 0
		pos.top = 0
		if (foxTab.OS==foxTab.LINUX) {
			pos.width = 2
			pos.height = 2
		} else {
			if (foxTab.canvasType==foxTab.CANVAS_WIN) {
				pos.left = 10000
				pos.top  = 0
				pos.width =  6
				pos.height = 6
			} else {
				pos.width =  1
				pos.height = 1			
			}
		}	
		return pos;
	},
	/*
	 *
	 */
	showWindow : function() {
		var pos = foxTab.getInitialWinPosition();
		
		if (foxTab.canvasType==foxTab.CANVAS_WIN) {
			// Loads only privileged content using "chrome://..."
			foxTab.foxTabWindow = window.open(foxTab.WINDOW_CHROME_URL,"foxTab"+foxTab.windowId, "width="+ pos.width +",height="+ pos.height +",top="+ pos.top +",left="+ pos.left +",titlebar=no, chrome, alwaysRaised=yes,dependent,dialog");
			
			function moveWin(left, top) {
				foxTab.foxTabWindow.moveTo(left, top);
			}			
			var win_timeout = setTimeout(moveWin, 1500, -20, 0)
		
		} else {
			var tabsList = document.getElementById("foxTab_tabs_list")
			tabsList.handleCtrlTab = false
		    tabsList.handleCtrlPageUpDown = false


 			var foxTabIframe = document.getElementById("foxTab_iframe")
			
			if (foxTab.OS==foxTab.MAC) {
				var supportedVersion = false;
				try {
					var info = Components.classes["@mozilla.org/xre/app-info;1"] .getService(Components.interfaces.nsIXULAppInfo);  
					if (info.version>="3.6"){
						supportedVersion = true;
					}
				} catch (e) {}	
				if (supportedVersion) {
					var frameParentNode = foxTabIframe.parentNode;
					foxTabIframe = null;
					foxTabIframe = document.createElement("browser");
					foxTabIframe.setAttribute('id', "foxTab_iframe");
					foxTabIframe.setAttribute('type', "content");
					frameParentNode.appendChild(foxTabIframe);	
				}
			}
			// Loads only privileged content using "chrome://..."
			foxTabIframe.setAttribute("src", foxTab.WINDOW_CHROME_URL);
			foxTab.foxTabWindow = foxTabIframe
			if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
				foxTab.foxTabContainer = document.getElementById("foxTab_iframe_container")
			}
		}
		foxTab.isWindowOpen = true
		if (foxTab.loadOnFirefoxStart) {
			foxTab.isFlashOpen  = false
		} else {
			foxTab.isFlashOpen  = true
		}
	},
	/*
	 *
	 */
	calcWindowPosition : function(forceSize) {
		var f = foxTab

		f.isFirstSizeCalculation = false;

		currentBrowser = f.gBrowser.getBrowserAtIndex(0);

		if (foxTab.canvasType==foxTab.CANVAS_WIN) {
			f.workAroundHeightDelta	  = currentBrowser.boxObject.screenY
			f.windowBoxObject.left    = currentBrowser.boxObject.screenX
			f.windowBoxObject.top     = currentBrowser.boxObject.screenY
		} else {
			f.workAroundHeightDelta	  = currentBrowser.boxObject.y
			f.windowBoxObject.left    = currentBrowser.boxObject.x
			f.windowBoxObject.top     = currentBrowser.boxObject.y
		}
		f.windowBoxObject.width   = currentBrowser.boxObject.width
		f.windowBoxObject.height  = currentBrowser.boxObject.height

		var deltaX = 0
		var deltaY = 0


		if (forceSize!=null) {
			var quick_size = forceSize
			var interactive_size = forceSize
		} else {
			var quick_size = f.pref.quick_size
			var interactive_size = f.pref.interactive_size
		}

		
		if (foxTab.PAGES_MODE==foxTab.MODE_NEW_TAB) {
			interactive_size = "fitToBrowser";
		}

		topDelta = 0;
		if (foxTab.launchMode==foxTab.LAUNCH_MODE_INTERACTIVE) {
			switch (interactive_size) {
					case "small":
							deltaX = f.windowBoxObject.width*3.6/20;
							deltaY = f.windowBoxObject.height*3.6/20;
						break;
					case "medium":
					case "large":
							deltaX = f.windowBoxObject.width*1/20;
							deltaY = f.windowBoxObject.height*1/20;
						break;
					case "fitToBrowser":
							deltaX = 0;
							deltaY = 0;
							if ((foxTab.interactiveFullScreenWorkaround==true) && (foxTab.PAGES_MODE!=foxTab.MODE_NEW_TAB)){
								f.windowBoxObject.left   = 0
								f.windowBoxObject.top    = 0
								f.windowBoxObject.width  = window.screen.width
								f.windowBoxObject.height = window.innerHeight
								f.workAroundHeightDelta  = 0
							}
					break;
					case "fullScreen":
							deltaX = 0;
							deltaY = 0;
							f.windowBoxObject.left   = 0
							f.windowBoxObject.top    = 0
							f.windowBoxObject.width  = window.screen.width
							f.windowBoxObject.height = window.screen.height

							f.workAroundHeightDelta  = 0
							if (foxTab.OS==foxTab.MAC) {
								deltaY += 20;
								f.windowBoxObject.height += 20;
							}
							if (foxTab.OS==foxTab.LINUX) {
								deltaY += 53;
								f.windowBoxObject.height += 53;
							}
					break;
					default: deltaX = 0;
							 deltaY = 0;
			}	

		} else {
			switch (quick_size) {
					case "small":
							if ((f.pref.mode==1) || (f.pref.mode==2)) {
								deltaX = (f.windowBoxObject.width)  * ((1/20) / (0.3));
								deltaY = (f.windowBoxObject.height) * ((1/4)  / (0.83));
								topDelta = deltaY/5;
							} else {
								deltaX = f.windowBoxObject.width*4/20;
								deltaY = f.windowBoxObject.height*4.5/20;
								topDelta = deltaY/5;
							}
						break;
					case "medium":
					case "large":
							if ((f.pref.mode==1) || (f.pref.mode==2)) {
								deltaX = (f.windowBoxObject.width)  * (1/20)
								deltaY = (f.windowBoxObject.height) * (1/4)
								topDelta = deltaY/5;
							} else {
								deltaX = f.windowBoxObject.width*2/20;
								deltaY = f.windowBoxObject.height*2.6/20;
								topDelta = deltaY/5;
							}
					break;
					case "fitToBrowser":
							deltaX = 0;
							deltaY = 0;
							if ((foxTab.quickFullScreenWorkaround==true) && (foxTab.PAGES_MODE!=foxTab.MODE_NEW_TAB)){
								f.windowBoxObject.left   = 0
								f.windowBoxObject.top    = 0
								f.windowBoxObject.width  = window.screen.width
								f.windowBoxObject.height = window.screen.height
								f.workAroundHeightDelta  = 0
							}
					break;
					case "fullScreen":
							deltaX = 0;
							deltaY = 0;
							f.windowBoxObject.left   = 0
							f.windowBoxObject.top    = 0
							f.windowBoxObject.width  = window.screen.width
							f.windowBoxObject.height = window.screen.height

							f.workAroundHeightDelta  = 0
							if (foxTab.OS==foxTab.MAC) {
								deltaY += 20;
								f.windowBoxObject.height += 20;
							}
							if (foxTab.OS==foxTab.LINUX) {
								deltaY += 53;
								f.windowBoxObject.height += 53;
							}
					break;
					default: deltaX = 0;
							 deltaY = 0;
			}	
		}

		f.windowBoxObject.left   += deltaX
		f.windowBoxObject.top    += deltaY - topDelta
		f.windowBoxObject.width  -= deltaX * 2
		f.windowBoxObject.height -= deltaY * 2

		if (foxTab.OS==foxTab.MAC) {
			f.windowBoxObject.left -= 5;
		}

		f.workAroundHeightDelta  += deltaY - topDelta
		return {}
	},

	moveFrame : function(left, top) {
		if (foxTab.canvasType!=foxTab.CANVAS_INNER) {
			if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
				foxTab.foxTabContainer.style.left = left  +"px"
				foxTab.foxTabContainer.style.top  = top +"px"
			} else {
				foxTab.foxTabWindow.moveTo(left, top);
			}
		}
	},

	resizeFrame : function(width, height) {

		if (foxTab.canvasType==foxTab.CANVAS_WIN) {
			foxTab.foxTabWindow.resizeTo(width, height);
		} else {
			foxTab.foxTabWindow.style.width  =  width + "px"
			foxTab.foxTabWindow.style.height =  height + "px"
		}
	},

	/*
	 *
	 */
	resize : function(forceSize) {
	
		if (foxTab.canvasType!=foxTab.CANVAS_INNER) {
			if (foxTab.isWindowOpen) {
				var pos = foxTab.calcWindowPosition(forceSize); 
				if (foxTab.isFlashOpen) {
					foxTab.moveFrame(foxTab.windowBoxObject.left,foxTab.workAroundHeightDelta);
					foxTab.resizeFrame(foxTab.windowBoxObject.width,foxTab.windowBoxObject.height);
					foxTab.foxTabWin.onResize();
				}
			}
		}
	},
	
    ////////////////////////////////////////////////
	onResize : function() {
		foxTab.resize();
	},
	moveFrameOffScreen : function() {
		foxTab.moveFrame(-8000,0);
		if (foxTab.frameOffScreenTimeout!=null) clearTimeout(foxTab.frameOffScreenTimeout);
		foxTab.frameOffScreenTimeout = null;
	},
	displayFrame : function() {
		var tabsList = document.getElementById("foxTab_tabs_list")
		tabsList.selectedIndex = "0"
	},
	setFrameNewTab : function() {
		if (((foxTab.pref.quick_size=="fitToBrowser") && (foxTab.pref.interactive_size=="fitToBrowser")) 
		      || (foxTab.pref.openInNewTab)) return;

		if ((foxTab.OS==foxTab.MAC) && (foxTab.isNewTabSupported==true)) return;
		var tabsList = document.getElementById("foxTab_tabs_list")

		var tabpanel = document.createElement("tabpanel");
		var foxTab_tabpanels_element = document.getElementById("foxTab_tabpanels_element")
		foxTab_tabpanels_element.appendChild(tabpanel);

		tabpanel.appendChild(document.getElementById("foxTab_iframe"));
		foxTab_tabpanels_element.removeChild(foxTab_tabpanels_element.childNodes[0])

		tabsList.selectedIndex = "1"
	},

	setFoxTabFrame : function(time, force) {
		if ((foxTab.OS==foxTab.MAC) && (foxTab.isNewTabSupported==true)) return;

		if (force!=true) {
			if ((foxTab.OS==foxTab.LINUX) || (foxTab.OS==foxTab.MAC)) {
				if (((foxTab.pref.quick_size=="fitToBrowser") && (foxTab.pref.interactive_size=="fitToBrowser")) 
					  || (foxTab.pref.openInNewTab)) return;
			}
			if ((foxTab.pref.hideTabPanels) && (foxTab.isFlashOpen) && (foxTab.launchMode==foxTab.LAUNCH_MODE_INTERACTIVE) && (foxTab.pref.interactive_size=="fitToBrowser")){
					time = null;
			}
		}

		if ((foxTab.OS==foxTab.LINUX) || (foxTab.OS==foxTab.MAC)) { // workaround for Linux and Mac
			if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
				if (time!=null) {
					foxTab.displayFrameTimeout = setTimeout(foxTab.setFrameNewTab, time)
				} else {
					foxTab.setFrameNewTab();
				}
			}
		} else {
			var tabsList = document.getElementById("foxTab_tabs_list")
			tabsList.selectedIndex = "1"
			
			if (time!=null) {
				foxTab.displayFrameTimeout = setTimeout(foxTab.displayFrame, time)
			} else {
				tabsList.selectedIndex = "0"
			}			
		}
	},
	/*
	 *
	 */
	onTabOpen : function() {
		foxTab.setFoxTabFrame();

		if (foxTab.isFlashOpen) foxTab.closeFoxTab();
		foxTab.onResize()
	},
	/*
	 *
	 */
	onTabClosed : function(event, browser) {
		
		  if (event==null) {
		  } else {
			 var browser = event.target.linkedBrowser;
		  }

		  var pos = foxTab.mostRecentlyUsedList.indexOf(browser);
		  if (pos>=0) {
				foxTab.mostRecentlyUsedList.splice(pos, 1);
		  }

		  if (foxTab.gBrowser.selectedBrowser==browser) foxTab.disableTabSelected = true

		  if (foxTab.pref.multipleWindows) {
			  var foxTabList = foxTab.getAllFoxTabObjects();
		  } else {
			  var foxTabList = new Array(foxTab);
		  }
		  for(var j=0; j<foxTabList.length; j++) {
			  var f = foxTabList[j];
			  
			  if ((f.isFlashOpen) && (f.isTabsPagesMode())) {
				 var index = -1
				 var resultTabsList = new Array();
				 for(var i=0; i<f.tabsList.length; i++) {
					if (f.tabsList[i].tabBrowser==browser) {
						f.tabsList[i].visible = false
						index = i;
					}

					if ((f.tabsList[i].visible) && (!f.tabsList[i].groupFilter)) {
						resultTabsList.push(i);
					}
				 }
				 	 f.foxTabWin.foxTabFlash.execute("","filterTabs",resultTabsList.join("^"))
					 if (f.foxTabWin.isGroupPanelOpen) {	
						var groupPanelIndex = f.foxTabWin.lastGroupIndex
						var selectedGroupIndex = 0;
						if ((groupPanelIndex!=0) && (groupPanelIndex!=-1)) {
							if (browser.contentDocument) {
								if (browser.contentDocument.domain) {
									var domainName  = f.foxTabWin.getDomainName(browser.contentDocument.domain)
								} else domainName = "Blank"
							} else domainName = "Blank"
							var domainName  = f.foxTabWin.getDomainName(domainName)
							var index = -1
							for(var i=1; i<f.foxTabWin.groupList.length; i++) {
								if (f.foxTabWin.groupList[i].d==domainName) {
								   index = i;
								   break;
								}
							}
							if (index==groupPanelIndex) {
								if (f.foxTabWin.groupList[index].indices.length==1) {
									selectedGroupIndex = 0;
									f.foxTabWin.clearAllFilter();
								} else {
									selectedGroupIndex = groupPanelIndex;
								}
							}
						}
						f.foxTabWin.setGroupPanel(selectedGroupIndex)
						f.foxTabWin.openGroupPanel(false)
					}
			  }
		  }
		  var url = browser.currentURI.spec;

		  if (f.pref.enableRecentlyClosedMode) {
			  var nsISessionStore = Components.classes["@mozilla.org/browser/sessionstore;1"].getService(Components.interfaces.nsISessionStore);
			  var list = nsISessionStore.getClosedTabData(window)
			  if (list) {

					var json = JSON.parse(list)	
					var totalPages = json.length;
					if (totalPages>foxTab.MAX_RECENTLY_CLOSED) totalPages = foxTab.MAX_RECENTLY_CLOSED;
					for (var i=0;i<totalPages;i++) {
						if (json[i].state) {
							if (json[i].state.entries) {
								var pos   = json[i].state.entries.length-1;
								var entry = json[i].state.entries[pos];
								if (entry.url==url) {
									if (!foxTab.isCacheFileExists('thumbsRCT', url)) {
										var result = foxTab.addUrlToRecentlyClosed(url);
										if (result==false) {
											if (browser!=null) {
												switch (foxTab.OS) {
													case foxTab.WINDOWS:
														var dir = foxTab.getCacheDir('thumbsRCT')+"\\";
														break;
													case foxTab.LINUX:			
													case foxTab.MAC:
														var dir = foxTab.getCacheDir('thumbsRCT')+"/";
														break;
												}
												foxTab.saveSite(browser.contentWindow, url, null, dir, foxTab.getCacheFile(url));
											}										
										}
									}
								}
							}
						}
					}
				
					var isDuplicated = function(url) {
						var z;
						for (z=0;z<savedList.length;z++) {
							if (savedList[z]==url) return true;
						}
						return false;
					}

					var savedList = new Array();
					for (var i=0;i<json.length;i++) {
						if (json[i].state) {
							if (json[i].state.entries) {
								var pos   = json[i].state.entries.length-1;
								var entry = json[i].state.entries[pos];
								if (savedList.length<foxTab.MAX_RECENTLY_CLOSED) {
									if (!isDuplicated(entry.url)) {
										savedList.push(entry.url);
									}
								} else {
									foxTab.removeCacheFile('thumbsRCT', entry.url);
									foxTab.removeCacheFile('thumbsRCT', entry.url, "_S");						
								}
							}
						}
					}

					if (!foxTab.rcCleanUp) {
						foxTab.rcCleanUp = true;
						// go through all the files in RC folder and delete thumbnails that are not in the recently closed list.
						try {
							var rcDirectory = foxTab.getCacheDir('thumbsRCT', true)

							// remove old recently closed tabs images
							var entries = rcDirectory.directoryEntries;
							while(entries.hasMoreElements()) {
							  var entry = entries.getNext();
							  entry.QueryInterface(Components.interfaces.nsIFile);
							  if (!entry.isDirectory()) {
								 if (entry.leafName.indexOf("_S")==-1) {
									var found = false;
									for (var i=0;i<json.length;i++) {		
										if (json[i].state) {
											if (json[i].state.entries) {
												var pos = json[i].state.entries.length-1;
												var en  = json[i].state.entries[pos];
												
												var fileName = foxTab.getCacheFile(en.url);
												if (entry.leafName==fileName) found = true;
											}
										}
									}
									if (!found) {
										var smallThumb = rcDirectory.clone()	
										smallThumb.append(entry.leafName + "_S")
										if (smallThumb.exists()) {
											smallThumb.remove(true); 
											entry.remove(true);
										}
									}
								}
							  }
							}
						} catch(ex){}
					}
			  }	
		  }

		  if (event.target.linkedBrowser.currentURI.spec==foxTab.FOXTAB_HOME_PAGE_URL) {
			  if (foxTab.isFlashOpen) foxTab.closeFoxTab();
		  }	

		  // check if we need to delete the url thumb from the disk
		  if (foxTab.url_list[url]==null) {
				foxTab.url_list[url] = 0
		  } else {
				var url_counter =  foxTab.url_list[url]	
				if (url_counter<2) foxTab.deleteSite(url)	
				foxTab.url_list[url]--
				if (url_counter==0) foxTab.url_list[url] = null
		  } 

		  if ((foxTab.OS!=foxTab.LINUX) && (foxTab.OS!=foxTab.MAC)) foxTab.setFoxTabFrame(1);	
	},
	/*
	 *
	 */
	onTabSelected : function(event) {
		if (foxTab.disableRecentlyUsedPush) {
			foxTab.disableRecentlyUsedPush = false
		} else {
			var browser = event.target.linkedBrowser;	
			var pos = foxTab.mostRecentlyUsedList.indexOf(browser);
			if (pos>=0) {
				foxTab.mostRecentlyUsedList.splice(pos, 1);
			}
			foxTab.mostRecentlyUsedList.push(browser);
		}


		if (foxTab.disableTabSelectedNewTab) {
			foxTab.disableTabSelectedNewTab = false;
		} else {
			var detectAsBlankPage = false;
			if (foxTab.pref.openInNewTab) {
				if ((!event.target.linkedBrowser.webProgress.isLoadingDocument) && (event.target.linkedBrowser.currentURI.spec=="about:blank")) {
					detectAsBlankPage = true;
				}
			}
			if ((!event.target.linkedBrowser.webProgress.isLoadingDocument) && (event.target.linkedBrowser.currentURI.spec==foxTab.FOXTAB_HOME_PAGE_URL)) {
				detectAsBlankPage = true;
				try {
					document.getElementById("urlbar").value = "";
					document.getElementById("urlbar").focus();
				} catch(ex){}
			}		
			if (detectAsBlankPage) {
				if ((!foxTab.isFlashOpen) || (foxTab.PAGES_MODE!=foxTab.MODE_NEW_TAB)) {
					foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE, foxTab.MODE_NEW_TAB);
				}
				foxTab.disableTabSelected = false;
			} else {
				if (foxTab.pref.openInNewTab) {
					if (foxTab.isFlashOpen) foxTab.closeFoxTab();
				}
			
				if (foxTab.disableTabSelected) {
					foxTab.disableTabSelected = false
				} else {
					if ((foxTab.pref.closeFoxTabOnTabChange) && (foxTab.isFlashOpen)) foxTab.closeFoxTab();
				}

				if ((foxTab.OS!=foxTab.LINUX) && (foxTab.OS!=foxTab.MAC)) foxTab.setFoxTabFrame();
			}
		}
	},
	/*
	 *
	 */
	setUrlAsOk : function(url) {
		try {
			foxTab.url_allow_list[url] = true
		} catch(ex){}
	},
	/*
	 *
	 */
	DOMContentLoaded : function(e) {
		if (foxTab.isFlashPlayerInstalled) {

			var doc = e.originalTarget;
			var loc = doc.location;
			if (e.originalTarget instanceof HTMLDocument) {
				var doc = e.originalTarget;
				if (e.originalTarget.defaultView.frameElement) {
					return;
				}
			}	
			if (foxTab.interval!=null) clearTimeout(foxTab.interval);
			
			var url_interval = setTimeout(foxTab.setUrlAsOk, foxTab.TIME_CACHE_DELTA/2 , loc)

			if (foxTab.pref.previewBy=="pageScrollPosition") {
				doc.addEventListener("scroll" , foxTab.onDocumentScroll, false);
			}

			if (doc.interval==null) {
			} else {
				clearTimeout(doc.interval);
			}
			doc.interval = setTimeout(foxTab.saveTabByDocument, 11000, doc);
			doc.intervalLong = setTimeout(foxTab.saveTabByDocument, 40000, doc);
			
			// save tab
			foxTab.interval = setTimeout(function(){foxTab.remotePageLoaded(loc)}, foxTab.TIME_CACHE_DELTA);
		}
		var doc = e.originalTarget;
		if (foxTab.pref.openInNewTab) {
			if ((foxTab.isFlashOpen) && (foxTab.PAGES_MODE==foxTab.MODE_NEW_TAB)){
				var browser = getBrowser().getBrowserForDocument(doc);
				if (foxTab.gBrowser.selectedBrowser==browser) {
					if (doc.location.href!="about:blank") {
						foxTab.closeFoxTab();
					}
				}
			}
		}
		if (loc==foxTab.FOXTAB_HOME_PAGE_URL) {
			if (foxTab.isFlashLoaded) {
				var browser = getBrowser().getBrowserForDocument(doc);
				if (foxTab.gBrowser.selectedBrowser==browser) {
					if (!foxTab.isFlashOpen) {
						foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE, foxTab.MODE_NEW_TAB);
						try {
							document.getElementById("urlbar").value = "";
							document.getElementById("urlbar").focus();
						} catch(ex){}
					}	
				}
			}
			return;
		}
	},
	/*
	 *
	 */
	closeFirstLaunchHintPanel : function() {
		if (foxTab.hintPanelTimeOut!=null) {
			clearTimeout(foxTab.hintPanelTimeOut);
			foxTab.hintPanelTimeOut = null;
			var panel = document.getElementById("foxTab_firstlaunchPanel");
			if (panel.state=="open") panel.hidePopup();
		}
	},
	/*
	 *
	 */
	openFirstLaunchHintPanel : function() {
		var toolbarIcon = document.getElementById("foxTab_toolbarButton");
		var _left, _top;
		try {
			_left = toolbarIcon.boxObject.x
			_top  = toolbarIcon.boxObject.y
		} catch (e) {
			_left = null;
			_top  = null;
		}	
		if ((_left!=null) && (_top!=null)) {
			if (_top<500) {
				var panel = document.getElementById("foxTab_firstlaunchPanel");
				panel.openPopup(toolbarIcon ,"after_end", 75, 0)
				foxTab.hintPanelTimeOut = setTimeout(foxTab.closeFirstLaunchHintPanel,7000);
			}
		}
	},
	/*
	 *
	 */
	onLoad : function(e) {

		try {
			var urlbar = document.getElementById("urlbar");
			if (urlbar!=null) {
				if (urlbar.readOnly) {
					foxTab.isFoxTabEnabled = false
					document.getElementById("foxTab_contextMenu").hidden = true;
					return false;
				}
			}
		} catch (e) {}
		
		if (foxTab.OS==foxTab.MAC) {
			try {
				document.getElementById("foxTab_toolbarButton").style.cursor = "pointer"
			} catch (e) {}	
		}
	    foxTab.defaultBrowserOpenTab = window.BrowserOpenTab
		getBrowser().addEventListener("NewTab", function(e) {
				if (foxTab.pref.openInNewTab) {
						var f = foxTab;
						if (!f.isFlashOpen) {
							f.openFoxTab(f.LAUNCH_MODE_INTERACTIVE, f.MODE_NEW_TAB);
						}
						f.disableTabSelectedNewTab = true;
						f.gBrowser.selectedTab = newTab;
						f.addBrowserListener(f.gBrowser.selectedBrowser);
						document.getElementById("urlbar").focus();
						e.preventDefault();
						e.stopPropagation();
				}
		}, false);


		foxTab.gBrowser  = getBrowser()
		foxTab.container = foxTab.gBrowser.tabContainer;

		var gBrowser     = foxTab.gBrowser
		var container    = foxTab.container

		foxTab.setPref();

		var isToolbarButtonAdded = foxTab.addFoxTabToolbarButton("foxTab_toolbarButton");
		if (foxTab.pref.displayTopSiteAddPageToolbarButton) foxTab.addFoxTabToolbarButton("foxTab_toolbarButton_topSitesAddPage", 0);

		var thumbsMaxDimension = foxTab.getThumbnailDimensions(foxTab.BIG_THUMBNAIL_SCALE);
		foxTab.biggestWindowWidth  = thumbsMaxDimension.width;
		foxTab.biggestWindowHeight = thumbsMaxDimension.height;

		if (foxTab.pref.lowMemAlloc){
			var canvasDoc = document.implementation.createDocument('http://www.w3.org/1999/xhtml', 'html', null);
			foxTab.canvas = canvasDoc.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );
			foxTab.scaledCanvas = canvasDoc.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );			
			foxTab.bufferCanvas = canvasDoc.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );			
		}
		
		container.addEventListener("TabOpen" , foxTab.onTabOpen, false);
		container.addEventListener("TabClose", foxTab.onTabClosed, false);
		container.addEventListener("TabSelect", foxTab.onTabSelected, false);
		window.document.addEventListener("DOMContentLoaded", foxTab.DOMContentLoaded, true)
		window.document.addEventListener("FoxTabEvent", foxTab.foxTabListener, false, true);
		window.document.addEventListener("FoxTabTopSiteEvent", foxTab.topSiteListener, false, true);

		var isFirstRun = foxTab.checkVersion();
		if ((isToolbarButtonAdded) && (isFirstRun) && (foxTab.pref.showFirstLaunchHint)) {
			setTimeout(foxTab.openFirstLaunchHintPanel,700);
		}

		// register logger
		if (foxTab.DEBUG_MODE) {
			try {
				const MODULES_URL = "resource://foxtab/";
				const LoggerFactory = {};
				Components.utils.import(MODULES_URL+"LoggerFactory.jsm",LoggerFactory)

				const FOLDER_EXT = "FoxTab"
				const FOLDER_DATA = "data"
				const FOLDER_LOGS = "logs";		
				const logPath = [FOLDER_EXT,FOLDER_LOGS];
				const envLogger = LoggerFactory.getLogger("env",logPath,"env.txt",1,true);
				const mainLogger = LoggerFactory.getLogger("main",logPath,"main.log",3);  // history of 3 and also dump environment
				const prefsLogger = LoggerFactory.getLogger("pref",logPath,"prefs.log",3);  // history of 3 and also dump environment
				mainLogger.level = mainLogger.DEBUG;
				mainLogger.debug("onLoad");
				prefsLogger.level = mainLogger.DEBUG;
				prefsLogger.writePrefs(Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch));
				foxTab.mainLogger = mainLogger;
			} catch(ex){
				foxTab.DEBUG_MODE = false;
			}
		}

		try {
			var selectedIndex = gBrowser.tabContainer.selectedIndex
			var browser       = gBrowser.getBrowserAtIndex(selectedIndex);
			var pos = foxTab.mostRecentlyUsedList.indexOf(browser);
			if (pos>=0) {
				foxTab.mostRecentlyUsedList.splice(pos, 1);
			}
		} catch (e) {
		}
		
		try {
			var info = Components.classes["@mozilla.org/xre/app-info;1"] .getService(Components.interfaces.nsIXULAppInfo);  
			if ((info.version>="3.6") || (foxTab.OS!=foxTab.MAC)){
				foxTab.isNewTabSupported = true;
			}
		} catch (e) {}	


		if (foxTab.canvasType!=foxTab.CANVAS_WIN) {
			setTimeout(foxTab.launchFoxTabWindow,300);
		} else {
			try {
				var info = Components.classes["@mozilla.org/xre/app-info;1"] .getService(Components.interfaces.nsIXULAppInfo);  
				foxTab.firefoxVer = info.version
				if (info.version>="3.1") { // if firefox version is 3.1 or later
					setTimeout(foxTab.launchFoxTabWindow,1000);
				} else {
					foxTab.launchFoxTabWindow();
				}
			} catch (e) {
				setTimeout(foxTab.launchFoxTabWindow,1000);
			}	
		}

		if (foxTab.pref.openInNewTab) {

			setTimeout(function() {
				if (gBrowser.selectedBrowser.currentURI.spec=="about:blank") {

					if (!gBrowser.selectedBrowser.webProgress.isLoadingDocument) {
						if (!foxTab.isFlashOpen) {
							if (foxTab.foxTabWin==null) {
								setTimeout(function() {
									foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE, foxTab.MODE_NEW_TAB);
								},700);
							} else {
								foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE, foxTab.MODE_NEW_TAB);
							}
						}
					}
				}
				try {
					foxTab.addBrowserListener(foxTab.gBrowser.selectedBrowser);
				} catch(ex){}
			},1000);
		}
	},
	/*
	 *
	 */
	setNewTabDefault : function() {
		window.BrowserOpenTab = foxTab.defaultBrowserOpenTab;
	},
	/*
	 *
	 */
	setFoxTabAsNewTab : function() {
		window.BrowserOpenTab = foxTab.openNewTab;
	},
	/*
	 *
	 */
	showNewTabMessage : function() {
		var f = foxTab;
		var newTab = f.gBrowser.addTab("chrome://foxtab/content/newTabMessage.html");
		f.gBrowser.selectedTab = newTab;
	},

	openNewTab : function() {
		var f = foxTab;
		if (foxTab.DEBUG_MODE) foxTab.mainLogger.debug("openNewTab");
		var newTab = f.gBrowser.addTab("about:blank");
		if (!f.isFlashOpen) {
			f.openFoxTab(f.LAUNCH_MODE_INTERACTIVE, f.MODE_NEW_TAB);
		}
		f.disableTabSelectedNewTab = true;
		f.gBrowser.selectedTab = newTab;
		f.addBrowserListener(f.gBrowser.selectedBrowser);
		document.getElementById("urlbar").focus();
	},
	addBrowserListener : function(browser) {
		var browserListener = 
		{
		  onStatusChange : function(){},
		  onProgressChange : function(){},
		  onLocationChange : function(){},
		  onSecurityChange : function(){},
		  onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus){
			 if (aStateFlags == 983041) {
				  if ((gBrowser.selectedBrowser==browser) && (foxTab.isFlashOpen)) {
						foxTab.closeFoxTab();
						foxTab.removeBrowserListener(browser);
				  }
			}
		  }
		}
		var webProgress = Components.classes["@mozilla.org/appshell/component/browser-status-filter;1"]
										    .createInstance(Components.interfaces.nsIWebProgress);
		webProgress.addProgressListener(browserListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_REQUEST);
		browser.addProgressListener(webProgress, Components.interfaces.nsIWebProgress.NOTIFY_STATE_REQUEST);
		browser.webProgressListener = webProgress;
		
	},
	removeBrowserListener : function(browser) {
		if (browser.webProgressListener) {
			browser.removeProgressListener(browser.webProgressListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_REQUEST);
			browser.webProgressListener = null;
		}
	},
	/*
	 *
	 */
	setPagesMode : function(newMode) {
		foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE, newMode);
	},

	isTabsPagesMode : function() {
		if ((foxTab.PAGES_MODE!=foxTab.MODE_TOP_SITES) && (foxTab.PAGES_MODE!=foxTab.MODE_NEW_TAB) && (foxTab.PAGES_MODE!=foxTab.MODE_RECENTLY_CLOSED)) {
			return true;
		}

		return false;
	},
	/*
	 *
	 */
	onWallImageSaved : function(newMode) {
		try {
			document.getElementById("foxTab_toolbarButton_topSitesAddPage").setAttribute("class", "");
		} catch(ex){}
	},
	/*
	 *
	 */
	addToTopSites : function(newMode) {
		try {
			document.getElementById("foxTab_toolbarButton_topSitesAddPage").setAttribute("class", "loader");
		} catch(ex){}
		foxTab.addBrowserToTopSites(foxTab.gBrowser.selectedBrowser);
	},
	/*
	 *
	 */
	openTopSites : function(newMode) {
		foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE, foxTab.MODE_TOP_SITES);
	},
	/*
	 *
	 */
	openRecentlyClosed : function(newMode) {
		foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE, foxTab.MODE_RECENTLY_CLOSED);
	},
	/*
	 *
	 */
	launchFoxTabWindow : function() {
		if (foxTab.loadOnFirefoxStart) {
			if (!foxTab.isWindowOpen) {
				foxTab.isWindowOpen = true
				foxTab.showWindow();
				setTimeout(foxTab.onResize,2000);
			}
		}	
	},	
	/*
	 *
	 */
	onUnLoad : function() {
		if (foxTab.OS==foxTab.LINUX) {
			foxTab.foxTabWindow.close();
		}
		if (foxTab.OS==foxTab.MAC){
			if (foxTab.isFlashOpen) {
				foxTab.foxTabWindow.close();
			}
		}
		if (foxTab.firefoxVer!=null) {
			if (foxTab.firefoxVer>="3.1") { 
				foxTab.foxTabWindow.close();
			}	
		}		
		var numTabs = foxTab.gBrowser.tabContainer.childNodes.length;
		var currentBrowser, url;
		var foxTabList = foxTab.getAllFoxTabObjects();

		for(var i=0; i<numTabs; i++) {
		   currentBrowser = foxTab.gBrowser.getBrowserAtIndex(i);
		   
		   for (var j=0;j<foxTabList.length;j++) {
				if (foxTabList[j].isFlashOpen) {
					foxTabList[j].onTabClosed(null, currentBrowser)
				}
		   }

		   url = currentBrowser.currentURI.spec;
		   if (foxTab.url_list[url]==null) {
				foxTab.url_list[url] = 0
		   } else {
				var url_counter =  foxTab.url_list[url]	
				if (url_counter<2) foxTab.deleteSite(url)	
				foxTab.url_list[url]--
				if (url_counter==0) foxTab.url_list[url] = null
		   } 
		}
	},
	/*
	 *
	 */
	foxTabListener : function(e) {
		  var domainName = e.target.ownerDocument.domain;
		  // Ignore any events from pages that are not from foxtab.com
		  // This prevent any security risk.
		  if ((domainName=="www.foxtab.com") || (domainName=="foxtab.com")) {
			  foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE);
		  }
		  return null;
	},
	/*
	 *
	 */
	topSiteListener : function(e) {
		  var domainName = e.target.ownerDocument.domain;
		  // Ignore any events from pages that are not from foxtab.com
		  // This prevent any security risk.
		  if ((domainName=="www.foxtab.com") || (domainName=="foxtab.com")) {
			var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			ffPreferences.setBoolPref("foxTab.general.openInNewTab", true);
			ffPreferences.setBoolPref("foxTab.enableGoogleSearch", true);
			foxTab.setPref();
		  }
		  return null;
	},
	/*
	 *
	 */
	getWindowById : function(windowId) {
		  var foxTabList = foxTab.getAllFoxTabObjects();
		  for (var i=0;i<foxTabList.length;i++) {
			  if (foxTabList[i].windowId==windowId) {
			 	return foxTabList[i];
			  }
		  }
		  return null;
	},
	/*
	 *
	 */
	getAllFoxTabObjects : function() {
          var list = new Array();
		  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
		  var e = wm.getEnumerator(null);
		
 		  while (e.hasMoreElements()) {
			var w = e.getNext();
			if (w.foxTab!=null) {
				if (w.foxTab.isFoxTabEnabled) list.push(w.foxTab);
			}
		  }
		  return list;
	},
	/*
	 *
	 */
	onFlashLoaded : function() {
		setTimeout(function() {
			foxTab.isFlashLoaded = true;
			if (foxTab.DEBUG_MODE) foxTab.mainLogger.debug("onFlashLoaded");
			var gBrowser = foxTab.gBrowser;
			if (gBrowser.selectedBrowser.currentURI.spec==foxTab.FOXTAB_HOME_PAGE_URL) {
			
				if (!gBrowser.selectedBrowser.webProgress.isLoadingDocument) {
					if (!foxTab.isFlashOpen) {
						foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE, foxTab.MODE_NEW_TAB);
					}
				}
			}
			try {
				foxTab.addBrowserListener(foxTab.gBrowser.selectedBrowser);
			} catch(ex){}
		}, 300)
	},
	/*
	 *
	 */
	onCallBack : function() {

	},
	/*
	 *
	 */
	clearStaticWall : function() {
		  foxTab.foxTabWin.foxTabFlash.execute("","clearStaticWall")

	},
	/*
	 *
	 */
	getStaticWallImagesString : function() {
		  var f = foxTab;

		  if (f.tabsList!=null) f.tabsList.length = 0;
		  f.tabsList = new Array();

		  var ts = foxTab.getTopSites();
		  var args = "";

		  switch (foxTab.OS) {
			case foxTab.WINDOWS:
				var path = foxTab.FOXTAB_DIR + "\\thumbsTS\\"
				break;
			case foxTab.LINUX:			
			case foxTab.MAC:
				var path = foxTab.FOXTAB_DIR + "/thumbsTS/"
				break;
		  }

		  args += "file://" + path + "_^_"
		  var c = 0;
		  for (var i=0;i<ts.topSites.length;i++) {
			  if (ts.topSites[i]!=null) {
				  f.tabsList.push({
						  index       : c,
						  title       : ts.topSites[c].title,
						  url         : ts.topSites[c].url,
						  thumb       : ts.topSites[c].fileName,
						  visible     : true
				  });
				  c++;
			  }
		  }
		  var tabsStr = "";

		  for(var j=0;j<f.tabsList.length; j++) {
			  tabsStr += f.tabsList[j].thumb+"_^_"
		  }
		  args += tabsStr
		  return args;		
	},
	/*
	 *
	 */
	createStaticWallImage : function() {
		  var f = foxTab;

		  var dir = f.getTopSitesDir();
		  var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	  	  aFile.initWithPath(dir);
		  aFile.append("wall")
		  if(aFile.exists()) {
		     aFile.remove(true);
		  }	
		  aFile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);

		  if (f.tabsList!=null) f.tabsList.length = 0;
		  f.tabsList = new Array();

		  var ts = foxTab.getTopSites();
		  var args = "";
		  switch (foxTab.OS) {
			case foxTab.WINDOWS:
				var path = foxTab.FOXTAB_DIR + "\\thumbsTS\\"
				break;
			case foxTab.LINUX:			
			case foxTab.MAC:
				var path = foxTab.FOXTAB_DIR + "/thumbsTS/"
				break;
		  }

		  args += "file://" + path + "_^_"
		  var c = 0;
		  for (var i=0;i<ts.topSites.length;i++) {
			  if (ts.topSites[i]!=null) {
				  f.tabsList.push({
						  index       : c,
						  title       : ts.topSites[c].title,
						  url         : ts.topSites[c].url,
						  thumb       : ts.topSites[c].fileName,
						  visible     : true
				  });
				  c++;
			  }
		  }
		  var tabsStr = "";

		  for(var j=0;j<f.tabsList.length; j++) {
			  tabsStr += f.tabsList[j].thumb+"_^_"
		  }
		  args += tabsStr
		  var wall = foxTab.getStaticWallSize();

		  foxTab.foxTabWin.foxTabFlash.execute("","createStaticWallImage", args, wall.rows, wall.columns, wall.factor)
	},
	/*
	 *
	 */
	getStaticWallSize : function() {
		  var result = {};
		  var deafultSize = "medium";
		  var size = foxTab.getStaticWallBySize(deafultSize);
		  if ((foxTab.pref.staticWallRows=="") || (foxTab.pref.staticWallColumns=="")){
		      result.rows    = size.rows;
		      result.columns = size.columns;
			  result.size    = deafultSize;
		  } else {
		      result.rows    = foxTab.pref.staticWallRows;
		      result.columns = foxTab.pref.staticWallColumns;
			  result.size    = foxTab.pref.staticWallSize;
		  }
		  result.factor = size.factor;

		  return result;
	},
	/*
	 *
	 */
	getStaticWallBySize : function(size) {

		  var inList = function() {
			  for (var i=0;i<arguments.length;i=i+2) {
				  if ((window.screen.width==arguments[i]) && (window.screen.height==arguments[i+1])) {
					  return true;
				  }
			  }
			  return false;
		  }

		  var result = {};
		  var a = null;
		  if (size=="large") {
			  if (inList(1280,1024)) {
				  a = [3, 2];
			  } else if (inList(1280, 800, 1440, 900, 1680, 1050, 1920, 1200, 1920, 1080)) {
				  a = [3, 2];
			  } else if (inList(800, 600, 1600, 1200)) {
				  a = [4, 2];
			  } else if (inList(1280, 960, 1152, 864)) {
				  a = [3, 2];
			  } else if (inList(1024, 768)) {
				  a = [3, 2];
			  } else {
				  a = [3, 2];
			  }
		  } else if (size=="medium") {

			  if (inList(1280,1024)) {
				  a = [5, 4];
			  } else if (inList(1280, 800, 1440, 900, 1680, 1050, 1920, 1200, 1920, 1080)) {
				  a = [5, 3];
			  } else if (inList(800, 600, 1600, 1200)) {
				  a = [5, 3];
			  } else if (inList(1280, 960, 1152, 864)) {
				  a = [5, 4];
			  } else if (inList(1024, 768)) {
				  a = [5, 3];
			  } else {
				  a = [5, 4];
			  }
		  } else if (size=="small") {
			  if (inList(1280,1024)) {
				  a = [7, 4];
			  } else if (inList(1280, 800, 1440, 900, 1680, 1050, 1920, 1200, 1920, 1080)) {
				  a = [7, 4];
			  } else if (inList(800, 600, 1600, 1200)) {
				  a = [5, 4];
			  } else if (inList(1280, 960, 1152, 864)) {
				  a = [7, 4];
			  } else if (inList(1024, 768)) {
				  a = [6, 4];
			  } else {
				  a = [7, 4];
			  }
		  }

		  if (inList(1280,1024)) {
			  result.factor = 86;
		  } else if (inList(1280,800, 1440, 900, 1680, 1050, 1920, 1200, 1920, 1080)) {
			  result.factor = 70;
		  } else if (inList(800,600, 1600, 1200)) {
			  result.factor = 60;
		  } else if (inList(1280,960, 1152, 864)) {
			  result.factor = 80;
		  } else if (inList(1024, 768)) {
			  result.factor = 65;
		  } else {
			  result.factor = 65;
		  }
		  
		  result.rows    = a[0];
		  result.columns = a[1];
		  return result;
	},
	/*
	 *
	 */
	getTabs : function() {
		  var f = foxTab;

		  switch (foxTab.PAGES_MODE) {

			case foxTab.MODE_NEW_TAB+"":
				  var args = "";
				  var wall = foxTab.getStaticWallSize();

				  if (f.pref.enableSearch) {
					 var searchBoxHeight = 55;
				  } else {
					 var searchBoxHeight = 0;
				  }
				  var prefStr = mode + "|" + tabEffect + "|" + f.pref.numOfSlides + "|" + f.pref.carouselSize + "|" + f.pref.numOfThumbnail+ "|" + f.pref.numOfColumns + "|" + f.pref.wallType+ "|" + 
								groupOpen+ "|" + filterOpen+ "|" + foxTab.pref.portrait+ "|" + f.pref.animateLayoutSelection+ "|" + f.pref.displayPanel+ "|" + f.pref.displayThumbnailsReflection+ "|" + f.pref.closeButton+ "|" + f.pref.speed + "|" + 
								f.pref.carouselParams + "|" + f.pref.rowParams + "|" + f.pref.slidesParams + "|" + f.pref.pageFlowParams + "|" + f.pref.wallParams + "|" + f.pref.gridParams + "|" + foxTab.launchMode + "|" + f.pref.showNavigationArrows+ "|" + f.pref.siteTitle	 + "|" + f.pref.isFirstLaunch + "|" + 
								foxTab.PAGES_MODE + "|" + wall.rows + "|" + wall.columns + "|" + wall.factor + "|" + searchBoxHeight
				  args += prefStr+"_^__^__^__^__^__^__^_";
				  foxTab.foxTabWin.openStaticWall();
				  if (foxTab.DEBUG_MODE) foxTab.mainLogger.debug("args: " + args);
			break;

			case foxTab.MODE_TOP_SITES+"":
			case foxTab.MODE_RECENTLY_CLOSED+"":

				  if (f.tabsList!=null) f.tabsList.length = 0;
				  f.tabsList = new Array();

				  var args = "";

				  var mode = f.pref.mode
				  var tabEffect = false
				  var groupOpen = "0";
				  var filterOpen = "0";

				  f.foxTabWin.isFilterTextBoxOpen = false;
				  if (foxTab.PAGES_MODE==foxTab.MODE_TOP_SITES) {
					 mode = f.pref.topSiteMode;
				  } else {
				     mode = f.pref.recentlyClosedMode;
				  }

				  var prefStr = mode + "|" + tabEffect + "|" + f.pref.numOfSlides + "|" + f.pref.carouselSize + "|" + f.pref.numOfThumbnail+ "|" + f.pref.numOfColumns + "|" + f.pref.wallType+ "|" + 
								groupOpen+ "|" + filterOpen+ "|" + foxTab.pref.portrait+ "|" + f.pref.animateLayoutSelection+ "|" + f.pref.displayPanel+ "|" + f.pref.displayThumbnailsReflection+ "|" + f.pref.closeButton+ "|" + f.pref.speed + "|" + 
								f.pref.carouselParams + "|" + f.pref.rowParams + "|" + f.pref.slidesParams + "|" + f.pref.pageFlowParams + "|" + f.pref.wallParams + "|" + f.pref.gridParams + "|" + foxTab.launchMode + "|" + f.pref.showNavigationArrows+ "|" + f.pref.siteTitle	 + "|" + f.pref.isFirstLaunch + "|" + foxTab.PAGES_MODE
				 
				  
				  if (foxTab.PAGES_MODE==foxTab.MODE_TOP_SITES) {
					  var wall = foxTab.getStaticWallSize();
					    prefStr += "|"+wall.rows+","+wall.columns					
				  }

				  args += prefStr+"_^_"

				  args += f.windowBoxObject.width+"_^_"
				  args += f.windowBoxObject.height+"_^_"

				  args += f.biggestWindowWidth+"_^_"
				  args += f.biggestWindowHeight+"_^_"


				  if (foxTab.PAGES_MODE==foxTab.MODE_TOP_SITES) {
					  var ts = foxTab.getTopSites();


					  switch (foxTab.OS) {
						case foxTab.WINDOWS:
							var aaaa = foxTab.FOXTAB_DIR + "\\thumbsTS\\"
							break;
						case foxTab.LINUX:			
						case foxTab.MAC:
							var aaaa = foxTab.FOXTAB_DIR + "/thumbsTS/"
							break;
					  }

					  args += "file://" + aaaa + "_^_"

					  var selectedIndex = 0;
					  args += selectedIndex+"_^_"

					  var c = 0;
					  for (var i=0;i<ts.topSites.length;i++) {
						  if (ts.topSites[i]!=null) {
							  f.tabsList.push({
									  index       : c,
									  title       : ts.topSites[c].title,
									  url         : ts.topSites[c].url,
									  thumb       : ts.topSites[c].fileName,
									  visible     : true
							  });
							  c++;
						  }
					  }
				  } else {
						var isDuplicated = function(thumb) {
							var z;
							for (z=0;z<f.tabsList.length;z++) {
								if (f.tabsList[z].thumb==thumb) return true;
							}
							return false;
						}
						var dir = foxTab.getCacheDir('thumbsRCT')+"\\";
					
					    args += "file://" + dir + "_^_"

					    var selectedIndex = 0;
					    args += selectedIndex+"_^_"

						var nsISessionStore = Components.classes["@mozilla.org/browser/sessionstore;1"].getService(Components.interfaces.nsISessionStore);
		
						var list = nsISessionStore.getClosedTabData(window)
						if (list) {
							var json = JSON.parse(list)	
							var counter = 0;
							var i = 0;
							while ((i<json.length) && (counter<foxTab.MAX_RECENTLY_CLOSED)) {
								if (json[i].state) {
									if (json[i].state.entries) {
										var pos   = json[i].state.entries.length-1;
										var entry = json[i].state.entries[pos];
										if (foxTab.isCacheFileExists('thumbsRCT', entry.url)) {
											var thumb = foxTab.getCacheFile(entry.url);
											if (!isDuplicated(thumb)) {
												f.tabsList.push({
													  index       : c,
													  title       : entry.title,
													  url         : entry.url,
													  thumb       : thumb,
													  visible     : true
												});
												counter++;
											}
										}
									}
								}
								i++;
							}
						}		
					  
				  }

				  var tabsStr = "";
				  for(var j=0;j<f.tabsList.length; j++) {
					  tabsStr += f.windowId+"~"+j+"~" + f.tabsList[j].thumb + "~"+f.tabsList[j].title+"_^_"
				  }

				  args += tabsStr

				  var blankIndices = "";
				  args += blankIndices+"_^_"
				  if (foxTab.DEBUG_MODE) foxTab.mainLogger.debug("args: " + args);
			break;
			default:
				  var checkDuplicate = function(url) {
						for(var i=0; i<duplicateList.length; i++) {
							if (duplicateList[i]==url) {
								return false;
							}
						}
						duplicateList.push(url);
						return true;
				  }
				  var duplicateList = new Array();

				  if (f.tabsList!=null) f.tabsList.length = 0;
				  f.tabsList = new Array();

				  if (foxTab.selectedIndex!=null) {
					 selectedIndex = foxTab.selectedIndex
				  } else {
					  if (foxTab.pref.mostRecentlyUsed) {
						  if (f.tabsList.length>1) {
							selectedIndex = 0;
						  } else {
							selectedIndex = 0;
						  }
					  } else {
						 selectedIndex = f.gBrowser.tabContainer.selectedIndex
					  }
				  }
				  if (f.pref.hideDuplicateTabs) {
					   var currentBrowser = f.gBrowser.getBrowserAtIndex(selectedIndex); 
					   var selectedURL = currentBrowser.currentURI.spec
				  }

				  var numTabs		= f.gBrowser.tabContainer.childNodes.length;
				  var url;
				  var blankIndices = ""
				  var args = ""

				  if (foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK) {
					var filterOpen = "0"
					var groupOpen = "0"
					f.foxTabWin.isGroupPanelOpen = false;
					f.foxTabWin.isFilterTextBoxOpen = false;
				  } else {
					var groupOpen  = f.pref.groupOpen
					var filterOpen = f.pref.filterOpen
				  }


				  var tabEffect = f.pref.tabEffect	

				  var mode = f.pref.mode
				  if (foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK) {
					  if (f.pref.quick_size!="fitToBrowser") tabEffect = false
					  if (f.pref.quick_mode!="") var mode = f.pref.quick_mode
				  } else {
					  if (f.pref.interactive_size!="fitToBrowser") tabEffect = false
				  }
				  var prefStr = mode + "|" + tabEffect + "|" + f.pref.numOfSlides + "|" + f.pref.carouselSize + "|" + f.pref.numOfThumbnail+ "|" + f.pref.numOfColumns + "|" + f.pref.wallType+ "|" + 
								groupOpen+ "|" + filterOpen+ "|" + foxTab.pref.portrait+ "|" + f.pref.animateLayoutSelection+ "|" + f.pref.displayPanel+ "|" + f.pref.displayThumbnailsReflection+ "|" + f.pref.closeButton+ "|" + f.pref.speed + "|" + 
								f.pref.carouselParams + "|" + f.pref.rowParams + "|" + f.pref.slidesParams + "|" + f.pref.pageFlowParams + "|" + f.pref.wallParams + "|" + f.pref.gridParams + "|" + foxTab.launchMode + "|" + f.pref.showNavigationArrows+ "|" + f.pref.siteTitle	 + "|" + f.pref.isFirstLaunch + "|" + foxTab.PAGES_MODE





				  args += prefStr+"_^_"

				  args += f.windowBoxObject.width+"_^_"
				  args += f.windowBoxObject.height+"_^_"

				  args += f.biggestWindowWidth+"_^_"
				  args += f.biggestWindowHeight+"_^_"

				  args += "file://" + f.CACHED_SITE_DIR+"_^_"

				  tabsStr = ""
				  if (f.pref.multipleWindows) {
					  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
					  var e = wm.getEnumerator(null);
					  var tabsCounter = 0;
					  while (e.hasMoreElements()) {
						var w = e.getNext();
						if (w.foxTab!=null) {
							if (w.foxTab.isFoxTabEnabled) {
								var numTabs		= w.foxTab.gBrowser.tabContainer.childNodes.length;
								if (foxTab.windowId == w.foxTab.windowId) {
									selectedIndex = selectedIndex + tabsCounter
								}
								for(var i=0; i<numTabs; i++) {
								  var currentBrowser = w.foxTab.gBrowser.getBrowserAtIndex(i);
								  if ((!f.pref.hideDuplicateTabs) || (checkDuplicate(currentBrowser.currentURI.spec))) {
								
									  var title = ""
									  if (currentBrowser.contentDocument) {
										if (currentBrowser.contentDocument.title) {
											title = currentBrowser.contentDocument.title;
										}
									  }
									  f.tabsList.push({
														tabBrowser  : currentBrowser,
														tab         : w.foxTab.gBrowser.tabContainer.childNodes[i],
														index       : tabsCounter,
														visible     : true,
														groupFilter : false,
														windowId    : w.foxTab.windowId,
														windowIndex : i,
														title       : title,
														url         : w.foxTab.urlToFileName(currentBrowser.currentURI.spec)
													  });
								  }
								  tabsCounter++
								}
							}

						}
					  }
					  if (foxTab.pref.mostRecentlyUsed) {
						 selectedIndex = 0;
						 if ((tabsCounter>1) && (foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK)){
							selectedIndex = 1;
						 }
					  }
				  } else {
					  for(var i=0; i<numTabs; i++) {
						var currentBrowser = f.gBrowser.getBrowserAtIndex(i);
						if ((!f.pref.hideDuplicateTabs) || (checkDuplicate(currentBrowser.currentURI.spec))) {
							var title = ""
							if (currentBrowser.contentDocument) {
							  if (currentBrowser.contentDocument.title) {
								  title = currentBrowser.contentDocument.title;
							  }
							}
							f.tabsList.push({
											  tabBrowser  : currentBrowser,
											  tab         : f.gBrowser.tabContainer.childNodes[i],
											  index       : i,
											  visible     : true,
											  groupFilter : false,
											  windowId    : f.windowId,
											  windowIndex : i,
											  title       : title,
											  url         : f.urlToFileName(currentBrowser.currentURI.spec)
											});
						}
					  }
				  }
				
				  if (f.pref.mostRecentlyUsed) {
					  var currentBrowser = foxTab.gBrowser.selectedBrowser;
					  var pos = foxTab.mostRecentlyUsedList.indexOf(currentBrowser);
					  if (pos>=0) {
						foxTab.mostRecentlyUsedList.splice(pos, 1);
					  }
					  foxTab.mostRecentlyUsedList.push(currentBrowser);

					  var t;
					  for(var i=0; i<f.mostRecentlyUsedList.length; i++) {
						  for(var j=0; j<f.tabsList.length; j++) {
							if (f.tabsList[j].tabBrowser==f.mostRecentlyUsedList[i]) {
							   var t = f.tabsList[j]
							   f.tabsList.splice(j, 1);
							   f.tabsList.unshift(t);					   
							   break;
							}
						  }
					  }
				  }


				  var t;
				  var url;
				  for(var i=0; i<f.tabsList.length; i++) {
					  t = f.tabsList[i]
						
					  tabsStr += t.windowId+"~"+t.windowIndex+"~"+t.url+"~"+t.title+"_^_"
					  if (t.tabBrowser.currentURI.spec=="about:blank") {
							blankIndices += i+"-"
					  }
				  }

				  if (f.pref.hideDuplicateTabs) {
					  if ((selectedIndex>=duplicateList.length) || (duplicateList[selectedIndex]!=selectedURL)) {
						for(var i=0; i<duplicateList.length; i++) {
							if (duplicateList[i]==selectedURL) {
								selectedIndex = i;
							}
						}
					  }
				  }

				  args += selectedIndex+"_^_"
				  args += tabsStr
				  args += blankIndices+"_^_"
				  if (foxTab.DEBUG_MODE) foxTab.mainLogger.debug("args: " + args);
		  }
		  return {
				  args          : args,
				  selectedIndex : selectedIndex,
				  numTabs		: numTabs
				 }
	},
	/*
	 *
	 */
	filterTabsByText : function(text) {
		  var f = foxTab

		  var numTabs		= f.gBrowser.tabContainer.childNodes.length;
		  var list = new Array();

		  text = text.toLowerCase();

		  for(var i=0; i<f.tabsList.length; i++) {

				isFound = false

				if ((f.tabsList[i].visible) && (!f.tabsList[i].groupFilter)) {

					var currentBrowser = f.tabsList[i].tabBrowser

					if (f.pref.searchByDomain) {
						if (currentBrowser.contentDocument) {
							if (currentBrowser.contentDocument.domain) {
								_domain = currentBrowser.contentDocument.domain.toLowerCase()
								_domain = _domain.replace("http://",'');
								_domain = _domain.replace("https://",'');
								if (_domain.indexOf(text)!=-1) isFound = true
							}
						}
					} 
					if ((f.pref.searchByTitle) && (!isFound)){
						if (currentBrowser.contentDocument) {
							if (currentBrowser.contentDocument.title) {
								if (currentBrowser.contentDocument.title.toLowerCase().indexOf(text)!=-1) isFound = true
							}
						}
					} 
					if ((f.pref.searchByUrl) && (!isFound)) {
						_url = currentBrowser.currentURI.spec.toLowerCase()
						_url = _url.replace("http://",'');
						_url = _url.replace("https://",'');
						if (_url.indexOf(text)!=-1) isFound = true
					} 
				}
				if (isFound) {
					list.push(i);
				}
		  }	
		  return list;
	},
	/*
	 *
	 */
	addFoxTabToolbarButton : function(buttonID, toolbarLocation, add, remove) {
		var toolbox = document.getElementById("navigator-toolbox");
		var button = document.getElementById(buttonID);
		var hasFoxTabButton = false;
		
		if (add==null) {
			var firstInitialization = buttonID + "Initialization"
			if (toolbox.hasAttribute(firstInitialization)) {
				return false;
			}
		
			for (var i = 0; i < toolbox.childNodes.length; ++i) {
			  var toolbar = toolbox.childNodes[i];
			  if (toolbar.localName == "toolbar" && toolbar.getAttribute("customizable") == "true" ) {
				if (toolbar.currentSet.indexOf(buttonID) > -1)
				  hasFoxTabButton = true;
			  }
			}
		}
		var isAdded = false;
		if (!hasFoxTabButton) {
		  for (var i = 0; i < toolbox.childNodes.length; ++i) {
			toolbar = toolbox.childNodes[i];
			if (toolbar.localName == "toolbar" &&  toolbar.getAttribute("customizable") == "true"
			  && toolbar.id == "nav-bar") {
			  var newSet = "";
			  var child = toolbar.firstChild;
			  if (toolbarLocation==0) {
				   while (child) {
					 if(child.id == "urlbar-container") {
						newSet += child.id + ",";
						if (remove!=true) newSet += buttonID + ",";
						isAdded = true;
					 } else {
				        if (child.id!=buttonID) newSet += child.id + ",";
					 }
					 child = child.nextSibling;
				   }				
			    } else {
				   while (child) {
					 if(child.id == "urlbar-container") {
						if (remove!=true) newSet += buttonID + ",";
						isAdded = true;
					 }
					 if (child.id!=buttonID) newSet += child.id + ",";
					 child = child.nextSibling;
				   }
			  }
			  if (remove!=true) {
				  if (!isAdded) newSet += buttonID + ",";
			  }

			  newSet = newSet.substring(0, newSet.length-1);
			  toolbar.currentSet = newSet;
			  toolbar.setAttribute("currentset", newSet);
			  toolbox.ownerDocument.persist(toolbar.id, "currentset");
			  BrowserToolboxCustomizeDone(true)
			  break;
			}
		  }
		}
		try {
			toolbox.setAttribute(firstInitialization, "initialized");
			toolbox.ownerDocument.persist(toolbox.id, firstInitialization);
			return isAdded;
		} catch (e) {
			return false;
		}
	},
	/*
	 *
	 */
	isQuickLaunchAllowed : function(isQuickLaunch) {
		var f = foxTab;
		if (isQuickLaunch) {
			if (f.pref.quick_mode_threshold<=2) {
			  if (f.pref.keyboardQuick_defaultEnabled) {
				  foxTab.gBrowser.mTabBox.handleCtrlTab = false
				  foxTab.gBrowser.mTabBox.handleCtrlPageUpDown = false
			  }
			  return true;
			} else {
			  if (f.pref.multipleWindows) {
				  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
				  var e = wm.getEnumerator(null);
				  var tabsCounter = 0;
				  while (e.hasMoreElements()) {
					var w = e.getNext();
					if (w.foxTab!=null) {
						if (w.foxTab.isFoxTabEnabled) tabsCounter += w.foxTab.gBrowser.tabContainer.childNodes.length;
					}
				  }
			  } else {
				   var tabsCounter	= f.gBrowser.tabContainer.childNodes.length;
			  }

			  if (f.pref.quick_mode_threshold>tabsCounter) {
				  foxTab.gBrowser.mTabBox.handleCtrlTab = true
		          foxTab.gBrowser.mTabBox.handleCtrlPageUpDown = true
				  return false;
			  } else {
				  if (f.pref.keyboardQuick_defaultEnabled) {
					  foxTab.gBrowser.mTabBox.handleCtrlTab = false
					  foxTab.gBrowser.mTabBox.handleCtrlPageUpDown = false
				  }
				  return true;
			  }
			}
		}
		return true;
	},
	/*
	 *
	 */
	openFoxTabByKey : function(isForward) {
		clearInterval(foxTab.keyboardInterval)
		foxTab.keyboardInterval = null;

		var steps = foxTab.steps 
		foxTab.steps = 0;
		var selectedIndex = foxTab.gBrowser.tabContainer.selectedIndex
		var numTabs		= foxTab.gBrowser.tabContainer.childNodes.length;
		
		var foxTabSelectedIndex;
		if (foxTab.isKeyDown) {
				if ((foxTab.pref.mostRecentlyUsed) && (foxTab.mostRecentlyUsedList.length>1)){
					  foxTabSelectedIndex = 0;
					  if (foxTab.isQuickLaunch) {
						  var t;
						  var contentDocument = foxTab.mostRecentlyUsedList[foxTab.mostRecentlyUsedList.length-2].contentDocument
						  if (foxTab.pref.multipleWindows) {
							  var foxTabList = foxTab.getAllFoxTabObjects();
						  } else {
							  var foxTabList = new Array(foxTab);
						  }
						  for(var j=0; j<foxTabList.length; j++) {
							 var docIndex = foxTab.gBrowser.getBrowserIndexForDocument(contentDocument);
							 if (docIndex!=-1) {
								selectedIndex = docIndex
								foxTabSelectedIndex = 1
								break;
							 }
						  }	
						  foxTab.swapLast2Recently = true
					  } else {
						
					  }
				} else {
					if (foxTab.isQuickLaunch) {
						
						selectedIndex 		 = selectedIndex + steps
						if (selectedIndex>numTabs-1) selectedIndex = (selectedIndex - numTabs)
						  else if (selectedIndex<0) selectedIndex = numTabs + selectedIndex

					}
					foxTabSelectedIndex = selectedIndex
				}

				foxTab.selectedIndex = foxTabSelectedIndex
				if (foxTab.isQuickLaunch) {
					foxTab.openFoxTab(foxTab.LAUNCH_MODE_QUICK);
				} else {
					foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE);
				}
				if (foxTab.pref.firstFlipTabInQuickMode) {
					if (foxTab.gBrowser.tabContainer.selectedIndex!= selectedIndex) {
						foxTab.disableTabSelected = true
						foxTab.disableRecentlyUsedPush = true
						foxTab.gBrowser.tabContainer.selectedIndex = selectedIndex		
					}
				}
		} else {
				if ((foxTab.pref.mostRecentlyUsed) && (foxTab.mostRecentlyUsedList.length>1)){
					  var t;
					  var contentDocument = foxTab.mostRecentlyUsedList[foxTab.mostRecentlyUsedList.length-2].contentDocument
					  if (foxTab.pref.multipleWindows) {
						  var foxTabList = foxTab.getAllFoxTabObjects();
					  } else {
						  var foxTabList = new Array(foxTab);
					  }
					  for(var j=0; j<foxTabList.length; j++) {
						 var docIndex = foxTab.gBrowser.getBrowserIndexForDocument(contentDocument);
						 if (docIndex!=-1) {
							selectedIndex = docIndex
							break;
						 }
					  }
			    } else {

					selectedIndex 		 = selectedIndex + steps
					if (selectedIndex>numTabs-1) selectedIndex = (selectedIndex - numTabs)
					   else if (selectedIndex<0) selectedIndex = numTabs + selectedIndex

				}
				if (foxTab.gBrowser.tabContainer.selectedIndex!= selectedIndex) {
					foxTab.disableTabSelected = true
					foxTab.gBrowser.tabContainer.selectedIndex = selectedIndex		
				}
		}

	},
	/*
	 *
	 */
	onKeyDown : function(event) {

		var p = foxTab.pref

		var isLaunchKey_Quick = false
		var isLaunchKey_Interactive = false
		var forceCtrl = true;
		if ((event.keyCode==p.keyboardQuick_defaultKey) || 
			(event.keyCode==event.DOM_VK_PAGE_UP) ||
			(event.keyCode==event.DOM_VK_PAGE_DOWN)) {
		    if (p.keyboardQuick_defaultEnabled) isLaunchKey_Quick = true;

		} else if (event.keyCode==p.keyboardQuick_customKey) {
		    if (p.keyboardQuick_customEnabled) isLaunchKey_Quick = true;
		
		} else if (event.keyCode==p.keyboardInteractive_defaultKey) {
			if ((!event.ctrlKey) && (!event.shiftKey) && (!event.altKey)) {
				if (p.keyboardInteractive_defaultEnabled) {
					isLaunchKey_Interactive = true;
					forceCtrl = false;
				}
			}
		
		} else if (event.keyCode==p.keyboardInteractive_customKey) {
		    if (p.keyboardInteractive_customEnabled) isLaunchKey_Interactive = true;
		}


		if ((event.ctrlKey) && (event.keyCode == event.DOM_VK_F4)) {
			if (!foxTab.gBrowser.mTabBox.handleCtrlPageUpDown) {
				foxTab.gBrowser.removeCurrentTab();
				return false;
			}
		}

	
			if ((isLaunchKey_Quick) || (isLaunchKey_Interactive)) {
			  if (((event.ctrlKey) || (!forceCtrl)) && (!event.altKey) && (!event.metaKey)) {
	
				if ((!foxTab.isWindowOpen) || ((foxTab.loadOnFirefoxStart) && (!foxTab.isFlashOpen)) || ((foxTab.loadOnFirefoxStart) && (foxTab.isFlashOpen) && (foxTab.PAGES_MODE==foxTab.MODE_NEW_TAB))) {
					foxTab.isKeyDown = true
					
					if ((isLaunchKey_Quick) && (!foxTab.isQuickLaunchAllowed(isLaunchKey_Quick))) return;
					foxTab.isQuickLaunch = isLaunchKey_Quick

					if (foxTab.keyboardInterval==null) {
						foxTab.steps = 0;
					}

					if ((event.shiftKey) || (event.keyCode==event.DOM_VK_PAGE_UP)) {
						foxTab.steps = -1
						isForward = false
					} else {
						foxTab.steps = 1
						isForward = true
					}
						
					if ((foxTab.pref.suspensionTime-0==0) || (isLaunchKey_Interactive)) {
						foxTab.openFoxTabByKey(isForward);
					} else {
						clearTimeout(foxTab.keyboardInterval)
						foxTab.keyboardInterval = setTimeout(foxTab.openFoxTabByKey, foxTab.pref.suspensionTime-0, isForward)
					}

				} else {
					if ((event.keyCode==p.keyboardInteractive_defaultKey) && (p.keyboardInteractive_defaultEnabled)) {
						if (foxTab.isFlashOpen) {
							foxTab.closeFoxTab();
						}
					 } else {
						if (event.shiftKey || (event.keyCode==event.DOM_VK_PAGE_UP)) {
							foxTab.foxTabWin.onMouseWheel("k", 5, true)
						} else {
							foxTab.foxTabWin.onMouseWheel("k", -5, true)
						}
					}
				}
				event.stopPropagation();
				event.preventDefault();
			} else {
				if (foxTab.isFlashOpen) {
					switch (event.keyCode) {
						case event.DOM_VK_TAB:
							if (event.shiftKey) {
								foxTab.foxTabWin.onMouseWheel("k", 5, true);
							} else {
								foxTab.foxTabWin.onMouseWheel("k", -5, true);
							}
						break;
						case event.DOM_VK_PAGE_UP:
							foxTab.foxTabWin.onMouseWheel("k", 5, true);
						break;
						case event.DOM_VK_PAGE_DOWN:
							foxTab.foxTabWin.onMouseWheel("k", -5, true);
						break;
					}
				}

			}
		} else {
			if (foxTab.isFlashOpen) {
				switch (event.keyCode) {
					case 70:
						if (event.ctrlKey) {
							if (!foxTab.foxTabWin.isFilterTextBoxOpen) {	
								foxTab.foxTabWin.openSearchPanel();
							} else {
								foxTab.foxTabWin.closeSearchPanel();
							}
							event.stopPropagation();
							event.preventDefault();
						}
					break;
					case 71:
						if (event.ctrlKey) {
							if (!foxTab.foxTabWin.isGroupPanelOpen) {		
								foxTab.foxTabWin.setGroupPanel();
								foxTab.foxTabWin.openGroupPanel(true);
							} else {
								foxTab.foxTabWin.closeGroupPanel();
								
							}
							event.stopPropagation();
							event.preventDefault();
						}
					break;
					case event.DOM_VK_ESCAPE:
						foxTab.closeFoxTab();
					break;
					case event.DOM_VK_TAB:
						if (event.shiftKey) {
							foxTab.foxTabWin.onMouseWheel("k", 5, true);
						} else {
							foxTab.foxTabWin.onMouseWheel("k", -5, true);
						}
					break;
					case event.DOM_VK_PAGE_UP:
						foxTab.foxTabWin.onMouseWheel("k", 5, true);
					break;
					case event.DOM_VK_PAGE_DOWN:
						foxTab.foxTabWin.onMouseWheel("k", -5, true);
					break;
					case event.DOM_VK_DOWN:
						foxTab.foxTabWin.onMouseWheel("k", -5, false);
					break;
					case event.DOM_VK_RIGHT:
						foxTab.foxTabWin.onMouseWheel("k", -5, true);
					break;
					case event.DOM_VK_UP:
						foxTab.foxTabWin.onMouseWheel("k", 5, false)
					break;
					case event.DOM_VK_LEFT:
						foxTab.foxTabWin.onMouseWheel("k", 5, true);
					break;
					case event.DOM_VK_RETURN:
						if (foxTab.isTabsPagesMode()) {
							foxTab.foxTabWin.foxTabFlash.execute("","closeAndSelect");
						}
					break;
					case event.DOM_VK_SPACE:
						if (foxTab.isTabsPagesMode()) {
							if (!foxTab.foxTabWin.isFilterTextBoxOpen) {	
								foxTab.foxTabWin.foxTabFlash.execute("","closeAndSelect")
							}
						}
					break;
				}
			}
		}
	},
	/*
	 *
	 */
	onKeyUp : function(event) {

		if (foxTab.canvasType==foxTab.CANVAS_WIN) {
			if (foxTab.mouseGestures.isOpenByGesture) {
				foxTab.mouseGestures.onKeyUp(event)
			}
		}


		if (event.keyCode == event.DOM_VK_CONTROL) {
			foxTab.isKeyDown = false
		}
		if (foxTab.isQuickLaunch) {
			if (foxTab.isFlashPlayerInstalled) {
				if (foxTab.isFlashOpen) {
					if (event.keyCode == event.DOM_VK_CONTROL) {
						foxTab.foxTabWin.foxTabFlash.execute("","closeAndSelect")
						event.stopPropagation();
						event.preventDefault();
					}
				} else {
					if (event.keyCode == event.DOM_VK_CONTROL){
						if (foxTab.keyboardInterval!=null) {
							foxTab.isKeyDown = false
							clearTimeout(foxTab.keyboardInterval)
							foxTab.openFoxTabByKey(true);
						}
					} else {
					}
				}
			}
		}
	},
	/*
	 *
	 */
	startCheckCallBack : function() {
		var interval = setTimeout(foxTab.checkCallBack,50)
	},
	/*
	 *
	 */
	checkCallBack : function() {
		 if (foxTab.foxTabWin.foxTabFlash==null) {
			 var interval = setTimeout(foxTab.checkCallBack,10)	
		 } else {
			 foxTab.foxTabWin.checkCallBack();
		 }
	},
	callURL : function(param) {
			foxTab.loadUrl("http://www.foxtab.com/addon/s/?" + param, function(response) {
			}, null);
	},

	loadUrl : function(url, callbackFunction, params) {
		var xmlHttp;
		if (window.XMLHttpRequest) {
			xmlHttp = new XMLHttpRequest();
		} else if (window.ActiveXObject) {
			xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
		}
		xmlHttp.open("GET", url, true);
		xmlHttp.onreadystatechange =  function () {
			if (xmlHttp.readyState == 4) {
				if (xmlHttp.status == 200) {
					var response;
					response = xmlHttp.responseText
					if (callbackFunction) callbackFunction.apply(this,new Array(response, params))
				}
			}
		};
		xmlHttp.send("");
	},

	openTopSitesHelpPage : function() { 
		foxTab.gBrowser.selectedTab = foxTab.gBrowser.addTab("http://www.foxtab.com/gettingstarted/#topsites")		
	},

	loadJSON : function(file){
		var request = new XMLHttpRequest()
		request.open('GET', 'file:///'+file.path, false);
		request.overrideMimeType("application/json");
		request.send(null);
		var nativeJSON = Components.classes["@mozilla.org/dom/json;1"].createInstance(Components.interfaces.nsIJSON); 
		return nativeJSON.decode(request.responseText);	
	},
	saveJSON : function(file,jsonData){
		try{	
			var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
			foStream.init(file, 0x02 | 0x08 | 0x20, 0600, 0);   // write, create, truncate
			var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
			converter.init(foStream, "UTF-8", 0, 0);
			var nativeJSON = Components.classes["@mozilla.org/dom/json;1"].createInstance(Components.interfaces.nsIJSON); 
			converter.writeString(nativeJSON.encode(jsonData));
			converter.close();
		}catch (e){
			try{
				if (converter)
					converter.close();
				else
					foStream.close();
			}catch(e){}
		}		
	},
	loadTopSites : function(){
		var dataFile = Components.classes["@mozilla.org/file/local;1"]
					.createInstance(Components.interfaces.nsILocalFile);
		dataFile.initWithPath(foxTab.FOXTAB_DIR);
		dataFile.append('data')
		if (!dataFile.exists())
			dataFile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);				
		dataFile.append(foxTab.TOP_SITES)
		try{
			var topSites=foxTab.loadJSON(dataFile)
		}catch(e){
			var topSites=[]
		}
		if (topSites==null) topSites = [];
		return {
			file : dataFile,
			data : topSites
		}
	},



	addUrlToRecentlyClosed : function(url){
		var fileName = foxTab.urlToFileName(url)
	    var file_big = Components.classes["@mozilla.org/file/local;1"]
							.createInstance(Components.interfaces.nsILocalFile);
		file_big.initWithPath(foxTab.CACHED_SITE_DIR + fileName);
		if (!file_big.exists()) {
			return false;
		}
	    var file_small = Components.classes["@mozilla.org/file/local;1"]
							.createInstance(Components.interfaces.nsILocalFile);
		file_small.initWithPath(foxTab.CACHED_SITE_DIR + fileName + "_S");
		foxTab.setCacheFile('thumbsRCT', url, file_big);
		foxTab.setCacheFile('thumbsRCT', url, file_small, "_S");
		return true;
	},

	addBrowserToTopSites : function(browser){
		var fileName = foxTab.urlToFileName(browser.currentURI.spec);
	    var file_big = Components.classes["@mozilla.org/file/local;1"]
							.createInstance(Components.interfaces.nsILocalFile);
		file_big.initWithPath(foxTab.CACHED_SITE_DIR + fileName);
		if (!file_big.exists()) {
				
			browser.topSiteAdded = false;
			return;
		}
	
	    var file_small = Components.classes["@mozilla.org/file/local;1"]
							.createInstance(Components.interfaces.nsILocalFile);
		file_small.initWithPath(foxTab.CACHED_SITE_DIR + fileName + "_S");
	    
		var title = ""
	    if (browser.contentDocument) {
		  if (browser.contentDocument.title) {
			   title = browser.contentDocument.title;
		  }
	    }

		foxTab.setTopSite(title, browser.currentURI.spec, file_small, file_big);
		foxTab.createStaticWallImage();
	},

	setTopSite : function(title, url, thumb_small, thumb_big){
		var file = Components.classes["@mozilla.org/file/local;1"]
					.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(foxTab.FOXTAB_DIR);
		var thumbDir=file.clone()
		thumbDir.append('thumbsTS')
		if (!thumbDir.exists())
			thumbDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);

		var fileName = Components.classes["@mozilla.org/uuid-generator;1"].getService(Components.interfaces.nsIUUIDGenerator).generateUUID().toString();
		thumb_big.copyTo(thumbDir, fileName)
		thumb_small.copyTo(thumbDir, fileName+"_S")
		
		var ts = foxTab.loadTopSites();

		var list  = ts.data;
		
		index = list.length;
		list.push({
			index    : index,
			fileName : fileName,
			title    : title,
			url		 : url
		});
		foxTab.saveJSON(ts.file, list)
	},
	updateTopSites : function(list){
		var ts = foxTab.loadTopSites();
		var topSites  = ts.data;
		var newList = new Array();
		for (var i=0;i<list.length;i++) {
			newList.push(topSites[list[i]]);
		}
		foxTab.saveJSON(ts.file, newList)	
	},
	removeTopSite : function(index){
		var file = Components.classes["@mozilla.org/file/local;1"]
					.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(foxTab.FOXTAB_DIR);
		var thumbFile=file.clone()
		thumbFile.append('thumbsTS')
		thumbFile.append(index)
		if (thumbFile.exists())
			thumbFile.remove(true)

		var ts = foxTab.loadTopSites();
		var list  = ts.data;
		if (list.length>index) {
			list.splice(index,1);
			foxTab.saveJSON(ts.file, list)	
		}
	},
	getTopSitesDir : function(){
		var file = Components.classes["@mozilla.org/file/local;1"]
					.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(foxTab.FOXTAB_DIR);
		
		var thumbDir=file.clone()
		thumbDir.append('thumbsTS')
		if (!thumbDir.exists())
			thumbDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
		return thumbDir.path;
	},
	getTopSites : function(){
		var file = Components.classes["@mozilla.org/file/local;1"]
					.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(foxTab.FOXTAB_DIR);
		
		var thumbDir=file.clone()
		thumbDir.append('thumbsTS')
		if (!thumbDir.exists())
			thumbDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);				

		var topSites = foxTab.loadTopSites().data
		var urls=[]

		return {
			dir : thumbDir.path,
			topSites : topSites
		}
	},
	getCacheFile : function(url){
		function toHexString(charCode){
			return ("0" + charCode.toString(16)).slice(-2);
		}		
		var str = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(url, null, null).asciiSpec;
		var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
		converter.charset = "UTF-8";
		var result = {};
		var data = converter.convertToByteArray(str, result);
		var hash = Components.classes["@mozilla.org/security/hash;1"].createInstance(Components.interfaces.nsICryptoHash);
		hash.init(hash.MD5);
		hash.update(data, data.length);
		var hash = hash.finish(false);
		var hashStr = [toHexString(hash.charCodeAt(i)) for (i in hash)].join("");
		return hashStr;
	},
	getCacheDir : function(type,returnFileObj){
		var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get(foxTab.cacheInTempdir ? "TmpD" : "ProfD" ,Components.interfaces.nsIFile);
		file.append(foxTab.FOXTAB_DIR_NAME); 	
		file.append(type)
		if (!file.exists())
			file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
		return (returnFileObj ? file : file.path)
	},
	clearCacheDir : function(type){
		var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get(foxTab.cacheInTempdir ? "TmpD" : "ProfD" ,Components.interfaces.nsIFile);
		file.append(foxTab.FOXTAB_DIR_NAME); 	
		file.append(type)
		if (file.exists())
			file.remove(true)
	},
	setCacheFile : function(type, url, sourceFile, suffix){	
		var dir=foxTab.getCacheDir(type,true)
		var file = dir.clone()
		var uun=foxTab.getCacheFile(url);
		if (suffix==null) suffix = "";
		file.append(uun + suffix)
		if (file.exists())
			file.remove(true)
		sourceFile.copyTo(dir,uun + suffix)
	},
	removeCacheFile : function(type, url, suffix){
		var file=foxTab.getCacheDir(type, true)
		if (suffix==null) suffix = "";
		file.append(foxTab.getCacheFile(url) + suffix)
		if (file.exists())
			file.remove(true)
	},
	isCacheFileExists : function(type, url, suffix){	
		var dir = foxTab.getCacheDir(type,true)
		var file = dir.clone()
		var uun = foxTab.getCacheFile(url);
		if (suffix==null) suffix = "";
		file.append(uun + suffix)
		if (file.exists()) {
			return true;
		} else {
			return false;
		}
	},

	/*setPrivateBrowsingListener : function() { 
		 function PrivateBrowsingListener() {  
		   this.init();  
		 }  
		 PrivateBrowsingListener.prototype = {  
		   _os: null,  
		   _inPrivateBrowsing: false, // whether we are in private browsing mode  
		   _watcher: null, // the watcher object  
			
		   init : function () {  
			 this._inited = true;  
			 this._os = Components.classes["@mozilla.org/observer-service;1"]  
								  .getService(Components.interfaces.nsIObserverService);  
			 this._os.addObserver(this, "private-browsing", false);  
			 this._os.addObserver(this, "quit-application", false);  
			 try {  
			   var pbs = Components.classes["@mozilla.org/privatebrowsing;1"]  
								   .getService(Components.interfaces.nsIPrivateBrowsingService);  
			   this._inPrivateBrowsing = pbs.privateBrowsingEnabled;  
			 } catch(ex) {  
			   // ignore exceptions in older versions of Firefox  
			 }  
		   },  
			
		   observe : function (aSubject, aTopic, aData) {  
			 if (aTopic == "private-browsing") {  
			   if (aData == "enter") {  
				 this._inPrivateBrowsing = true;  
				 if (this.watcher &&  
					 "onEnterPrivateBrowsing" in this._watcher) {  
				   this.watcher.onEnterPrivateBrowsing();  
				 }  
			   } else if (aData == "exit") {  
				 this._inPrivateBrowsing = false;  
				 if (this.watcher &&  
					 "onExitPrivateBrowsing" in this._watcher) {  
				   this.watcher.onExitPrivateBrowsing();  
				 }  
			   }  
			 } else if (aTopic == "quit-application") {  
			   this._os.removeObserver(this, "quit-application");  
			   this._os.removeObserver(this, "private-browsing");  
			 }  
		   },  
			
		   get inPrivateBrowsing() {  
			 return this._inPrivateBrowsing;  
		   },  
			
		   get watcher() {  
			 return this._watcher;  
		   },  
			
		   set watcher(val) {  
			 this._watcher = val;  
		   }  
		 }; 
	},*/




	/*
	 * FoxTab make use of window if the size was set to be "Full Screen", we must override the "closeWindow" method in order to have the default "Save and Quit" button
	 * in the "Quit Firefox" dialog, right before the user close the browser.
	 */
	overrideCloseWindow : function() { 
		if (foxTab.canvasType==foxTab.CANVAS_WIN) {
			window.closeWindow = function(aClose, aPromptFunction) {
					var windowCount = 0;
					var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
					var e = wm.getEnumerator(null);

					foxTabCounter = 0;
					// FoxTab code
					while (e.hasMoreElements()) {
						var w = e.getNext();
						windowCount++
						if (w.foxTab!=null) {
							if (w.foxTab.isFoxTabEnabled) {
								foxTabCounter++
							}
						}
					}
					if (foxTab.canvasType==foxTab.CANVAS_WIN) {
						windowCount -= foxTabCounter
					}
					////////////////

					if (windowCount == 1 && !canQuitApplication()) {
						return false;
					} else if (windowCount != 1) {
						if (typeof aPromptFunction == "function" && !aPromptFunction()) {
							return false;
						}
					}
					if (aClose) {
						window.close();
					}
					return true;
			}
		}
	},
	/*
	 *
	 */
	flashBlockEvent : function(e) { 
		if (e.target.baseURI==foxTab.WINDOW_CHROME_URL) {
			e.preventDefault();
			e.stopPropagation();
		}
	},
	/*
	 *
	 */
	openAdobeFlashPlayerSite : function() { 
		foxTab.closeFoxTab();
		foxTab.gBrowser.selectedTab = foxTab.gBrowser.addTab("http://get.adobe.com/flashplayer/")		
	}
	
	/***********************************************************************************
	 ***********************************************************************************
	 ***********************************************************************************/
}

foxTab.init();
