/* Copyright (c) 2011, FoxTab. (team@foxtab.com)
 * All rights reserved.
 * See License.txt for further details.
 */
var foxTabWin = {

	selectedIndex   : null,
	numTabs		    : null,
	wo			    : null,
	wp			    : null,

	foxTabFlash  	: new FoxTab_Flash(),
		
	flashCallBack   : 0,
 
	windowPositionInterval : null,
	lastWindowX		: 0,
	lastWindowY		: 0,
	isFilterTextBoxOpen : false,
	isGroupPanelOpen : false,
	

	isFullScreen   : false,
	filterInterval : null,
	groupList      : null,
	lastGroupIndex : -1,

	init : function() {
		
		if (window.parent) {
			if (window.parent.foxTab) {
				foxTabWin.wo = window.parent.foxTab;
				foxTabWin.wp = window.parent;
			} else {
				var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
				var supportedVersion = false;
				try {
					var info = Components.classes["@mozilla.org/xre/app-info;1"] .getService(Components.interfaces.nsIXULAppInfo);  
					if (info.version>="3.6"){
						supportedVersion = true;
					}
				} catch (e) {}	

				if ((osString.toLowerCase()=="darwin") && (supportedVersion)){
					var f = foxTabWin.getFirstFoxTabObject();
					foxTabWin.wo = f.f;
					foxTabWin.wp = f.w;
				} else {
					if (window.opener) {
						foxTabWin.wo = window.opener.foxTab;
						foxTabWin.wp = window.opener;	
					} else {
						var f = foxTabWin.getFirstFoxTabObject();
						foxTabWin.wo = f.f;
						foxTabWin.wp = f.w;
					}
				}
			}
		} else {
			foxTabWin.wo = window.opener.foxTab;
			foxTabWin.wp = window.opener;
		}
		
		if (foxTabWin.wp==window.opener) {
			function blurWindow() {
				window.blur()
			}			
			var win_timeout = setTimeout(blurWindow, 1)
			window.addEventListener("keyup"  , foxTabWin.wo.onKeyUp, false);
			window.addEventListener("keydown", foxTabWin.wo.onKeyDown, false);
		}
		window.addEventListener("load", foxTabWin.onLoad, false);
		window.addEventListener("flashblockCheckLoad", foxTabWin.flashBlockEvent, true, true);
	},
	/*
	 *
	 */
	getFirstFoxTabObject : function() {
          var list = new Array();
		  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
		  var e = wm.getEnumerator(null);
		
 		  while (e.hasMoreElements()) {
			var w = e.getNext();
			if (w.foxTab!=null) {
				return {
					w : w,
					f : w.foxTab
				}
				break;
			}
		  }
	},
	/*
	 *
	 */
	onFlashMouseDown : function(evt, params) {
		var button = params[0];
		var x      = params[1];
		var y      = params[2];
		if (button==1) {
			foxTabWin.foxTabFlash.execute("","onMiddleClick", x, y)
		}
	},
	/*
	 *
	 */
	onMouseWheel : function(evt,args, isKey) {
		var f = foxTabWin
		if (args>0) {
			f.selectedIndex--
			if (f.selectedIndex<0) f.selectedIndex = f.numTabs-1
		} else {
			f.selectedIndex++
			if (f.selectedIndex>f.numTabs-1) f.selectedIndex = 0
		}

		f.foxTabFlash.execute("","onJSMouseWheel",args, isKey)
	},
	onImageCorrupted : function(evt,args) {
		 if (foxTabWin.wo.isTabsPagesMode()) {
			 var params = args.split("_");
			 var foxTabObject = foxTabWin.wo.getWindowById(params[0]-0);

			 if (foxTabObject!=null) {
				 if (foxTabObject.OS!=foxTabObject.MAC) {
					foxTabObject.saveTabByBrowser(foxTabWin.wo.tabsList[params[2]].tabBrowser, false);
				 }
				 foxTabWin.foxTabFlash.execute("","loadFixedImage",params[2], params[3])	
			 }
		 }
	},
	onTabSelected : function(evt,args) {
		 var f = foxTabWin
		 switch (f.wo.PAGES_MODE) {
			case f.wo.MODE_TOP_SITES:
			case f.wo.MODE_RECENTLY_CLOSED:
				var params = args.split("_");
				 var b = foxTabWin.wo.gBrowser;
				 b.selectedBrowser.loadURI(foxTabWin.wo.tabsList[params[2]].url);
				 foxTabWin.closeFoxTab();
			break;
			default:
				 var params = args.split("_");
				 var foxTabObject = foxTabWin.wo.getWindowById(params[0]);
				 if (foxTabObject!=null) {
					 foxTabWin.closeFoxTab();
					 var b = foxTabObject.gBrowser
					 b.selectedTab = foxTabWin.wo.tabsList[params[2]].tab
					 if (foxTabObject!=foxTabWin.wo) foxTabObject.win.focus();
				 }
		}
	},
	updateImage : function(windowId, tabIndex, newUrl) {
	    if (!foxTabWin.wo.pref.multipleWindows) windowId = -1
		foxTabWin.foxTabFlash.execute("","updateImage", windowId, tabIndex, newUrl)
	},
	/*
	 *
	 */
	setTextPosition : function(posX, posY, windowId, windowIndex, tabIndex) {
		if (foxTabWin.rightPanelOpen==true) return false;
	    var div = document.getElementById("foxTab_div_text")
	    div.style.display = ""
	    if ((posY<35) && (foxTabWin.wo.launchMode!=foxTabWin.wo.LAUNCH_MODE_QUICK)) posY = 35
	    div.style.top  = posY +"px"
	    div.style.color = "#ffffff"

	    var font = document.getElementById("foxTab_siteTitle")

	    try {
		   var favIconObj = null
		   if (!foxTabWin.wo.isTabsPagesMode()) {
			   var title = foxTabWin.wo.tabsList[tabIndex].title
			   if ((title=="") || (title=="about:blank")) title="Blank Page"
		   } else {
			
			   var currentBrowser = foxTabWin.wo.tabsList[tabIndex].tabBrowser

			   var title = currentBrowser.contentDocument.title
			   if (title=="") {
					if (currentBrowser.currentURI.spec=="about:blank") title="Blank Page"
			   } else {
				   if (foxTabWin.wo.pref.displayFavoriteIcon) {
						var pageDomain = currentBrowser.contentDocument.domain
						favIconObj = document.createElement("image");
						favIconObj.setAttribute("src", "http://"+pageDomain +"/favicon.ico");
						favIconObj.setAttribute("validate","never")
						favIconObj.setAttribute("width","16")
						favIconObj.setAttribute("height","16")
						favIconObj.style.marginRight = "7px"			   
				   }
				   
			   }
		   }
		   font.style.color = "#" + foxTabWin.wo.pref.titleColor
		   font.style.fontFamily = "arial"

		   var isSmallSize = false;
		   if (((foxTabWin.wo.launchMode==foxTabWin.wo.LAUNCH_MODE_INTERACTIVE) && (foxTabWin.wo.pref.interactive_size=="small")) ||
			  ((foxTabWin.wo.launchMode==foxTabWin.wo.LAUNCH_MODE_QUICK) && (foxTabWin.wo.pref.quick_size=="small"))) {
			  isSmallSize = true;
		   }
		   if (isSmallSize) {
				font.style.fontSize = "20px"
				if (title.length>45) title = title.substring(0,45)+"..."
		   } else {
			    if (title.length>65) title = title.substring(0,65)+"..."
				font.style.fontSize = "25px"
		   }

		   font.innerHTML = ""
		   if (favIconObj!=null) font.appendChild(favIconObj);
		   var nobr = document.createElement("html:nobr");
		   nobr.textContent = title
		   font.appendChild(nobr);

	    } catch (e) {
		}	   
	},
	/*
	 *
	 */
	onGroupItemDbClick : function (index) {
		if (!isNaN(index)) {
			if (foxTabWin.groupList[index].indices.length==1) {
				foxTabWin.foxTabFlash.execute("","closeAndSelect")
			}
		}
	},
	/*
	 *
	 */
	onGroupItemClick : function (index) {
	   var f = foxTabWin

		var list = new Array();
	    var tabsList = foxTabWin.wo.tabsList
		if (index-0!=0) {
			for (var i=1;i<f.groupList.length;i++) {
				if (i!=(index-0)) {
					 for (var j=0;j<f.groupList[i].indices.length;j++) {
						tabsList[f.groupList[i].indices[j]].groupFilter = true;
					 }
				}
			}
		}
		if (!isNaN(index)) {
			for (var j=0;j<f.groupList[index].indices.length;j++) {
				if (tabsList[f.groupList[index].indices[j]].visible) {
					list.push(f.groupList[index].indices[j])
					tabsList[f.groupList[index].indices[j]].groupFilter = false;
				} else {
					tabsList[f.groupList[index].indices[j]].groupFilter = true;
				}
			}
		}
		list.sort(function(a, b){return (a - b)})
		if (f.lastGroupIndex!=-1) {
			document.getElementById("groups_arrow" + f.lastGroupIndex).src = 'chrome://foxtab/skin/images/groupsPanel/green_arrow.png'
		}
		document.getElementById("groups_arrow" + index).src = 'chrome://foxtab/skin/images/groupsPanel/blue_arrow.png'
		f.lastGroupIndex = index

		// Clear the filter text
	    var textbox = document.getElementById("foxTab_filter_textbox")
	    textbox.value = ""
	    textbox.style.color = "#" + foxTabWin.wo.pref.titleColor

		foxTabWin.foxTabFlash.execute("","filterTabs",list.join("^"))
	},
	/*
	 *
	 */
	getDomainName : function(domainName) {
		var tldList = new Array("com","net","org","us","uk","de","ws","int", "mob","biz","info","net","edu","mil","nom","sch","tv","ac","k12","muni")
		var sldList = new Array("co","com","org","net","edu","mil","nom","sch","tv","ac","k12","muni")
		var domainSplit = domainName.split(".");
		
		if (domainSplit.length>2) {
			tld = domainSplit[domainSplit.length-1].toLowerCase();
			sld = domainSplit[domainSplit.length-2].toLowerCase();
			for (var i=0;i<sldList.length;i++) {
				if (sldList[i]==sld) {
					return domainSplit[domainSplit.length-3]+"."+domainSplit[domainSplit.length-2]+"."+domainSplit[domainSplit.length-1];
				}
			}
			for (var i=0;i<tldList.length;i++) {
				if (tldList[i]==tld) {
					return domainSplit[domainSplit.length-2]+"."+domainSplit[domainSplit.length-1];
				}
			}

			if (domainSplit[0]=="www") {
				domainName = domainSplit[1]
				for (var i=2;i<domainSplit.length;i++) {
					domainName += "."+ domainSplit[i]
				}
				return domainName;
			} else {
				if (domainSplit.length==3) {
				  domainName = domainSplit[domainSplit.length-2]+"."+domainSplit[domainSplit.length-1]
				}
				return domainName;
			}
		} else {
			return domainName;
		}
		return domainName;
	},
	/*
	 *
	 */
	openGroupPanel : function(animate) {
	   var div = document.getElementById("foxTab_div_groups_panel")
	   if (animate) {
		   t1 = new FoxTab_Tween(div.style,'left',false,parseFloat(div.style.left),5,0.6,'px');
		   t1.start();
		   t1.onMotionFinished = function(){
			foxTabWin.foxTabFlash.execute("","groupPanelOpened")
		   };
	   } else {
		   div.style.left = "5px"
	   }
	   if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
	     var bg_iframe = document.getElementById("foxTab_iframe_groups") // only linux
	     if (animate) {
			   t2 = new FoxTab_Tween(bg_iframe.style,'left',false,parseFloat(bg_iframe.style.left),5,0.6,'px');
			   t2.start();
		  } else {
		     bg_iframe.style.left = "5px"
		  }	   
	   }
	   foxTabWin.isGroupPanelOpen = true;
	},
	/*
	 *
	 */
	closeGroupPanel : function() {
	   var div = document.getElementById("foxTab_div_groups_panel")
	   t1 = new FoxTab_Tween(div.style,'left',true,parseFloat(div.style.left),-255,0.6,'px');
	   t1.start();
	   t1.onMotionFinished = function(){
			if (foxTabWin.wo.pref.groupClearFilter) foxTabWin.clearAllFilter();
			foxTabWin.foxTabFlash.execute("","groupPanelClosed")
	   };
	   if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
			var bg_iframe = document.getElementById("foxTab_iframe_groups") // only linux
			t2 = new FoxTab_Tween(bg_iframe.style,'left',true,parseFloat(bg_iframe.style.left),-255,0.6,'px');
	  	    t2.start();	   
	   }   
	   foxTabWin.isGroupPanelOpen = false;
	},
	/*
	 *
	 */
	clearAllFilter : function() {
		var tabsList = foxTabWin.wo.tabsList
		var list = new Array();
		for(var i=0; i<tabsList.length; i++) {
			if (tabsList[i].visible) {
				tabsList[i].groupFilter = false
				list.push(i);
			}
		}
		var textbox = document.getElementById("foxTab_filter_textbox")
		textbox.value = ""
		textbox.style.color = "#" + foxTabWin.wo.pref.titleColor
		foxTabWin.foxTabFlash.execute("","filterTabs",list.join("^"))
	},
	/*
	 *
	 */
	onGroupPanelScroll : function(evt) {
			if (foxTabWin.groupParams!=null) {
				 if (evt.detail>0) {
					 foxTabWin.groupScroll(15, true);
				 } else {
					 foxTabWin.groupScroll(-15, true);
				 }
			} else {
				foxTabWin.foxTabFlash.onMouseWheel(evt);
			}
	},
	/*
	 *
	 */
	groupScrollUp : function() {
		foxTabWin.groupScroll(-15);
	},
	/*
	 *
	 */
	groupScrollDown : function() {
		foxTabWin.groupScroll(15);
	},
	/*
	 *
	 */
	groupScroll : function(delta, disableTween) {
		var g = foxTabWin.groupParams

		var groupScrollDiv = document.getElementById("groupScrollDiv")
		var scrollDivTop = parseFloat(groupScrollDiv.style.top);
		scrollDivTop += delta
		if (scrollDivTop<0) scrollDivTop = 0;
		 else if (scrollDivTop>g.scrollHeight - g.scrollDivHeight-2) scrollDivTop = g.scrollHeight - g.scrollDivHeight-2
		var groupTable = document.getElementById("groupTable")
		var groupScroll = -1 * (g.totalHeight) * (scrollDivTop/g.scrollHeight)
			groupScrollDiv.style.top = scrollDivTop + "px"
			groupTable.style.top= groupScroll + "px"
	},


	/*
	 *
	 */
	setGroupPanel : function(selectedGroupIndex) {

		   var f = foxTabWin
		   var inGroupList = function(url) {
				for(var i=1; i<f.groupList.length; i++) {
					if (f.groupList[i].d==url) {
						return i;
					}
				}
				return -1;
		   }

		   var div = document.getElementById("foxTab_div_groups_panel")

		   var rowHeight = 30
		   if (selectedGroupIndex==null) selectedGroupIndex = 0;
		   f.lastGroupIndex = selectedGroupIndex
		   
		   if (f.groupList!=null) f.groupList.length = 0;
		   f.groupList = new Array();		
		   f.groupList.push({d:"All", indices:new Array()})
		   var tabsList = foxTabWin.wo.tabsList
		   for (var i=0;i<tabsList.length;i++) {
			    if (tabsList[i].visible) {
					var currentBrowser = tabsList[i].tabBrowser
					if (currentBrowser.contentDocument) {
						try {
							if (currentBrowser.contentDocument.domain) {
								var domainName  = f.getDomainName(currentBrowser.contentDocument.domain)
							} else domainName = "Blank"
						}catch(e){
							domainName = "Unknown"
						}
					} else domainName = "Blank"
					var index = inGroupList(domainName)

					f.groupList[0].indices.push(i)
					if (index==-1) {
						f.groupList.push({d:domainName, indices:[i]})
					} else {
						f.groupList[index].indices.push(i);
					}
			    }
		   }
		   // sort by name
		   if (f.wo.pref.sortGroupByName) {
				f.groupList.sort(function(a, b){
					if (a.d=="All") return -1 
					  else if (b.d=="All") return 1 
					     else return a.d > b.d
				})
		   }

		   var totalHeight = (rowHeight * f.groupList.length) + 50 + 2 + f.groupList.length-1

		   var winWidth  = foxTabWin.wo.windowBoxObject.width
		   var winHeight = foxTabWin.wo.windowBoxObject.height
		   var top = winHeight/2 - totalHeight/2

		   div.style.left   = "-255px"
		   div.style.top    = "40px"
		   div.style.width  = "240px"
		   if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
		   }
		   if (totalHeight>winHeight - 105 ) {

			   foxTabWin.groupParams = {}
			   var totalHeight     = totalHeight - 50 - 2
			   var groupsHeight	   = (winHeight - 145)
			   var scrollWidth     = 10
			   var scrollHeight    = groupsHeight - 20

			   var scrollDivHeight = (groupsHeight/totalHeight) * scrollHeight

			   foxTabWin.groupParams.totalHeight = totalHeight
			   foxTabWin.groupParams.groupsHeight = groupsHeight
			   foxTabWin.groupParams.scrollHeight = scrollHeight
			   foxTabWin.groupParams.scrollDivHeight = scrollDivHeight
				
			   var divStyle  = 'style="overflow-y:hidden;height:'+ groupsHeight +'px"'
			   var scrollDiv = '<html:table cellPadding="0" cellSpacing="0" style="border-collapse: collapse;"><html:tr><html:td height="10" background="chrome://foxtab/skin/images/groupsPanel/scroll_top.png" onclick="foxTabWin.groupScrollUp();" style="cursor:pointer"></html:td></html:tr><html:tr><html:td bgcolor="#303030" height="'+scrollHeight+'" valign="top"><html:div id="groupScrollDiv" style="position:relative;top:0px;width:'+ scrollWidth +'px;height:'+ scrollDivHeight +'px;background-color:#000000"></html:div></html:td></html:tr><html:tr><html:td height="10" background="chrome://foxtab/skin/images/groupsPanel/scroll_bottom.png" onclick="foxTabWin.groupScrollDown();" style="cursor:pointer"></html:td></html:tr></html:table>'
			   scrollHtml	 = '<html:td valign="top" width="'+ scrollWidth +'"><html:div>'+ scrollDiv +'</html:div></html:td>'
			   var maxDomainLength = 16;
		   } else {
			   foxTabWin.groupParams = null
			   divStyle = ""
			   scrollHtml = ""
			   var maxDomainLength = 17;
		   }

		   var groupsHTML = '<html:table width="237" cellPadding="0" cellSpacing="0" style="border-collapse: collapse;">'

						  + '<html:tr><html:td valign="top"><html:div '+ divStyle +'><html:table id="groupTable" cellPadding="0" cellSpacing="0" style="position:relative;top:0px;border-collapse: collapse;">'
						for (var i=0;i<f.groupList.length;i++) {
						  if (i==selectedGroupIndex) {
							arrowColor = "blue"
							icoImg = ""
						  } else {
							arrowColor = "green"
							if (f.groupList[i].d!="Blank") {
								path = 'http://www.'+ f.groupList[i].d+'/favicon.ico'
							  } else {
								path = 'chrome://foxtab/skin/images/groupsPanel/blank_icon.png'
							}
							icoImg ='<image src="'+ path +'" width="16" height="16" hspace="0" align="left" valign="top" border="0" style="outline: none;display:block"/>'
						  }
						  var domainName = f.groupList[i].d
						  if (domainName.length>maxDomainLength) domainName = domainName.substring(0,maxDomainLength)+"..."

						  groupsHTML	+= '<html:tr style="cursor:pointer" ondblclick="foxTabWin.onGroupItemDbClick('+ i +')" onmousedown="foxTabWin.onGroupItemClick('+ i +')" xonmouseover="this.style.backgroundColor=\'#ffffff\'" xonmouseout="this.style.backgroundColor=\'\'">'
										+  '<html:td width="20" height="16" valign="center" style="padding-left:15px">'+ icoImg +'</html:td>'
										+  '<html:td height="16" class="panel_text" valign="top">'+ domainName +' ('+ f.groupList[i].indices.length+')'
										+  '<html:img id="groups_arrow'+i+'" src="chrome://foxtab/skin/images/groupsPanel/'+ arrowColor +'_arrow.png" width="6" height="9" style="margin-left:7px"/></html:td>'

						  groupsHTML	+= '</html:tr>'
						  if (i<f.groupList.length-1) {
						  }
						}
		   groupsHTML	+= '</html:table></html:div></html:td>'

		   groupsHTML	+= scrollHtml
		   groupsHTML	+= '</html:tr></html:table>'

		   var panelHTML = '<html:table width="240" cellPadding="0" cellSpacing="0" style="border-collapse: collapse;">'
						    + '<html:tr><html:td width="240" height="23" class="panel_top_td"></html:td>'
						    + '<html:td width="10" valign="center" align="left" rowspan="4" style="padding:0px;margin:0px;"><html:img src="chrome://foxtab/skin/images/groupsPanel/close_white.png" title="Close panel." onclick="foxTabWin.closeGroupPanel()" onmouseover="this.src=\'chrome://foxtab/skin/images/groupsPanel/close_gray.png\'" onmouseout="this.src=\'chrome://foxtab/skin/images/groupsPanel/close_white.png\'" style="cursor:pointer;padding:0px;margin:0px;" width="10" height="90" hspace="0" vspace="0" align="left" valign="top"/></html:td></html:tr>'
						    + '<html:tr><html:td width="240" class="panel_middle_td">'+ groupsHTML +'</html:td></html:tr>'
						    + '<html:tr><html:td width="240" height="23" class="panel_bottom_td"></html:td></html:tr>'
						 + '</html:table>'

		   div.innerHTML = panelHTML
		   div.style.display = ''
	},
	/*
	 *
	 */
	setFilterTextBoxPosition : function(posX, posY, width, height) {

	   var div = document.getElementById("foxTab_div_filter_text")

	   var delta = 0;
	   var width = width - 0
	   var textbox_width  = (width * 8/10) - (delta * 5)
	   var textbox_height = 30

	   var textbox_width  = 226

	   posX = (posX-0) + ((width-textbox_width)/2) - 2 + delta +3;
	   posX = Math.round(posX)


	   posY = (posY-0) + ((height-textbox_height)/2) - 4 + 7

	   div.style.left = posX +"px"
	   div.style.top  = posY +"px"
	   if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
	   }
	   var _iframe = document.getElementById("foxTab_div_filter_text")
	   _iframe.style.left = posX +"px"
	   _iframe.style.top  = posY +"px"
	   _iframe.style.width  = textbox_width +"px"
	   _iframe.style.height = textbox_height +"px"
	   _iframe.style.display = 'block'

	   var textbox = document.getElementById("foxTab_filter_textbox")
	   textbox.style.display = ''
	   textbox.style.color = "#" + foxTabWin.wo.pref.titleColor

	   textbox.style.width  = textbox_width +"px"

	   textbox.style.height = textbox_height +"px"

	   window.focus();
	   var g = setTimeout(foxTabWin.setFilterTextBoxToFocus,50); // workaround for textbox.focus();
	   
	   foxTabWin.isFilterTextBoxOpen = true;
	},
	/*
	 *
	 */
	setFilterTextBoxToFocus : function() {
	   var textbox = document.getElementById("foxTab_filter_textbox")
		textbox.focus();
	},
	/*
	 *
	 */
	hideFilterTextBox : function() {
	   var textbox = document.getElementById("foxTab_filter_textbox")
	   textbox.style.display = 'none'
	   if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
		   var bg_iframe = document.getElementById("foxTab_iframe_filter_text")
		   bg_iframe.style.display = 'none'
	   }
	   foxTabWin.isFilterTextBoxOpen = false;
	},
	/*
	 *
	 */
	filterBoxKeyUp : function(textBox, event) {
		switch (event.keyCode) {
			case event.DOM_VK_DOWN:
			case event.DOM_VK_RIGHT:
			case event.DOM_VK_LEFT:
			case event.DOM_VK_UP:
			case event.DOM_VK_CONTROL:
			case event.DOM_VK_ALT:
			case event.DOM_VK_TAB:
			case event.DOM_VK_SHIFT:
			break;
			default:
				if (foxTabWin.filterInterval!=null) {
					clearInterval(foxTabWin.filterInterval);
				}
				foxTabWin.filterInterval = setTimeout(foxTabWin.filterTabs, 50, textBox.value);
			break;
		}
	},
	/*
	 *
	 */
	filterTabs : function(text) {
		var resultTabsList = foxTabWin.wo.filterTabsByText(text);

		var textBoxStyle = document.getElementById("foxTab_filter_textbox").style
		if (resultTabsList.length == 0) {
			textBoxStyle.color = "#DA7272"
		} else {
			textBoxStyle.color = "#" + foxTabWin.wo.pref.titleColor
		}
		foxTabWin.foxTabFlash.execute("","filterTabs",resultTabsList.join("^"))
	},
	/*
	 *
	 */
	openSearchPanel : function() {
		if (foxTabWin.isFilterTextBoxOpen) {
			var textbox = document.getElementById("foxTab_filter_textbox")
			textbox.focus();			
		} else {
			foxTabWin.foxTabFlash.execute("","openSearchPanel")
		}
	},
	/*
	 *
	 */
	closeSearchPanel : function() {
		foxTabWin.foxTabFlash.execute("","closeSearchPanel")
	},
	/*
	 *
	 */
	closeTab : function(windowId, windowIndex, tabIndex) {
			var closeByWindow = function(url, foxTabObject) {
				
				var browser = foxTabObject.gBrowser
				var numTabs = browser.tabContainer.childNodes.length;
				var currentBrowser, url;
				var tabsToRemove = new Array();


				for(var j=0; j<numTabs; j++) {
				   currentBrowser = browser.getBrowserAtIndex(j);
				   if (url==currentBrowser.currentURI.spec) {
						tabsToRemove.push(browser.tabContainer.childNodes[j]);
				   }						   
				}

				for (var j=0;j<tabsToRemove.length;j++) {
					if (browser.tabContainer.childNodes.length==1) {
						foxTabObject.win.close();
					} else {
						browser.removeTab(tabsToRemove[j])
					}
				}				
			}
			/////////////////////////////////////////////////////

			var browser    = foxTabWin.wo.tabsList[tabIndex].tabBrowser

			if (!foxTabWin.wo.pref.hideDuplicateTabs) {
				 var foxTabObject = foxTabWin.wo.getWindowById(windowId-0);
				 if (foxTabObject!=null) {
					 if (foxTabObject.gBrowser.tabContainer.childNodes.length==1) {
						 foxTabObject.win.close();
					 } else {
						 foxTabObject.gBrowser.removeTab(foxTabWin.wo.tabsList[tabIndex].tab)
					 }
				 }
			} else {
				var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
				var url		   = browser.currentURI.spec

				if (foxTabWin.wo.pref.multipleWindows) {
					for (var i=0;i<foxTabList.length;i++) {
						closeByWindow(url, foxTabList[i]);
					}
				} else {
					closeByWindow(url, foxTabWin.wo);
				}
			}
	},
	/*
	 *
	 */
	onCommand : function(evt,args) {
		var params = args.split("^");
		switch (params[0].toLowerCase()) {
			case "close":
					 foxTabWin.closeFoxTab();
					break;	
			case "open_options":
					 foxTabWin.wo.openOptions();
			break;		
			case "top_sites_edit":
					var f =  foxTabWin.wo;
					f.openFoxTab(f.LAUNCH_MODE_INTERACTIVE, f.MODE_NEW_TAB);

					document.getElementById("wallSizeButtonsContainer").style.display='block';
					document.getElementById("wallThemeIcon").style.display='block';
					document.getElementById("wallEditButton").setAttribute("class", "editButton save");
					foxTabWin.openFoxTabOnEditFinished = true;
					foxTabWin.startEditMode();
			break;		


			
			case "bookmark_this_tab":
				
			break;				
			case "open_in_a_new_tab":
				 switch (foxTabWin.wo.PAGES_MODE) {
					case foxTabWin.wo.MODE_TOP_SITES:
					case foxTabWin.wo.MODE_RECENTLY_CLOSED:
						 var b = foxTabWin.wo.gBrowser;
						 var url = foxTabWin.wo.tabsList[params[3]].url
						 b.selectedTab = b.addTab(url)
						 foxTabWin.closeFoxTab();
					break;
					default:
						foxTabWin.closeFoxTab();
						var foxTabObject = foxTabWin.wo.getWindowById(params[1]);
						if (foxTabObject!=null) {
							 var b = foxTabObject.gBrowser
							 var currentBrowser = foxTabWin.wo.tabsList[params[3]].tabBrowser
							 b.selectedTab = b.addTab(currentBrowser.currentURI.spec)
							 if (foxTabObject!=foxTabWin.wo) foxTabObject.win.focus();
						}
				}
			break;			
			case "open_tab_in_new_window":
					if (foxTabWin.wo.isTabsPagesMode()) {
						foxTabWin.closeFoxTab();
						var foxTabObject = foxTabWin.wo.getWindowById(params[1]);
						if (foxTabObject!=null) {
							 var b = foxTabObject.gBrowser
							 var currentBrowser = foxTabWin.wo.tabsList[params[3]].tabBrowser
							 window.open(currentBrowser.currentURI.spec)	
						}
					} else {
						 window.open(foxTabWin.wo.tabsList[params[3]].url)
					}
			break;		
			case "remove_from_a_top_sites":
					var index = params[3];
					foxTabWin.wo.removeTopSite(index);

				    if ((foxTabWin.wo.isFlashOpen) && (!foxTabWin.wo.isTabsPagesMode())) {
							 var resultTabsList = new Array();
							 var tabsList = foxTabWin.wo.tabsList;
							 for(var i=0; i<tabsList.length; i++) {
								if (i==index) {
									tabsList[i].visible = false
								}

								if (tabsList[i].visible) {
									resultTabsList.push(i);
								}
							 }
							 foxTabWin.wo.foxTabWin.foxTabFlash.execute("","filterTabs",resultTabsList.join("^"))
					}

			break;			
			case "close_tab":
					if (foxTabWin.wo.isTabsPagesMode()) {
						foxTabWin.closeTab(params[1], params[2], params[3])
					}
			break;
			case "set_text_position":
					if (foxTabWin.wo.pref.siteTitle) foxTabWin.setTextPosition(params[1], params[2], params[3], params[4], params[5]);
			break;
			case "set_filter_textbox_position":
					foxTabWin.setFilterTextBoxPosition(params[1], params[2], params[3], params[4]);
			break;
			case "hide_filter_textbox":
					foxTabWin.hideFilterTextBox();
					if (params[1]=="1") { // remove also group panel
						var div = document.getElementById("foxTab_div_groups_panel")
						div.style.display='none'
						if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
							 var bg_iframe = document.getElementById("foxTab_iframe_groups") // only linux
						  	 bg_iframe.style.display='none'
						}
					}
			break;
			case "filter_textbox_closed":
				  if (foxTabWin.wo.pref.findClearFilter) foxTabWin.clearAllFilter();
			break;
			case "hide_title":
			        document.getElementById("foxTab_div_text").style.display = "none"
			break;
			case "mode_change":
					var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
					 switch (foxTabWin.wo.PAGES_MODE) {
						case foxTabWin.wo.MODE_TOP_SITES:
							ffPreferences.setCharPref("foxTab.topSiteMode", params[1]);
							var pref = "topSiteMode";
						break;
						case foxTabWin.wo.MODE_RECENTLY_CLOSED:
							ffPreferences.setCharPref("foxTab.recentlyClosedMode", params[1]);
							var pref = "recentlyClosedMode";
						break;
						default:
							ffPreferences.setCharPref("foxTab.mode", params[1]);
							var pref = "mode";
					}

					
					var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
					for (var i=0;i<foxTabList.length;i++) {
					  foxTabList[i].pref[pref] = params[1]-0
					}
			break;
			case "full_screen":

			break;
			case "show_hide_group_panel":
					if (!foxTabWin.isGroupPanelOpen) {		
						foxTabWin.setGroupPanel();
						foxTabWin.openGroupPanel(true);
					} else {
						foxTabWin.closeGroupPanel();
					}
			break;
			case "open_welcome":
						 foxTabWin.wo.gBrowser.selectedTab = foxTabWin.wo.gBrowser.addTab("http://www.foxtab.com/welcome/")	
			break;
			case "set_mode_view_params":
						var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
						ffPreferences.setCharPref("foxTab.layout.carouselParams", params[1]);
						ffPreferences.setCharPref("foxTab.layout.rowParams", params[2]);
						ffPreferences.setCharPref("foxTab.layout.slidesParams", params[3]);
						ffPreferences.setCharPref("foxTab.layout.pageFlowParams", params[4]);
						ffPreferences.setCharPref("foxTab.layout.wallParams", params[5]);
						ffPreferences.setCharPref("foxTab.layout.gridParams", params[6]);

						var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
						for (var i=0;i<foxTabList.length;i++) {
						   foxTabList[i].pref.carouselParams = params[1]
						   foxTabList[i].pref.rowParams      = params[2]
						   foxTabList[i].pref.slidesParams   = params[3]
						   foxTabList[i].pref.pageFlowParams = params[4]
						   foxTabList[i].pref.wallParams     = params[5]
						   foxTabList[i].pref.gridParams     = params[6]
						}
			break;


			case "set_theme_item":
						var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
						for (var i=0;i<foxTabList.length;i++) {
							if (foxTabList[i].foxTabWin!=null) {
								if (foxTabList[i].foxTabWin.foxTabFlash!=null) {
									foxTabList[i].foxTabWin.foxTabFlash.execute("","setThemeItem", 
																				params[1],
																				params[2])
								}
							}

						}
			break;

			case "set_theme":
						var f = foxTabWin.wo;
						var themeStr = params[1] + "," + params[2] + "," + params[3] + "," + params[4]
						var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
						
						var mode = "";
						if (f.PAGES_MODE==f.MODE_RECENTLY_CLOSED) {
							mode = ".rc"
						}
						if ((f.PAGES_MODE==f.MODE_TOP_SITES) || (f.PAGES_MODE==f.MODE_NEW_TAB)) {
							mode = ".ts"
						}
						ffPreferences.setCharPref("foxTab.theme"+mode, themeStr);
						ffPreferences.setCharPref("foxTab.theme"+mode+".titleColor", params[5]);
						ffPreferences.setCharPref("foxTab.theme"+mode+".useTheme", params[6]);
						ffPreferences.setCharPref("foxTab.theme"+mode+".customColors", params[7]);

						var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
						for (var i=0;i<foxTabList.length;i++) {
							 switch (f.PAGES_MODE) {
								case f.MODE_NEW_TAB:
								case f.MODE_TOP_SITES:
									foxTabList[i].pref.themeTS = themeStr
								break;
								case f.MODE_RECENTLY_CLOSED:
									foxTabList[i].pref.themeRC = themeStr
								break;
								default:
									foxTabList[i].pref.theme   = themeStr
							}
							
							foxTabList[i].pref.titleColor   = params[5]
							foxTabList[i].pref.useTheme     = params[6]
							foxTabList[i].pref.customColors = params[7]

							if (foxTabList[i].foxTabWin!=null) {
								if (foxTabList[i].foxTabWin.foxTabFlash!=null) {
									foxTabList[i].foxTabWin.foxTabFlash.execute("","setTheme", 
																				params[1],
																				params[2],
																				params[3],
																				params[4])
								}
							}

						}
						document.getElementById("foxTab_siteTitle").style.color = "#" + foxTabWin.wo.pref.titleColor
						document.getElementById("foxTab_filter_textbox").style.color = "#" + foxTabWin.wo.pref.titleColor
						

			break;
			case "set_background_image":
						foxTabWin.saveBackgroundImage(params[1]);
			break;
			case "browse_background_image":
						foxTabWin.browseBackgroundImage();
			break;
			case "clear_background_image":
						var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
						ffPreferences.setBoolPref("foxTab.theme.displayBgImage", false);
						foxTabWin.removeBackgroundImage();
			break;
			case "clear_first_launch":
						var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
						ffPreferences.setBoolPref("foxTab.isFirstLaunch", false);
							

						var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
						for (var i=0;i<foxTabList.length;i++) {
							foxTabList[i].pref.isFirstLaunch     = false
							if (foxTabList[i]!=foxTabWin.wo) {
								if (foxTabList[i].foxTabWin!=null) {
									if (foxTabList[i].foxTabWin.foxTabFlash!=null) {
										foxTabList[i].foxTabWin.foxTabFlash.execute("","clearFirstLaunch");
									}
								}
							}
						}
			break;
			case "right_panel_open":
						foxTabWin.rightPanelOpen = true
						 document.getElementById("foxTab_div_text").style.display = "none"
			break;	
			case "right_panel_closed":
						foxTabWin.rightPanelOpen = false
						foxTabWin.isThemeOpen = false;
			break;		
			case "share":
						foxTabWin.wo.gBrowser.selectedTab = foxTabWin.wo.gBrowser.addTab(params[1])	
			break;	
			case "add_to_top_sites":
				var index = params[2];
				var b = foxTabWin.wo.gBrowser.getBrowserAtIndex(index);
				foxTabWin.wo.addBrowserToTopSites(b);
			break;

			case "set_pages_mode":
				var f = foxTabWin.wo;
				var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
				if (params[1]=="0") {
					var themeList = f.pref.themeTS.split(",");
					foxTabWin.foxTabFlash.execute("","setTheme", themeList[0], themeList[1], themeList[2], themeList[3]);
					ffPreferences.setCharPref("foxTab.lastPagesMode", f.MODE_TOP_SITES);
					f.pref.lastPagesMode = f.MODE_TOP_SITES;
					f.openTopSites(f.MODE_TOP_SITES);
				} else if (params[1]=="1") {
					var themeList = f.pref.themeRC.split(",");
					foxTabWin.foxTabFlash.execute("","setTheme", themeList[0], themeList[1], themeList[2], themeList[3]);
					ffPreferences.setCharPref("foxTab.lastPagesMode", f.MODE_RECENTLY_CLOSED);
					f.pref.lastPagesMode = f.MODE_RECENTLY_CLOSED;
					f.openRecentlyClosed(f.MODE_RECENTLY_CLOSED);
				} else if (params[1]=="2") {
					var themeList = f.pref.theme.split(",");
					foxTabWin.foxTabFlash.execute("","setTheme", themeList[0], themeList[1], themeList[2], themeList[3]);
					ffPreferences.setCharPref("foxTab.lastPagesMode", f.MODE_TABS);
					f.pref.lastPagesMode = f.MODE_TABS;
					f.openFoxTab(f.LAUNCH_MODE_INTERACTIVE, f.MODE_TABS);
				}
			break;	
			case "open_top_sites_help":
				foxTabWin.wo.openTopSitesHelpPage();
			break;

		}
	},
 	onBackgroundImageSaved : function() {

		var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
		for (var i=0;i<foxTabList.length;i++) {
			if (foxTabList[i].foxTabWin!=null) {
				if (foxTabList[i].foxTabWin.foxTabFlash!=null) {
					foxTabList[i].foxTabWin.foxTabFlash.execute("","backgroundImageSaved", foxTabWin.wo.FOXTAB_DIR + "bg_image.png")
					foxTabList[i].pref.displayBgImage = true;
				}
			}
		}

		var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		ffPreferences.setBoolPref("foxTab.theme.displayBgImage", true);
	},
 	onBackgroundImageError : function() {
		foxTabWin.foxTabFlash.execute("","backgroundImageError")
	},
	removeBackgroundImage : function() {
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		try {
			file.initWithPath(foxTabWin.wo.FOXTAB_DIR + "bg_image.png");
			file.remove(false);
		} catch (e) {
		}

		var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
		for (var i=0;i<foxTabList.length;i++) {
			if (foxTabList[i].foxTabWin!=null) {
				if (foxTabList[i].foxTabWin.foxTabFlash!=null) {
					foxTabList[i].foxTabWin.foxTabFlash.execute("","clearBackgroundImage")
					foxTabList[i].pref.displayBgImage = false;
				}
			}
		}
	},
	browseBackgroundImage : function() {
		const nsIFilePicker = Components.interfaces.nsIFilePicker;

		var fp = Components.classes["@mozilla.org/filepicker;1"]
					   .createInstance(nsIFilePicker);
		fp.init(window, "Select Image", nsIFilePicker.modeOpen);
		fp.appendFilters(nsIFilePicker.filterImages);

		var rv = fp.show();
		var path = ""
		if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
		  var file = fp.file;
		  var path = fp.file.path;
		  url = path;
		}
		if (path=="") {
			foxTabWin.onBackgroundImageError();
		} else {
			foxTabWin.saveBackgroundImage(path, true);
		}
	},
	saveBackgroundImage : function(url, localPath) {
		var file = Components.classes["@mozilla.org/file/local;1"]  
					.createInstance(Components.interfaces.nsILocalFile);  
		file.initWithPath(foxTabWin.wo.FOXTAB_DIR + "bg_image.png");  
		var wbp = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1']  
				  .createInstance(Components.interfaces.nsIWebBrowserPersist);  
		var ios = Components.classes['@mozilla.org/network/io-service;1']  
				  .getService(Components.interfaces.nsIIOService);  
		

		if (localPath) {
			if (url.indexOf("file://")==-1)  url = "file:///" + url
		} else {
			if ((url.indexOf("http://")==-1) && (url.indexOf("https://")==-1) && (url.indexOf("ftp://")==-1) && (url.indexOf("chrome://")==-1)) {
				if ((url.indexOf(".com")==-1) && (url.indexOf("www")==-1)) {
					if (url.indexOf(":\\")<3) url = "file:///" + url
					 else url = "http://" + url
				} else {
					url = "http://" + url
				}
			}
		}

		try {
			
			 var uri = ios.newURI(url, null, null); 
			 wbp.progressListener = {
			  onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
				if (aCurTotalProgress>=aMaxTotalProgress) {
					foxTabWin.onBackgroundImageSaved();
				}
			  },
			  onStateChange: function(aWebProgress, aRequest, aStatus, aMessage) {
				  if (aMessage==2152398878) {
						foxTabWin.onBackgroundImageError();
				  }
			   }
			 }
			 wbp.saveURI(uri, null, null, null, null, file);
		} catch (e) {
			 foxTabWin.onBackgroundImageError();
		}
	},


	/*
	 *
	 */
	wallMouseMove : function(e) {
		foxTabWin.foxTabFlash.execute("","onJSMouseMoves",e.clientX, e.clientY)
	},
	/*
	 *
	 */
	wallMouseDown : function(e) {
		if ((e.target.id!="searchBoxText") && (e.target.id!="searchBoxText")) {
			if (e.target.as==null) {
				foxTabWin.foxTabFlash.execute("","onJSMouseDown",e.clientX, e.clientY, e.button);
			}
		}
	},
	/*
	 *
	 */
	staticWallBlockMouseOver : function(index) { 
	    /*if (foxTabWin.editMode!=true) {
			var ts = foxTabWin.wo.getTopSites();
			if (index<ts.topSites.length) {
				for (var i=0;i<ts.topSites.length;i++) {
				  if (index==i) {
					  if (ts.topSites[i]!=null) {
							var tooltip = document.getElementById("block_tooltip");
							if (ts.topSites[i].title!="") {
								tooltip.innerHTML = ts.topSites[i].title
								tooltip.style.display = '';
							}
						  return;

					  }
				  }
				}
			}
		}*/
	},
	/*
	 *
	 */
	staticWallBlockMouseOut : function() { 
		var tooltip = document.getElementById("block_tooltip");
		tooltip.style.display = 'none';
	},
	/*
	 *
	 */
	staticWallBlockClicked : function(index, button) { 
	    var ts = foxTabWin.wo.getTopSites();
		if (index<ts.topSites.length) {
			for (var i=0;i<ts.topSites.length;i++) {
			  if (index==i) {
				  if (ts.topSites[i]!=null) {
					  var b = foxTabWin.wo.gBrowser;
					  if (button==0) {
						  b.selectedBrowser.loadURI(ts.topSites[i].url);
						  foxTabWin.closeFoxTab();
					  } else if (button==1) {
						  b.selectedTab = b.addTab(ts.topSites[i].url)
						  foxTabWin.closeFoxTab();
					  }
					  return;
				  }
			  }
			}
		}
	},
	updateTopSites : function(newList) {
		foxTabWin.wo.updateTopSites(newList);
	},
	/*
	 *
	 */
	wallImageSaved : function(type) {
		if (type==1) {
			if (foxTabWin.wallSizeRows!=null) {
				var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
				ffPreferences.setCharPref("foxTab.staticWall.size", foxTabWin.wallSize+"");
				ffPreferences.setCharPref("foxTab.staticWall.rows", foxTabWin.wallSizeRows+"");
				ffPreferences.setCharPref("foxTab.staticWall.columns", foxTabWin.wallSizeColumns+"");

				var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
				for (var i=0;i<foxTabList.length;i++) {
				   foxTabList[i].pref.staticWallSize	 = ffPreferences.getCharPref("foxTab.staticWall.size");
				   foxTabList[i].pref.staticWallRows	 = ffPreferences.getCharPref("foxTab.staticWall.rows");
				   foxTabList[i].pref.staticWallColumns  = ffPreferences.getCharPref("foxTab.staticWall.columns"); 
				}
			}
			if (foxTabWin.isThemeOpen==true) {
				foxTabWin.isThemeOpen = false;
				foxTabWin.foxTabFlash.execute("","openThemeSelection")
			}
			if (foxTabWin.openFoxTabOnEditFinished) {
				foxTabWin.openFoxTabOnEditFinished = null;
				var f = foxTabWin.wo;
				f.openFoxTab(f.LAUNCH_MODE_INTERACTIVE, f.MODE_TOP_SITES);
				foxTabWin.disableEdit = false;
			} else {
				foxTabWin.openStaticWall(true);
				var i = setTimeout(function() {
					foxTabWin.foxTabFlash.execute("","clearEditMode")
					foxTabWin.disableEdit = false;
				}, 1000);
			}

		} else {
			if (document.getElementById("foxTab_static_wall").initialized!=null) {
				foxTabWin.openStaticWall(true);
			}
			foxTabWin.wo.onWallImageSaved();
		}
	},
	/*
	 *
	 */
	startEditMode : function(e) {
		foxTabWin.wallSizeRows    = null;
		foxTabWin.wallSizeColumns = null;
		foxTabWin.wallSize        = null;
		foxTabWin.editMode = true;	
		var wallImages = foxTabWin.wo.getStaticWallImagesString();
		foxTabWin.foxTabFlash.execute("","startEditMode", wallImages);
		document.getElementById("foxTab_static_wall").innerHTML = "";
	},
	/*
	 *
	 */
	stopEditMode : function(e) {
		var f = foxTabWin.wo;
		


		foxTabWin.disableEdit = true;
		var stageWidth  = foxTabWin.wo.windowBoxObject.width;
		var stageHeight = foxTabWin.wo.windowBoxObject.height;

		var img = document.createElement("div");
		img.setAttribute("class", "wallSavingMessage");
		document.getElementById("foxTab_static_wall").appendChild(img);	
		img.style.left = (stageWidth/2 - 186/2) +"px";
		img.style.top = (stageHeight/2 - 89/2 - 40) +"px";


		foxTabWin.editMode = null;	
		var dir = f.getTopSitesDir();
		var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	  	aFile.initWithPath(dir);
		aFile.append("wall")
		if(aFile.exists()) {
		     aFile.remove(true);
		}	
		aFile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
		foxTabWin.foxTabFlash.execute("","stopEditMode")
	},
	/*
	 *
	 */
	setStaticWallSize : function(rows, columns, size) {
		foxTabWin.wallSizeRows    = rows;
		foxTabWin.wallSizeColumns = columns;
		foxTabWin.wallSize        = size;
		foxTabWin.foxTabFlash.execute("","setRowsCols", rows, columns)
	},
	/*
	 *
	 */
	clearStaticWall : function() {
		document.getElementById("foxTab_static_wall").innerHTML = "";
		document.getElementById("foxTab_static_wall_overlay").innerHTML = "";
		document.getElementById("foxTab_static_wall").initialized = null;
		document.getElementById("block_tooltip").style.display="none";
		//document.getElementById("foxTab_static_wall_header").style.display = 'none';
		document.getElementById("foxTab_static_wall_search").style.display = 'none';
		if (document.getElementById("newtab-homepage-link")) {
			document.getElementById("newtab-homepage-link").style.display = 'none';
			document.getElementById("newtab-homepage-remove").style.display = 'none';
		}
		document.removeEventListener('mousemove', foxTabWin.wallMouseMove, false);
		document.removeEventListener('mousedown', foxTabWin.wallMouseDown, false);
		document.mouseMoveInitialized = null;

	},
	/*
	 *
	 */
	openStaticWall : function(force) {
		
		var tileX = 3;
		var tileY = 3;
		var counter = 1;

		var stageWidth  = foxTabWin.wo.windowBoxObject.width;
		var stageHeight = foxTabWin.wo.windowBoxObject.height; //width * (window.screen.width/window.screen.height);
		if (foxTabWin.wo.pref.enableSearch) {
			var SEARCH_BOX_HEIGHT = 55;
		} else {
			var SEARCH_BOX_HEIGHT = 0;
		}
		stageHeight -= SEARCH_BOX_HEIGHT;
		var wallSize = foxTabWin.wo.getStaticWallSize();
		
		var scale = stageWidth/window.screen.width;
		var THUMB_RATIO = 3/4.9;
		var wallNumOfX  = wallSize.rows;
		var wallNumOfY  = wallSize.columns;
		var wallWidth   = window.screen.width - (30 * 2);
		var blockWidth  = (wallWidth - (13 * (wallNumOfX-1))) / wallNumOfX
		var blockHeight = blockWidth*THUMB_RATIO
		var factor      = wallSize.factor;
		var wallHeight  = (blockHeight * wallNumOfY) + (13 * (wallNumOfY-1)) + factor*2
		wallHeight      = wallHeight * (scale);
		
		var wallLeft = 0;
		var wallTop  = 0;
		var heightDelta = 0;
		if (wallHeight + heightDelta>stageHeight) {
			ratio = (stageHeight/(wallHeight + heightDelta));
			scale      *= ratio;

			wallWidth =  (blockWidth * wallNumOfX) + (13 * (wallNumOfX-1)) + (30 * 2)
			wallWidth = wallWidth * scale
			wallLeft = stageWidth/2 - wallWidth/2;
			stageWidth  = stageWidth * ratio; 
			wallTop = 10;
		} else {
			wallLeft = 0;
			wallTop = (stageHeight/2 - wallHeight/2) + 10;
		}

		var tileWidth  = (stageWidth)/tileX;
		var tileHeight = tileWidth * (window.screen.height/window.screen.width)
		var dir = foxTabWin.wo.getTopSitesDir();
		
		wall = document.getElementById("static-wall");
		if (wall==null) {
			var wall = document.createElement("div");
			wall.setAttribute("id","static-wall");
			wall.style.position = "absolute";
			wall.style.top  = "0px";
			wall.style.left = "0px";
		} else {
			wall.style.width = (tileWidth * tileX) + "px";
			wall.style.height = (tileHeight * tileY) + "px";
		}


		for (var i=0;i<tileX;i++) {
			for (var j=0;j<tileY;j++) {
				
				div = document.getElementById("static-wall" + i+""+j);
				if ((force==null) && (div!=null)) {
					img = div.img;
				} else {
					var div = document.createElement("div");
					div.setAttribute("id","static-wall" + i+""+j);
					var img = document.createElement("image");
					img.setAttribute("src", "file://" + dir + "//wall//wall"+ counter +".png?" + Math.random());
					div.appendChild(img);
					div.img = img;
					wall.appendChild(div);
				}
				img.style.width  = tileWidth + "px";
				img.style.height = tileHeight + "px";
				img.style.border = "0px solid";
				
				div.style.position = "absolute";
				div.style.left = (tileWidth * j) + "px";
				div.style.top  = (tileHeight * i) + "px";

				counter++;
			}
		}
 		
		wall.style.marginLeft = wallLeft + "px";
		wall.style.marginTop  = (wallTop + (SEARCH_BOX_HEIGHT) ) + "px";


		var overlay = document.getElementById("foxTab_static_wall_overlay");
		overlay.style.top = (foxTabWin.wo.windowBoxObject.height - 32) + "px";
		overlay.style.left = "0px";

		var tooltip = document.getElementById("block_tooltip");
		tooltip.style.opacity = "0.9"
		tooltip.style.top  = "5px";
    	tooltip.style.display = 'none';

	    var ts = foxTabWin.wo.getTopSites();

		//document.getElementById("foxTab_static_wall_header").style.display = '';
		document.getElementById("foxTab_static_wall_search").style.display = '';

		if ((force) || (document.getElementById("foxTab_static_wall").initialized==null)){
			document.getElementById("foxTab_static_wall").innerHTML = "";
			document.getElementById("foxTab_static_wall").appendChild(wall);
			document.getElementById("foxTab_static_wall").initialized = true;

			if (ts.topSites.length==0) {
				var emptyWallMessage = document.createElement("div");
				emptyWallMessage.setAttribute("class", "emptyWallMessage");
				emptyWallMessage.setAttribute("id", "emptyWallMessage");
				document.getElementById("foxTab_static_wall").appendChild(emptyWallMessage);	
				emptyWallMessage.style.left = (foxTabWin.wo.windowBoxObject.width/2 - 328/2) +"px";
				emptyWallMessage.style.top  = (stageHeight/2 - 127/2 - 40) +"px";	
				emptyWallMessage.addEventListener('click', function(e) {		
					e.preventDefault();
					e.stopPropagation();				
					foxTabWin.wo.openTopSitesHelpPage();

				}, false);
			} else {
				var emptyWallMessage = document.getElementById("emptyWallMessage")
				if (emptyWallMessage!=null) emptyWallMessage.style.display='none';
			}

		    overlay.innerHTML = "";

		    var editBar = document.createElement("div");
			editBar.setAttribute("class", "editBar");
			overlay.appendChild(editBar);

		    var editBarRight = document.createElement("div");
			editBarRight.setAttribute("class", "editBarRight");
			editBar.appendChild(editBarRight);

		    var editBarBG = document.createElement("div");
			editBarBG.setAttribute("class", "editBarBG");
			editBar.appendChild(editBarBG);

		    var editButton = document.createElement("div");
			editButton.setAttribute("id", "wallEditButton");
			editButton.setAttribute("class", "editButton");

			editButton.addEventListener('click', function(e) {		
				e.preventDefault();
				e.stopPropagation();				
				if (foxTabWin.disableEdit==true) return;

				if (foxTabWin.editMode==null) {
					wallSizeButtonsContainer.style.display='block';
					themeIcon.style.display='block';
					e.currentTarget.setAttribute("class", "editButton save");
					foxTabWin.startEditMode();
				} else {
					wallSizeButtonsContainer.style.display='none';
					themeIcon.style.display='none';
					e.currentTarget.setAttribute("class", "editButton");
					foxTabWin.stopEditMode();
				}

			}, false);
			foxTabWin.editMode = null;
			editBarBG.appendChild(editButton);

		    var wallSizeButtonsContainer = document.createElement("div");
			wallSizeButtonsContainer.setAttribute("id", "wallSizeButtonsContainer");
			wallSizeButtonsContainer.setAttribute("class", "wallSizeButtonsContainer");
			editBarBG.appendChild(wallSizeButtonsContainer);
			wallSizeButtonsContainer.style.display='none';

			var wallSizeButtons = document.createElement("div");
			wallSizeButtons.setAttribute("class", "wallSizeButtons");
			wallSizeButtonsContainer.appendChild(wallSizeButtons);

			var sizeClicked = function(e) {
				var btn = e.currentTarget;
				if (wallSizeButtons.last!=btn) {
					wallSizeButtons.last.setAttribute("class", "wallSizeButtons " + wallSizeButtons.last.size);
					e.currentTarget.setAttribute("class", "wallSizeButtonsSelected " + btn.size);
					wallSizeButtons.last = btn;
				}
				var size = foxTabWin.wo.getStaticWallBySize(btn.size);
				foxTabWin.setStaticWallSize(size.rows, size.columns, btn.size);				
			}
			var createSizeButton = function(size) {
				var img = document.createElement("div");
				img.size = size;
				img.setAttribute("class", "wallSizeButtons " + size);
				img.addEventListener('click', sizeClicked, false);	
				wallSizeButtons.appendChild(img);	
				return img;
			}
			wallSizeButtons.small = createSizeButton("small");
			wallSizeButtons.medium = createSizeButton("medium");
			wallSizeButtons.large = createSizeButton("large");
			wallSizeButtons.last = wallSizeButtons.small;

			if ( wallSize.size!="") {
                wallSizeButtons[wallSize.size].setAttribute("class", "wallSizeButtonsSelected " + wallSize.size);
				wallSizeButtons.last = wallSizeButtons[wallSize.size]
			} else {
			    wallSizeButtons.medium.setAttribute("class", "wallSizeButtonsSelected medium");
				wallSizeButtons.last = wallSizeButtons.medium;
			}


		    var themeIcon = document.createElement("div");
			themeIcon.setAttribute("id", "wallThemeIcon");
			themeIcon.setAttribute("class", "themeIcon");
			themeIcon.style.display='none';
			editBarBG.appendChild(themeIcon);

			themeIcon.addEventListener('click', function(e) {		
				e.preventDefault();
				e.stopPropagation();	
				if (foxTabWin.isThemeOpen==null) {
					foxTabWin.isThemeOpen = true;
				} else {
					foxTabWin.isThemeOpen = !foxTabWin.isThemeOpen;
				}
				foxTabWin.foxTabFlash.execute("","openThemeSelection")
			}, false);
			
			var lastSelected;
			var createLink = function(name, class) {
				var lnk = document.createElement("div");
				lnk.setAttribute("id", "search-link");
				lnk.setAttribute("class", class);
				lnk.textContent = name;
				lnk.addEventListener('click', function(e) {		
					e.currentTarget.setAttribute("class", "selected");
					lastSelected.setAttribute("class", "");
					lastSelected = lnk;
				}, false);
				if (class=="selected") lastSelected = lnk
				return lnk;
			}
			if (foxTabWin.wo.pref.showNTHomePageLink) {
				if (document.getElementById("newtab-homepage-link")) {
					document.getElementById("newtab-homepage-link").style.display = 'block';
					document.getElementById("newtab-homepage-remove").style.display = 'block';
				} else {
					var homepageLink = document.createElement("div");
					homepageLink.setAttribute("id", "newtab-homepage-link");
					homepageLink.textContent = "Make this page my homepage";
					document.getElementById("foxTab_main_flash_div").appendChild(homepageLink);
					var homepageRemove = document.createElement("div");
					homepageRemove.setAttribute("id", "newtab-homepage-remove");
					homepageRemove.textContent = "[remove]";
					document.getElementById("foxTab_main_flash_div").appendChild(homepageRemove);
					homepageLink.addEventListener('click', function(e) {
						document.getElementById("newtab-homepage-link").style.display = 'none';
						document.getElementById("newtab-homepage-remove").style.display = 'none';
						foxTabWin.setPref("foxTab.general.showNTHomePageLink", "showNTHomePageLink", false);
						foxTabWin.setPref("browser.startup.homepage", null, "chrome://foxtab/content/homepage.html", true);
					    foxTabWin.wo.callURL("h=1");
					}, false);
					homepageRemove.addEventListener('click', function(e) {
						document.getElementById("newtab-homepage-link").style.display = 'none';
						document.getElementById("newtab-homepage-remove").style.display = 'none';
						foxTabWin.setPref("foxTab.general.showNTHomePageLink", "showNTHomePageLink", false);
						foxTabWin.wo.callURL("h=0");
					}, false);
				}
			}

			if (foxTabWin.wo.pref.enableSearch) {

				var searchBox = document.getElementById("search-box");
				searchBox.style.display = "block"
				var searchButton = document.getElementById("searchButton");
				var searchBoxText = document.getElementById("searchBoxText");
				
				if (searchButton.listenerRegistered==null) {
					var as = new FoxTab_AutoSuggest(document.getElementById("searchBoxText"));
					searchButton.listenerRegistered = true;
					searchButton.addEventListener('click', function(e) {	
						 var b = foxTabWin.wo.gBrowser;
						 var url = "http://search.foxtab.com/?q=" + searchBoxText.value + "&s=2&chnl=fxmoz"
						 b.selectedBrowser.loadURI(url);
						 searchBoxText.value = "";
						// b.selectedTab = b.addTab(url)
					}, false);
					searchBoxText.addEventListener('keyup', function(e) {	
						 if (e.keyCode==13) {
							 var b = foxTabWin.wo.gBrowser;
							 var url = "http://search.foxtab.com/?q=" + searchBoxText.value + "&s=2&chnl=fxmoz"
							 b.selectedBrowser.loadURI(url);
							 searchBoxText.value = "";
						 }
						// b.selectedTab = b.addTab(url)
					}, false);
				}

								

			} else {
				var searchBox = document.getElementById("search-box");
			    searchBox.style.display = "none"
			}
		}

		var searchBox = document.getElementById("search-box");
		searchBox.style.marginLeft = ((foxTabWin.wo.windowBoxObject.width/2) - (350/2)) +"px"

		if (document.mouseMoveInitialized==null) {
			document.mouseMoveInitialized = true;
			document.addEventListener('mousemove', foxTabWin.wallMouseMove, false);
			document.addEventListener('mousedown', foxTabWin.wallMouseDown, false);
		}

	},
	setPref : function (prefStr, pref, value, isChar) {
			var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			if (isChar) {
				ffPreferences.setCharPref(prefStr, value);
			} else {
				ffPreferences.setBoolPref(prefStr, value);
			}
			if (pref) {
				var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
				for (var i=0;i<foxTabList.length;i++) {
				  foxTabList[i].pref[pref] = value;
				}
			}
	},
	saveWallImage : function (tileNumber, _pngBinary) {
		 var dir = foxTabWin.wo.getTopSitesDir();
		 try {
			 var __pngBinary = new Array(_pngBinary.length);
			 for (var i=0;i<_pngBinary.length;i++) {
				__pngBinary[i] = String.fromCharCode(_pngBinary[i]);
			 }
			 var pngBinary = __pngBinary.join("");
			var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

			aFile.initWithPath(dir);
			aFile.append("wall")
			aFile.append("wall"+ tileNumber +".png")
					
			var stream = Components.classes["@mozilla.org/network/file-output-stream;1"].
								   createInstance(Components.interfaces.nsIFileOutputStream);
			stream.init(aFile, 0x04 | 0x08 | 0x20, 0600, 0); // write, create, truncate
						
			stream.write(pngBinary, pngBinary.length);
			if (stream instanceof Components.interfaces.nsISafeOutputStream) {
				stream.finish();
			} else {
				stream.close();
			}
				
		} catch(e) {}
	},
	/*
	 *
	 */
	setFlashImages : function(forceCallBack) {
		   var f = foxTabWin
		   f.flashCallBack = 0;
		   var params = f.wo.getTabs();
		   if (f.wo.loadOnFirefoxStart) {
				a = f.foxTabFlash.execute("","initImages",params.args)
			} else {
			    f.foxTabFlash.setArgs(params.args)
		   }
		   f.selectedIndex = params.selectedIndex
		   f.numTabs		 = params.numTabs

		   if (forceCallBack!=false) f.wo.startCheckCallBack()
	},
	/*
	 *
	 */
	checkCallBack : function() {
		if (foxTabWin.flashCallBack==0) {
			 document.getElementById("winBox").style.visibility = ""
			 foxTabWin.setFlashImages()

		}
	},
	onCallBack : function() {
		var f = foxTabWin
		var font = document.getElementById("foxTab_siteTitle")
		font.innerHTML = "";
		f.flashCallBack = 1
		var width  = f.wo.windowBoxObject.width
		var height = f.wo.windowBoxObject.height

		f.foxTabFlash.object.style.width  = width +"px"
		f.foxTabFlash.object.style.height = height +"px"

		f.startWindowPositionInterval();
	    var textbox = document.getElementById("foxTab_filter_textbox")
	    textbox.value = ""

		foxTabWin.isFullScreen = false
		if ((f.wo.PAGES_MODE==f.wo.MODE_TOP_SITES) || 
			(f.wo.PAGES_MODE==f.wo.MODE_RECENTLY_CLOSED)) {
				if (foxTabWin.isGroupPanelOpen) {
					foxTabWin.closeGroupPanel();
				}
		}
		if ((f.wo.pref.interactive_size=="small") || (foxTabWin.wo.launchMode==foxTabWin.wo.LAUNCH_MODE_QUICK)) { 
			f.isGroupPanelOpen = false
			f.isFilterTextBoxOpen = false;
		  } else {
			
			switch (f.wo.pref.groupOpen-0) {
				case 0:
						f.isGroupPanelOpen = false
				break;
				case 1:
						f.setGroupPanel();
						f.openGroupPanel(false);
				break;
				case 2:
					if (f.isGroupPanelOpen) {		
						f.setGroupPanel();
						f.openGroupPanel(false);
					}
				break;
			}

			if (f.wo.pref.filterOpen-0==0) f.isFilterTextBoxOpen = false;
		}

		f.wo.onCallBack();

		try {
			if (!f.isFlash10) {
				var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
				displayOldVerMessage  = ffPreferences.getBoolPref("foxTab.general.displayOldVerMessage");
				if (displayOldVerMessage) {
					f.openOldVersionMessage();
				}
			}
		} catch (e) {}
	},
	/*
	 *
	 */
	checkWindowPosition : function() {
		
		if (foxTabWin.wo.canvasType==foxTabWin.wo.CANVAS_WIN) {
			if ((foxTabWin.lastWindowX!=foxTabWin.wp.screenX) || (foxTabWin.lastWindowY!=foxTabWin.wp.screenY)) {
				foxTabWin.lastWindowX = foxTabWin.wp.screenX
				foxTabWin.lastWindowY = foxTabWin.wp.screenY
				foxTabWin.wo.onResize();
			}		
		} else {
			if ((foxTabWin.lastBrowserWidth!=foxTabWin.tabpanelsBox.width) || (foxTabWin.lastBrowserHeight!=foxTabWin.tabpanelsBox.height)) {
					foxTabWin.lastBrowserWidth  = foxTabWin.tabpanelsBox.width
					foxTabWin.lastBrowserHeight = foxTabWin.tabpanelsBox.height	
					foxTabWin.wo.onResize();
			}		
		}
	},
	/*
	 *
	 */
	startWindowPositionInterval : function() {
		foxTabWin.stopWindowPositionInterval();

		
		if (foxTabWin.wo.canvasType==foxTabWin.wo.CANVAS_WIN) {
			foxTabWin.lastWindowX = foxTabWin.wp.screenX
			foxTabWin.lastWindowY = foxTabWin.wp.screenY
			foxTabWin.windowPositionInterval = setInterval(foxTabWin.checkWindowPosition, 2500);
		} else {
			if ((foxTabWin.wo.launchMode==foxTabWin.wo.LAUNCH_MODE_INTERACTIVE) && (foxTabWin.wo.pref.interactive_size=="fitToBrowser")) {
				try {
					foxTabWin.tabpanelsBox = foxTabWin.wo.gBrowser.mTabBox.tabpanels.boxObject
					foxTabWin.lastBrowserWidth  = foxTabWin.tabpanelsBox.width
					foxTabWin.lastBrowserHeight = foxTabWin.tabpanelsBox.height
					foxTabWin.windowPositionInterval = setInterval(foxTabWin.checkWindowPosition, 1500);
				} catch (e) {}
			}
		}
	},
	/*
	 *
	 */
	stopWindowPositionInterval : function() {
		if (foxTabWin.windowPositionInterval!=null) {
			clearInterval(foxTabWin.windowPositionInterval);
			foxTabWin.windowPositionInterval = null;
		}
	},
	/*
	 *
	 */
	onResize : function() { 

		var f = foxTabWin

		var width  = foxTabWin.wp.document.width
		var height = 20
		var width  = f.wo.windowBoxObject.width
		var height = f.wo.windowBoxObject.height

		if (f.wo.windowBoxObject.left<0) f.wo.windowBoxObject.left = 0;
	  	if (foxTabWin.wo.OS!=foxTabWin.wo.LINUX) {
			document.getElementById("main_div").style.width  = width +"px"
			document.getElementById("main_div").style.height = height +"px"

			document.getElementById("foxTab_main_flash_div").style.width = width +"px"
			document.getElementById("foxTab_main_flash_div").style.height = height +"px"
		} else {
			document.getElementById("foxTab_div_text").style.width = width +"px"
		}

		if (f.wo.isFlashOpen) {
			f.foxTabFlash.object.style.width  = width +"px"
			f.foxTabFlash.object.style.height = height +"px"

			if (width<400) {
				if (foxTabWin.isGroupPanelOpen) {		
					foxTabWin.closeGroupPanel();
				}				
			}
		    if (foxTabWin.isGroupPanelOpen) {
			   var rowHeight = 30;
			   var totalHeight = (rowHeight * foxTabWin.groupList.length) + 50 + 2 + foxTabWin.groupList.length-1
			   if (totalHeight>height - 105 ) {
					foxTabWin.setGroupPanel();
					foxTabWin.openGroupPanel(false);
			   } else {
					if (foxTabWin.groupParams!=null) {
						foxTabWin.setGroupPanel();
						foxTabWin.openGroupPanel(false);
					}
			   }
		    }

			if (foxTabWin.wo.PAGES_MODE==foxTabWin.wo.MODE_NEW_TAB) {
				foxTabWin.openStaticWall()
			}
		}
	},
	resizeTimeOut  : function(newSize) { 
		setTimeout(foxTabWin.wo.resize, 250, newSize);	
	},	
	/*
	 *
	 */
	getTooltipString  : function() { 
		var tooltipStr = ""
		try {
			var strbundle = document.getElementById("foxTab_stringbundle");
			var tooltip_list = new Array();
			tooltip_list.push(strbundle.getString("hint_Carousel"));
			tooltip_list.push(strbundle.getString("hint_Row"));
			tooltip_list.push(strbundle.getString("hint_Grid"));
			tooltip_list.push(strbundle.getString("hint_Stack"));
			tooltip_list.push(strbundle.getString("hint_PageFlow"));
			tooltip_list.push(strbundle.getString("hint_Wall"));
			tooltip_list.push(strbundle.getString("hint_Close"));
			tooltip_list.push(strbundle.getString("hint_ThemeSelection"));
			tooltip_list.push(strbundle.getString("hint_Controller"));
			tooltip_list.push(strbundle.getString("hint_FullScreen"));
			tooltip_list.push(strbundle.getString("hint_Find"));
			tooltip_list.push(strbundle.getString("hint_Options"));
			tooltip_list.push(strbundle.getString("hint_Grouping"));
			tooltip_list.push(strbundle.getString("hint_NumberOfTabs"));
			tooltip_list.push(strbundle.getString("hint_share"));
			tooltipStr = tooltip_list.join("~");
		} catch (e) {}
		return tooltipStr;
	},	
	/*
	 *
	 */
	releaseFlash : function() { 
		var foxTab     = foxTabWin.wo;
		var isOpen     = foxTab.isFlashOpen;
		var launchMode = foxTab.launchMode;

		if (isOpen) foxTab.closeFoxTab();
		var pos = foxTab.getInitialWinPosition();
		foxTab.moveFrame(-10, pos.top);
		document.getElementById("main_div").innerHTML = "";
	},
	/*
	 * 
	 */
 	openOldVersionMessage : function() {
		var winWidth  = foxTabWin.wo.windowBoxObject.width
	    var winHeight = foxTabWin.wo.windowBoxObject.height

		var posX = winWidth/2 - 550/2;
		var posY = winHeight/2 - 350/2 - 50;

		var div_info_panel = document.getElementById("foxTab_div_info_panel");

		div_info_panel.style.left = posX + "px";
		div_info_panel.style.top  = posY + "px";


		var strbundle = document.getElementById("foxTab_stringbundle");
		var msg_title = strbundle.getString("old_flash_msg_title")

		var innerHTML = "<html:iframe src='chrome://foxtab/content/flashVersionMessage.html' width='550' height='350' frameborder='0' scrolling='no' style='border:1px solid #454545'/>"

		if (div_info_panel.innerHTML=="") {
			div_info_panel.innerHTML = innerHTML
		}
		
	},
	removeOldVersionMessage : function() {
		var div_info_panel = document.getElementById("foxTab_div_info_panel");
		div_info_panel.innerHTML = ""
		div_info_panel.style.left = "-1px";
		var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		ffPreferences.setBoolPref("foxTab.general.displayOldVerMessage", false);
	},
	/*
	 *
	 */
	detectFlashVersion : function() { 
		  var f = foxTabWin;
		  var foxTab = f.wo;

		  //////////////////////////////////////////////////
		  // detect flash player version
		  var requiredMajorVersion = 9;
		  var requiredMinorVersion = 0;
		  var requiredRevision = 0;
		  var version = AC_DetectFlashVer(requiredMajorVersion, requiredMinorVersion, requiredRevision);

		  var hasReqestedVersion = version.hasReqestedVersion;


		  if ((hasReqestedVersion==null) && (hasReqestedVersion!=true) && (hasReqestedVersion!=false)) hasReqestedVersion = true;
		  foxTab.isFlashPlayerInstalled = hasReqestedVersion
		  //////////////////////////////////////////////////

		  if ((foxTab.pref.flashVer=="9") || (foxTab.pref.flashVer=="10")) foxTab.isFlashPlayerInstalled = true;

		  f.isFlash10 = false;

		  if (foxTab.pref.flashVer=="9") {
				f.isFlash10 = false;
		  } else if (foxTab.pref.flashVer=="10") {
				f.isFlash10 = true;
		  } else if (version.versionMajor-0>=10) {
				f.isFlash10 = true;
		  }

		  if (foxTab.DEBUG_MODE) foxTab.mainLogger.debug("detectFlashVersion: isFlashPlayerInstalled = " + foxTab.isFlashPlayerInstalled +", isFlash10 = " + f.isFlash10);

	},

	/*
	 *
	 */
	writeFlash : function() { 
		  var f = foxTabWin;
		  var foxTab = f.wo;
		  if ((!foxTab.isFlashPlayerInstalled) || (!f.isFlash10)) {
			  document.getElementById("main_div").innerHTML = "<html:div id='foxTab_main_flash_div' style='width:100%;height:100%;text-align:center;'><html:table align='center' width='682' height='594' background='chrome://foxtab/skin/images/flashplayerMessage.jpg'><html:tr><html:td width='261' valign='top' align='left' style='padding-left:71px;padding-top:477px;color:#ffffff'><html:div style='width:290px;height:88px;cursor:pointer;' onclick='foxTabWin.wo.openAdobeFlashPlayerSite();'></html:div></html:td><html:td valign='top' align='left' style='padding-left:204px;padding-top:5px;color:#ffffff'><html:div style='width:22px;height:22px;cursor:pointer;' onclick='foxTabWin.wo.closeFoxTab();'></html:div></html:td></html:tr></html:table></html:div>" 
			  document.getElementById("winBox").style.visibility=""
		  } else {

			  if (foxTab.DEBUG_MODE) foxTab.mainLogger.debug("writeFlash");

			  var width  = f.wo.windowBoxObject.width
			  var height = f.wo.windowBoxObject.height
			  if (height==0) height = 25;

			  if (f.isFlash10) {
				 var flashName = "foxTab_flash10.swf?"
			  }
			  var flashCache = "v1_4_1"
			  flashName += flashCache
			  f.foxTabFlash.init("foxTabFlash", width, height, flashName, "1A1A1A", true, f.isFlash10)
			  try {
				 var foxtab_dir = foxTab.FOXTAB_DIR;
				 foxtab_dir = foxtab_dir.replace(/&/g ,"%26");

				 var tooltips = f.getTooltipString();

				 switch (foxTab.pref.lastPagesMode) {
					case foxTab.MODE_TOP_SITES:
						var theme = foxTab.pref.themeTS;
					break;
					case foxTab.MODE_RECENTLY_CLOSED:
						var theme = foxTab.pref.themeRC
					break;
					default:
						var theme = foxTab.pref.theme
				}
			    if (foxTab.DEBUG_MODE) foxTab.mainLogger.debug("args=" + foxtab_dir + "^" + 
																	   foxTab.pref.isFirstLaunch + "^" + 
																	   theme + "^" + 
																	   foxTab.pref.customColors + "^" + 
																	   foxTab.pref.useTheme + "^" +
																	   foxTab.pref.displayBgImage + "^" +
																	   tooltips);

				f.foxTabFlash.setArgs("args=" + foxtab_dir + "^" + 
											     foxTab.pref.isFirstLaunch + "^" + 
											     theme + "^" + 
												 foxTab.pref.customColors + "^" + 
											     foxTab.pref.useTheme + "^" +
												 foxTab.pref.displayBgImage + "^" +
												 tooltips);
			  } catch (e) {}
			  if (!foxTab.loadOnFirefoxStart) {
				  f.setFlashImages();
				  document.getElementById("winBox").style.visibility = ""
			  }
			  f.foxTabFlash.write(document.getElementById("main_div"))
			  f.onResize()
			  foxTab_eventManager.add("foxTabFlash",f.onFlashMouseDown,"mousedown")
			  foxTab_eventManager.add("foxTabFlash",f.onMouseWheel,"mousewheelevent")
			  foxTab_eventManager.add("foxTabFlash",f.onCommand,"command")
			  foxTab_eventManager.add("foxTabFlash",f.onTabSelected,"tabSelected")
			  foxTab_eventManager.add("foxTabFlash",f.onImageCorrupted,"imageCorrupted")
			  
			  foxTab_eventManager.add("foxTabFlash",f.onCallBack,"callBack")

			  document.getElementById("foxTab_div_groups_panel").addEventListener('DOMMouseScroll',f.onGroupPanelScroll, false);


			  f.wo.onFlashLoaded();
		  }
	},
	/*
	 *
	 */
	onLoad : function() { 
		  var f = foxTabWin
		  if (f.wp.foxTab.DEBUG_MODE) f.wp.foxTab.mainLogger.debug("windowLoaded");
		  foxTabWin.wp.foxTab.foxTabWin = foxTabWin
		  f.detectFlashVersion();
		  f.writeFlash();
	},
	/*
	 *
	 */
	closeFoxTab : function() { 
		 foxTabWin.wp.focus();
		 foxTabWin.wo.closeFoxTab();
	},
	/*
	 *
	 */
	onFoxTabClosed : function() { 
		var font = document.getElementById("foxTab_siteTitle")
		if (font!=null) font.innerHTML = ""
		foxTabWin.stopWindowPositionInterval();
	    try {
		  var textbox = document.getElementById("foxTab_filter_textbox")
		  textbox.style.display = 'none'
	      if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
		  	 var bg_iframe = document.getElementById("foxTab_iframe_filter_text")
		  	 bg_iframe.style.display = 'none'
	 	  }

		  div = document.getElementById("foxTab_div_groups_panel")
		  div.style.display='none'
	    } catch (e) {
		}
	},

	/*
	 *
	 */
	flashBlockEvent : function(e) { 
		e.preventDefault();
		e.stopPropagation();
	}
}


function foxTabFlash_DoFSCommand(id_evt, args) {
	  var splitId_Evt = id_evt.split("^")
	  objectId = splitId_Evt[0]
	  evt = splitId_Evt[1]
	  var i;
		
	  foxTab_eventManager.executeEvent(objectId,evt,args)
}

foxTabWin.init();

function FoxTab_AutoSuggest(textBox) {
	var t = this;
	var interval = null;
	var lastValue = "";

	t.asDiv = null;
	var selectedRow = -1;
	var resultsLength = 0;
	t.init = function() {
		textBox.addEventListener("keydown" ,t.keyDown, false);
		textBox.addEventListener("keyup" ,t.keyUp, false);
		textBox.addEventListener("blur" ,t.documentMouseDown, false);
	},
	t.trim = function(str) {
		return str.replace(/^\s+|\s+$/g,"");
	},
	t.getData = function(val) {
		var URL = "http://google.com/complete/search?output=toolbar&q=" + val;

		var xmlHttpRequest;
		xmlHttpRequest = new XMLHttpRequest();
		xmlHttpRequest.open("GET", URL, true);
		xmlHttpRequest.onreadystatechange =  function () {
		
			if (xmlHttpRequest.readyState==4) {
				if (xmlHttpRequest.status==200) {
					
					var response;

					if (lastValue==val) {
						if (t.asDiv!=null) {
							document.getElementById("foxTab_main_flash_div").removeChild(t.asDiv); 
							t.asDiv = null;
						}
						if (t.asDiv==null) {
							t.asDiv = document.createElement("div");
							document.getElementById("foxTab_main_flash_div").appendChild(t.asDiv); 
							t.asDiv.style.display='none';
						}
					
						t.asDiv.setAttribute("class", "auto-suggest");
						t.setASdivPosition();
						t.asDiv.innerHTML = ""

						var xml = xmlHttpRequest.responseXML;
						var completeSuggestion = xml.getElementsByTagName("suggestion");
						resultsLength = completeSuggestion.length;

						for (var i=0;i<resultsLength;i++) {
							var resultVal = completeSuggestion[i].attributes[0].nodeValue;

							var row = document.createElement("div")
							var pos = resultVal.indexOf(val.toLowerCase());
							if (pos!=-1) {
								var t1 = document.createElement("div");
								var t2 = document.createElement("div");
								//val = val.replace(" ","x");
								t1.textContent = resultVal.substr(0, pos + val.length);
								t2.textContent = resultVal.substr(pos + val.length);
								if (t1.textContent.substr(t1.textContent.length-1)==" ") t2.style.paddingLeft = "4px"
								if (t2.textContent.substr(0,1)==" ") t2.style.paddingLeft = "4px"
								t2.style.fontWeight = "bold"
								row.appendChild(t1)
								row.appendChild(t2)
								t1.as = 1;
								t2.as = 1;
							} else {
								row.textContent = resultVal;
							}
						//	row.textContent = resultVal;
								//	row.innerHTML = resultVal.substr(0, pos + val.length) + "<b>" + resultVal.substr(pos + val.length) +"</b>";
						
							row.setAttribute("id", "auto-suggest-row" + i);
							row.setAttribute("class", "auto-suggest-row");
							row.as = 1;
							row.index = i;
							row.isRow = true;
							row.addEventListener("mouseover" , function(e) {
								var row = e.currentTarget;
								if (selectedRow!=-1)  document.getElementById("auto-suggest-row" + selectedRow).setAttribute("class", "auto-suggest-row");
								row.setAttribute("class", "auto-suggest-row selected");
								selectedRow = row.index;
							}, false);
							row.addEventListener("mousedown" , function(e) {
								var row = e.currentTarget;
								textBox.value = row.textContent;
								t.onSearch(row.textContent);
							}, false);

							t.asDiv.appendChild(row); 
						}

						selectedRow = -1;
						if (resultsLength==0) {
							t.asDiv.style.display = 'none';
						} else {
							t.asDiv.style.display = 'block';
						}
					}
				}
			}
		};
		xmlHttpRequest.send("");
	}
	t.keyUp = function(e) {

		var keyCode = e.keyCode;
		if (keyCode != 13) {
		   if ((keyCode!=38) &&  (keyCode!=40) &&  (keyCode!=116)) {
			   if (interval!=null) {
				   window.clearInterval(interval)
				   interval = null;
			   }
			   lastValue = textBox.value;
			   interval = setTimeout(t.getData, 10, textBox.value)
		   } else {

		   }
		} else {
			
		}
	},
	t.keyDown = function(e) {
		  var keyCode = e.keyCode;
		  if (keyCode==13) {
			 if (selectedRow!=-1) {
				textBox.value = document.getElementById("auto-suggest-row" + selectedRow).textContent
			 }
			// t.onSearch(textBox.value);
			 return;
		  }
		  if ((keyCode!=38) && (keyCode!=40)) {
			} else {
			  
			  if (keyCode==38) {
				  if (selectedRow!=-1)  document.getElementById("auto-suggest-row" + selectedRow).setAttribute("class", "auto-suggest-row");
				  selectedRow--
				  if (selectedRow<0) selectedRow = resultsLength-1;
			  } else {
				  if (selectedRow!=-1)  document.getElementById("auto-suggest-row" + selectedRow).setAttribute("class", "auto-suggest-row");
				  selectedRow++
				  if (selectedRow>=resultsLength) selectedRow = 0;
			  }
			  var row = document.getElementById("auto-suggest-row" + selectedRow);
			  row.setAttribute("class", "auto-suggest-row selected");
			  textBox.value = row.textContent;
		  }
	}
	t.documentMouseDown = function(e) {
		if (e.explicitOriginalTarget!=t.asDiv) {
			lastValue = "--";
			if (t.asDiv!=null) {
				t.asDiv.style.display = 'none';
				document.getElementById("container").style.height =  "3px";
			}
		}
	},
	
	t.setASdivPosition = function(){
		var el = textBox;
		var x = 0;
		var y = textBox.offsetHeight - 1;
		while ((el.offsetParent) && (el.tagName.toLowerCase()!='body')) {
			x += el.offsetLeft;
			y += el.offsetTop;
			el = el.offsetParent;
		}
		x += el.offsetLeft - 5;
		y += el.offsetTop + 5;
		if (t.asDiv!=null) {
			t.asDiv.style.left = x + "px";
			t.asDiv.style.top  = y + "px";
		}

	},

	t.onSearch = function(val) {
		lastValue = "--";
		if (t.asDiv!=null) {
			t.asDiv.style.display = 'none';
			var b = foxTabWin.wo.gBrowser;
			var url = "http://search.foxtab.com/?q=" + textBox.value + "&s=2&chnl=fxmoz"
			b.selectedBrowser.loadURI(url);
			textBox.value = "";
		}
	}
	t.init();
}